program animation;
{$N+}
uses graph,crt,dos,joystick,joystrin,wizinfo,maus;
const bgipath='';
      pysscrsizex=24.0;
      pysscrsizey=17.0;
      maxpunkt=2500;
      maxlinie=5000;
      aktpunkt:word=0;
      aktlinie:word=0;
type vct3=record x,y,z:single; end;
     mat4=array[0..3,0..3] of single;
     vct4=record w,x,y,z:single; end;
     punktlistptr=^punktlisttyp;
     punktlisttyp=array[0..maxpunkt] of record
                    p:vct3;
                    x,y:integer;
                  end;
     linielistptr=^linielisttyp;
     linielisttyp=array[0..maxlinie] of record
                    a,e:word;
                    farbe:byte;
                  end;
     pointlistptr=^pointlisttyp;
     pointlisttyp=array[0..maxlinie] of record
                    xa,ya,xe,ye:integer;
                  end;

const VRP:vct3=(x:0;y:0;z:0);
      NRP:vct3=(x:1;y:1;z:1);
      VUP:vct3=(x:0;y:1;z:0);
      XMIN:single=-3;
      YMIN:single=-2;
      XSIZE:single=6;
      VPD:single=6;
      FPD:single=5;
      BPD:single=-5;
      e:mat4=((1.0,0.0,0.0,0.0), (0.0,1.0,0.0,0.0),
              (0.0,0.0,1.0,0.0), (0.0,0.0,0.0,1.0));
      epsilon=1E-7;
      punktl:punktlistptr=nil;
      liniel:linielistptr=nil;
      actpage:pointlistptr=nil;
      inactpage:pointlistptr=nil;
      modus:boolean=true;
var xmaxglobal,ymaxglobal:integer;
    ysize:single;
    lux,luy,rox,roy:single;
    ysubu,ysubo:integer;
    WCNPC,WCDC,NPCDC:mat4;
    pixelhochzubreit:single;
    xwinsize,ywinsize:single;
    xwinofs,ywinofs:integer;
    seite:byte;
    jmaxx,jmaxy,mittex,mittey:integer;
    ein:char;
    eingabe:(eString,eStick,eMaus);

  FUNCTION IITCoPro : Boolean;
  begin
    asm
      WAIT
      FINIT
      WAIT
      FLD  dword Ptr CS:[0000]
      WAIT
      FADD ST,ST(0)
      WAIT
    end;
    inline($DF/$E0);    {ESC  $3C,AX}
    asm
      AND	 AX,0002
      MOV	 AX,0000
      JNZ	 @ende
      MOV	 AX,0001
  @ende:
    end;
  end;

function switch(nr:byte):boolean;
var xpos,ypos,tasten:word;
begin
  if eingabe in [eStick,eString] then switch:=Joystick.Switch(nr) else begin
    MausTastPos(tasten,xpos,ypos);
    switch:=tasten and nr>0;
  end;
end;

procedure error(s:string);
var c:char;
begin
  closegraph;
  if s<>'' then begin
    textcolor(yellow);
    textbackground(blue);
    write(#7,s);
    c:=readkey;
  end else write(#7);
  halt;
end;

function donorm(var v:vct3):boolean;
var norm:single;
begin
  norm:=sqrt(sqr(v.x)+sqr(v.y)+sqr(v.z));
  if abs(norm)<epsilon then donorm:=true else begin
    v.x:=v.x / norm; v.y:=v.y / norm; v.z:=v.z /norm;
    donorm:=false;
  end;
end;

procedure mulmat(a,b:mat4; var c:mat4);
var i:integer;
begin
  for i:=0 to 3 do begin
    c[0,i]:=a[0,0]*b[0,i]+a[0,1]*b[1,i]+a[0,2]*b[2,i]+a[0,3]*b[3,i];
    c[1,i]:=a[1,0]*b[0,i]+a[1,1]*b[1,i]+a[1,2]*b[2,i]+a[1,3]*b[3,i];
    c[2,i]:=a[2,0]*b[0,i]+a[2,1]*b[1,i]+a[2,2]*b[2,i]+a[2,3]*b[3,i];
    c[3,i]:=a[3,0]*b[0,i]+a[3,1]*b[1,i]+a[3,2]*b[2,i]+a[3,3]*b[3,i];
  end;
end;

procedure invmat(a:mat4; var am1:mat4);
var det:single;
    i,j,i1,i2,j1,j2,j3,i3:integer;
    negflag:boolean;
begin
  negflag:=false;
  for i:=0 to 3 do begin
    i1:=(succ(i)) and 3; i2:=(i+2) and 3 ; i3:=(i+3) and 3;
    for j:=0 to 3 do begin
      j1:=(succ(j)) and 3; j2:=(j+2) and 3; j3:=(j+3) and 3;
      am1[j,i]:=a[i1,j1]*(a[i2,j2]*a[i3,j3] - a[i2,j3]*a[i3,j2]) +
                a[i1,j2]*(a[i2,j3]*a[i3,j1] - a[i2,j1]*a[i3,j3]) +
                a[i1,j3]*(a[i2,j1]*a[i3,j2] - a[i2,j2]*a[i3,j1]);
      if negflag then am1[j,i]:=-am1[j,i];
      negflag:=not negflag;
    end;
    negflag:=not negflag;
  end;
  det:=a[0,0]*am1[0,0];
  for i:=1 to 3 do det:=det+a[0,i]*am1[i,0];
  if abs(det)<epsilon then error('Matrix nicht regulr!');
  for i:=0 to 3 do for j:=0 to 3 do am1[i,j]:=am1[i,j]/det;
end;

procedure grafikbegin;
var graphdriver,grapherror,grafmode:integer;
begin
  graphdriver:=ega;grafmode:=egahi;
  initgraph(graphdriver,grafmode,bgipath);
  grapherror:=graphresult;
  if (grapherror<>GrOK) then begin
    clrscr;
    textcolor(red);
    writeln('Grafik Fehler:');
    writeln(GraphErrorMsg(grapherror));
    repeat until keypressed;
    halt(1);
  end;
  xmaxglobal:=getmaxx; ymaxglobal:=getmaxy;
  pixelhochzubreit:=((pysscrsizey/succ(ymaxglobal)) /
                      (pysscrsizex/succ(xmaxglobal)));
end;

procedure SetScreenGlobal(_lux,_luy,_rox,_roy:single);
var scal:single;
    vpn,r:vct3;
begin
  roy:=_roy;rox:=_rox;lux:=_lux;luy:=_luy;
  YSubO:=Round(_roy); YSubU:=Round(_roy-1);
  ySize:=xSize*PixelHochZuBreit*(_luy-_roy)/(_rox-_lux);
  vpn.x:=nrp.x - vrp.x;
  vpn.y:=nrp.y - vrp.y;
  vpn.z:=nrp.z - vrp.z;
  scal:=vup.x*vpn.x+vup.y*vpn.y+vup.z*vpn.z;
  vup.x:=vup.x-scal*vpn.x;
  vup.y:=vup.y-scal*vpn.y;
  vup.z:=vup.z-scal*vpn.z;
  if donorm(vup) then error('calcWCVRC: VUP liegt kollinear zu (VRP,NRP)');
  r.x:=vrp.x-nrp.x;r.y:=vrp.y-nrp.y;r.z:=vrp.z-nrp.z;
  donorm(r);
  vrp.x:=nrp.x+r.x;vrp.y:=nrp.y+r.y;vrp.z:=nrp.z+r.z;
end;

procedure doinit;

  procedure setviewing(VRP,NRP,VUP:vct3;
                       xmin,ymin,xmax,ymax,vpd,fpd,bpd:single);
  var  WCvrc,vrcnpc,npcwc:mat4;

    procedure calcwcvrc(var wcvrc:mat4);
    var vpn: vct3;
      scal: single;
    begin
      wcvrc[0][0]:=1.0;
      wcvrc[0][1]:=vrp.x; wcvrc[0][2]:=vrp.y;  wcvrc[0][3]:=vrp.z;
      vpn.x:=nrp.x - vrp.x;
      vpn.y:=nrp.y - vrp.y;
      vpn.z:=nrp.z - vrp.z;
      WCVRC[3][0]:=0.0; WCVRC[3][1]:=vpn.x;
      WCVRC[3][2]:=vpn.y; WCVRC[3][3]:=vpn.z;
      
      WCVRC[2][0]:=0.0;WCVRC[2][1]:=vup.x;
      WCVRC[2][2]:=vup.y;WCVRC[2][3]:=vup.z;
      WCVRC[1][0]:=0.0;
      wcvrc[1][1]:=vup.y*vpn.z - vup.z*vpn.y;
      wcvrc[1][2]:=vup.z*vpn.x - vup.x*vpn.z;
      wcvrc[1][3]:=vup.x*vpn.y - vup.y*vpn.x;
    end;

    procedure calcVRCNPC(var VRCNPC:mat4);
    var k,l:single;
    begin
      k := (VPD - bpd) / VPD;
      l := (fpd - bpd) / (VPD - fpd);

      VRCNPC[0][0]:=1.0; VRCNPC[0][1]:=k*xMin;
      VRCNPC[0][2]:=k*yMin; VRCNPC[0][3]:=BPD;

      VRCNPC[1][0]:=0.0; VRCNPC[1][1]:=k*(xmax-xMin);
      VRCNPC[1][2]:=0.0; VRCNPC[1][3]:=0.0;

      VRCNPC[2][0]:=0.0; VRCNPC[2][1]:=0.0;
      VRCNPC[2][2]:=k*(ymax-yMin); VRCNPC[2][3]:=0.0;

      VRCNPC[3][0]:=l; VRCNPC[3][1]:=0.0;
      VRCNPC[3][2]:=0.0; VRCNPC[3][3]:=l*VPD;
    end;

  begin
    CalcWCVRC(WCVRC);
    CalcVRCNPC(VRCNPC);
    MulMat(VRCNPC,WCVRC,NPCWC);
    InvMat(NPCWC,WCNPC);
  end;

  procedure SetScreen(lux,luy,rox,roy:single);
  begin
    xwinsize:=rox-lux; xwinofs:=round(lux);
    ywinsize:=roy-luy; ywinofs:=round(luy);
    NPCDC:=E;
    NPCDC[1,1]:=xwinsize;NPCDC[2,2]:=ywinsize;
    NPCDC[3,3]:=maxint;
    NPCDC[0,1]:=xwinofs;NPCDC[0,2]:=ywinofs;
  end;

begin
  YSubU:=round(luy);
  SetViewing(VRP,NRP,VUP,
             xMin,yMin+ySize*(luy-YSubU)/(luy-roy),
             xMin+xSize,yMin+ySize*(luy-YSubO)/(luy-roy),
             VPD,FPD,BPD);
  SetScreen(lux,YSubU,rox,YSubO);
  MulMat(WCNPC,NPCDC,WCDC);
end;

procedure WCtoDc(a:vct3; var x,y{,z}:integer);
var w:single;
begin
  w:=WCDC[0,0]+a.x*WCDC[1,0]+a.y*WCDC[2,0]+a.z*WCDC[3,0];
  if abs(w)<epsilon then error('WCtoDC: Punkt nicht definiert!');
  x:=round((WCDC[0,1]+a.x*WCDC[1,1]+a.y*WCDC[2,1]+a.z*WCDC[3,1])/w);
  y:=round((WCDC[0,2]+a.x*WCDC[1,2]+a.y*WCDC[2,2]+a.z*WCDC[3,2])/w);
 { z:=round((WCDC[0,3]+a.x*WCDC[1,3]+a.y*WCDC[2,3]+a.z*WCDC[3,3])/w);}
end;

procedure linie3d(b,e:vct3);
var x1,y1,x2,y2:integer;
begin
  wctodc(b,x1,y1);
  wctodc(e,x2,y2);
  Line(x1,y1,x2,y2);
end;

procedure laden;
var suche:searchrec;
    name:pathstr;
    datname:namestr;
    dir:dirstr;
    ext:extstr;
    x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4:single;

  procedure lade(name:pathstr);
  const zeile:word=0;
  var hlinie,h2:word;
      f:text;
      befehl,argumente:string;
      fehler:boolean;
      farbe:byte;
      a,b,c,d:word;

    procedure lesezeile;
    begin
      readln(f,befehl);
      while pos(' ',befehl)=1 do delete(befehl,1,1);
      argumente:=befehl;
      argumente:=argumente+' ';
      delete(argumente,1,pos(' ',argumente));
      befehl:=befehl+' ';
      delete(befehl,pos(' ',befehl),length(befehl)-pos(' ',befehl));
      inc(zeile);gotoxy(7,pred(wherey));writeln(zeile);
    end;

    procedure upword(var tex:string);
    var n:byte;
    begin
      for n:=1 to length(tex) do begin
        tex[n]:=upcase(tex[n]);
        case tex[n] of
          '':tex[n]:='';
          '':tex[n]:='';
          '':tex[n]:='';
        end;
      end;
    end;

    function id(s:string):boolean;
    var gleich:boolean;
        n,k:byte;
    begin
      gleich:=true;
      K:=pred(length(befehl));
      if k=0 then k:=1;
      n:=length(s);
      if n<k then k:=n;
      for n:=1 to k do begin
        befehl[n]:=upcase(befehl[n]);
        case befehl[n] of
          '':befehl[n]:='';
          '':befehl[n]:='';
          '':befehl[n]:='';
        end;
        gleich:=gleich and (s[n]=befehl[n]);
      end;
      id:=gleich;
    end;

    function getsingle:single;
    var h:single;
        err:integer;
    begin
      while pos(' ',argumente)=1 do delete(argumente,1,1);
      argumente:=argumente+' ';
      val(copy(argumente,1,pred(pos(' ',argumente))),h,err);
      fehler:=err<>0;
      getsingle:=h;
      delete(argumente,1,pos(' ',argumente));
    end;

    function getbefehlsingle:single;
    var h:single;
        err:integer;
    begin
      while pos(' ',befehl)=1 do delete(befehl,1,1);
      befehl:=befehl+' ';
      val(copy(befehl,1,pred(pos(' ',befehl))),h,err);
      fehler:=err<>0;
      getbefehlsingle:=h;
    end;

    procedure punkteintrag(xn,yn,zn:single);
    var hpunkt:punktlistptr;
    begin
      with punktl^[aktpunkt].p do begin
        x:=xn; y:=yn; z:=zn
      end;
      inc(aktpunkt);
      fehler:=(aktpunkt>maxpunkt+1) or fehler;
    end;

    procedure linieeintrag(an,en:word;farben:byte);
    var hlinie:word;
    begin
      hlinie:=0;
      while hlinie<aktlinie do begin
        with liniel^[hlinie] do
{        if ((punktl^[a].p.x=punktl^[an].p.x) and (punktl^[a].p.y=punktl^[an].p.y)
        and (punktl^[a].p.z=punktl^[an].p.z) and (punktl^[e].p.x=punktl^[en].p.x)
        and (punktl^[e].p.y=punktl^[en].p.y) and (punktl^[e].p.z=punktl^[en].p.z))
        or ((punktl^[a].p.x=punktl^[en].p.x) and (punktl^[a].p.y=punktl^[en].p.y)
        and (punktl^[a].p.z=punktl^[en].p.z) and (punktl^[e].p.x=punktl^[an].p.x)
        and (punktl^[e].p.y=punktl^[an].p.y) and (punktl^[e].p.z=punktl^[an].p.z) )}
        if ((a=an) and (e=en) )
        or ((a=en) and (e=an) )
         then exit;
        inc(hlinie);
      end;
      with liniel^[aktlinie] do begin a:=an; e:=en;if farben<>0 then farbe:=farben else farbe:=15; end;
      inc(aktlinie);fehler:=(aktlinie>maxlinie+1) or fehler;
    end;

    procedure argtobef;
    begin
      while pos(' ',argumente)=1 do delete(argumente,1,1);
      argumente:=argumente+' ';
      befehl:=copy(argumente,1,pred(pos(' ',argumente)));
      delete(argumente,1,pos(' ',argumente));
    end;

    function rgbtofarbe(r,g,b:single):byte;
    begin
      rgbtofarbe:=byte(b>0.5) or (byte(g>0.5) shl 1) or (byte(r>0.5) shl 2) or (byte(r+g+b>1.5) shl 3);
    end;

  begin
    farbe:=white;
    assign(f,name+'.SCN');
    reset(f);
    fehler:=false;
    while name[1]=' ' do delete(name,1,1);
    if pos(' ',name)<>0 then name:=copy(name,1,pos(' ',name));
    upword(name);
    name:=':'+name;
    writeln('Zeile 0');
    lesezeile;
    while not (id('A:') or eof(f)) do begin
      punkteintrag(getbefehlsingle,getsingle,getsingle);
      lesezeile;
    end;
    argtobef;
    if eof(f) then fehler:=true;
    while not (eof(f) or id('H:')) do begin
      a:=trunc(getbefehlsingle);b:=trunc(getsingle);
      c:=trunc(getsingle);d:=trunc(getsingle);
      farbe:=rgbtofarbe(getsingle,getsingle,getsingle);
      linieeintrag(a,b,farbe);linieeintrag(b,c,farbe);
      linieeintrag(c,d,farbe);linieeintrag(d,a,farbe);
      lesezeile;
    end;
    close(f);
    if fehler then error('Fehler beim Interpretieren der Datei '+name+'.SCN')
    else begin {Punkte, die auf Ende von Linie fallen lschen}
      hlinie:=0;
      while hlinie<aktlinie do begin
        if liniel^[hlinie].a=liniel^[hlinie].e then begin
          h2:=0;
          while (h2<aktlinie) do begin
            if (h2<>hlinie) and
               ((liniel^[h2].a=liniel^[hlinie].a) or (liniel^[h2].e=liniel^[hlinie].a)) then begin
              liniel^[hlinie]:=liniel^[pred(aktlinie)];
              dec(aktlinie);
              if liniel^[hlinie].a=liniel^[hlinie].e then h2:=0 else h2:=aktlinie;
            end else inc(h2);
          end;
        end;
        inc(hlinie);
      end;
    end;
    writeln(aktlinie,' Linien');
    writeln(aktpunkt,' Punkte');
  end;

begin
  if paramcount<>0 then name:=paramstr(1)
  else if getinfo<>'' then begin
    fsplit(getinfo,dir,datname,ext);
    name:=dir+datname;
  end else begin
    suche.name:='*.SCN';
    findfirst('*.SCN',$3f,suche);
    if (Doserror<>0) then error('keine Bilder');
    while (doserror=0) do begin
      write(suche.name:20);
      findnext(suche);
    end;
    writeln;
    write('Geben Sie den Bilddateinamen ein (ohne Extension) : ');
    readln(name);
  end;
  findfirst(name+'.SCN',$3f,suche);
  if doserror<>0 then error(name+'.SCN nicht gefunden !');
  lade(name);
end;

  procedure transformpunkte{intel}(var t:mat4;var punktl:punktlisttyp;last:word);{far;}
  var hpunkt:word;
  begin
    for hpunkt:=0 to pred(aktpunkt) do with punktl[hpunkt] do begin
      wctodc(p,x,y);
    end;
  end;

  procedure transformpunkteiit(var t:mat4;var punktl:punktlisttyp;last:word);far;
  VAR CW87:WORD;
  label nochmal;
  BEGIN
    asm
      FSTCW CW87
      LES SI,t
      FINIT
    END;
    INLINE($DB/$EA); {FSBP2}
    ASM
      FLD DWORD PTR es:[si+20]  {WCDC[1,1]}
      FLD DWORD PTR es:[si+24]  {WCDC[1,2]}
      FLD DWORD PTR es:[si+28]  {WCDC[1,3]}
      FLD DWORD PTR es:[si+16]  {WCDC[1,0]}

      FLD DWORD PTR es:[si+36]  {WCDC[2,1]}
      FLD DWORD PTR es:[si+40]  {WCDC[2,2]}
      FLD DWORD PTR es:[si+44]  {WCDC[2,3]}
      FLD DWORD PTR es:[si+32]  {WCDC[2,0]}
      finit
    END;
    INLINE($DB/$Eb); {FSBP1}
    ASM
      FLD DWORD PTR es:[si+52]  {WCDC[3,1]}
      FLD DWORD PTR es:[si+56]  {WCDC[3,2]}
      FLD DWORD PTR es:[si+60]  {WCDC[3,3]}
      FLD DWORD PTR es:[si+48]  {WCDC[3,0]}

      FLD DWORD PTR es:[si+04]  {WCDC[0,1]}
      FLD DWORD PTR es:[si+08]  {WCDC[0,2]}
      FLD DWORD PTR es:[si+12]  {WCDC[0,3]}
      FLD DWORD PTR es:[si+00]  {WCDC[0,0]}

      xor ax,ax
      mov dx,last
      les si,punktl

      mov bx,ax
      shl bx,4
      finit
    END;
    INLINE($DB/$E8); {FSBP0}
    ASM
nochmal:fld1
      fld dword ptr es:[si+bx]
      fld dword ptr es:[si+bx+4]
      fld dword ptr es:[si+bx+8]
    END;
    INLINE($DB/$F1); {F4x4}
    ASM
      inc ax
      mov cx,ax
      shl cx,4
      fdiv st,st(3)
      fistp word ptr es:[si+bx+12]
      fdiv st,st(2)
      fistp word ptr es:[si+bx+14]
      finit
      mov bx,cx
      cmp ax,dx
      jle nochmal
      fldcw cw87
    END;
  end;


  procedure animiere;
  var hlinie:word;
      h:pointlistptr;
      dx,dy:single;
{      transformpunkte:procedure(var t:mat4;var punktl:punktlisttyp;last:word);}
      Ursprung:array[0..2] of integer;
  const ein:char='!';
        modus:byte=2;
        JoyGedruckt:boolean=false;
        

    procedure holeeingabe;
    var xpos,ypos,tasten:word;
    begin
      if eingabe=estick then begin
        dx:=(paddle(0)-mittex)/jmaxx;
        dy:=(mittey-paddle(1))/jmaxy;
        if switch(1) then begin
          inc(modus);
          if modus=3 then modus:=0;
        end;
        repeat until not switch(1);
      end else begin
        MausTastPos(tasten,xpos,ypos);
        dx:=(xpos-mittex)/jmaxx;
        dy:=(mittey-ypos)/jmaxy;
        if tasten and 1>0 then begin
          inc(modus);
          if modus=3 then modus:=0;
        end;
        repeat until not switch(1);
      end;
    end;

    procedure bewegeauge;
    var scal:single;
        h,r:vct3;

      procedure drehen(a,b:vct3;al:single;var h:vct3);
      var d,e,c,p,q,w:single;
      begin
        w:=cos(al);
        d:=sqr((a.z*b.y-a.y*b.z)/(a.x*b.y-a.y*b.x))+
           sqr((a.z*b.x-a.x*b.z)/(a.y*b.x-a.x*b.y))+1;
        e:=-2*w*((b.y*(a.z*b.y-a.y*b.z))/((a.x*b.y-a.y*b.x)*(a.x*b.y-a.y*b.x))+
         (b.x*(a.z*b.x-a.x*b.z))/((a.y*b.x-a.x*b.y)*(a.y*b.x-a.x*b.y)));
        c:=sqr(w*b.y/(a.x*b.y-a.y*b.x))+sqr(w*b.x/(a.y*b.x-a.x*b.y))-1;
        p:=e/d;
        q:=c/d;
        if al>0 then h.z:=-p/2+sqrt(abs(P*P/4-q)) else h.z:=-p/2-sqrt(abs(P*P/4-q));
        h.y:=(w*b.x-h.z*(a.z*b.x-a.x*b.z))/(a.y*b.x-a.x*b.y);
    {    h.x:=(-b.z*h.z-b.y*h.y)/b.x;}
        h.x:=sqrt(abs(1-h.y*h.y-h.z*h.z));
      end;

    begin
      holeeingabe;
      if switch(0) then begin
        if abs(dx)>0.1 then begin
          r.x:=vrp.x-nrp.x;r.y:=vrp.y-nrp.y;r.z:=vrp.z-nrp.z;
          drehen(vup,r,0.5*dx,vup);
        end;
        if abs(dy)>0.1 then begin
          h.x:=vrp.x-nrp.x;h.y:=vrp.y-nrp.y;h.z:=vrp.z-nrp.z;
          r.x:=h.y*vup.z-h.z*vup.y;
          r.y:=h.z*vup.x-h.x*vup.z;
          r.z:=h.x*vup.y-h.y*vup.x;
          donorm(r);
          drehen(vup,r,0.1*dy,vup);
          drehen(h,r,0.1*dy,h);
          vrp.x:=nrp.x+h.x;vrp.y:=nrp.y+h.y;vrp.z:=nrp.z+h.z;
        end;
      end else begin
        r.x:=vrp.x-nrp.x;r.y:=vrp.y-nrp.y;r.z:=vrp.z-nrp.z;
        donorm(r);
        if abs(dx)>0.1 then begin
          drehen(r,vup,0.1*dx,r);
          vrp.x:=nrp.x+r.x;vrp.y:=nrp.y+r.y;vrp.z:=nrp.z+r.z;
        end;
        if abs(dy)>0.02 then begin
          r.x:=r.x*dy*5;r.y:=r.y*dy*5;r.z:=r.z*dy*5;
          vrp.x:=vrp.x+r.x;vrp.y:=vrp.y+r.y;vrp.z:=vrp.z+r.z;
          nrp.x:=nrp.x+r.x;nrp.y:=nrp.y+r.y;nrp.z:=nrp.z+r.z;
        end;
      end;
    end;

    procedure Rotate(achse:integer;w:real);
    var s,c:real;
        M:mat4;
    begin
      M:=E;
      w:=w*pi/180.0;
      s:=sin(w); c:=cos(w);
      case achse of
        1: begin M[2][2]:=c; M[2][3]:=s; M[3][2]:=-s; M[3][3]:=c; end;
        2: begin M[1][1]:=c; M[1][3]:=-s; M[3][1]:=s; M[3][3]:=c; end;
        3: begin M[1][1]:=c; M[1][2]:=s; M[2][1]:=-s; M[2][2]:=c; end;
      end;
      MulMat(M,WCDC,WCDC);
    end;


    procedure bewegekorper;
    var scal:single;
        h,r:vct3;
    begin
      holeeingabe;
      if switch(0) then begin
        rotate(3,dy*10);
        rotate(2,dx*10);
      end else begin
        rotate(1,dy*10);
        rotate(2,dx*10);
      end;
    end;


    procedure bewegejoystring;
    var x,y,z:byte;
        x1,y1,z1:integer;

      procedure translate(xv,yv,zv:real);
      var M:mat4;
      begin
        M:=E;
        M[0][1]:=xv; M[0][2]:=yv; M[0][3]:=zv;
        MulMat(M,WCDC,WCDC);
      end;

    begin
      if buttonpressed then begin
        joystringpos(x,y,z);
        if not joygedruckt then begin
          ursprung[0]:=x;
          ursprung[1]:=y;
          ursprung[2]:=z;
          joygedruckt:=true;
        end;
        x1:=integer(x)-ursprung[0];y1:=integer(y)-ursprung[1];z1:=integer(z)-ursprung[2];
        if (abs(x1)>20) or (abs(y1)>20) or (abs(z1)>20)
        then begin
          if switch(0) then translate(x1/2048,y1/2048,z1/2048)
          else if switch(1) then begin
            Rotate(1,x1/16);
            Rotate(2,y1/16);
            Rotate(3,z1/16);
          end;
        end;
      end else JoyGedruckt:=false;
    end;

    procedure position;
    var h:vct3;
    begin
      setcolor(red);
      h.x:=nrp.x+vup.x;h.y:=nrp.y+vup.y;h.z:=nrp.z+vup.z;
      linie3d(h,nrp);
      setcolor(white);
      linie3d(vrp,nrp);
    end;

    procedure waitsync;
    begin
      asm
             mov  dx,$3da
             mov  ah,8
{      @wait2:in   al,dx
             test al,ah
             jnz  @wait2}
      @wait4:in   al,dx
             test al,ah
             jz   @wait4
      end;
    end;

    
  begin
    joygedruckt:=false;
{    if iitcopro then transformpunkte:=transformpunkteiit
                else transformpunkte:=transformpunkteintel;}
    grafikbegin;
    if eingabe=eMaus then begin
      MausSetPos(200,200);
      MausMinMaxX(0,400);
      MausMinMaxY(0,400);
      jmaxx:=400;
      mittex:=200;
      jmaxy:=400;
      mittey:=200;
    end;
    seite:=0;
    setscreenglobal(0,ymaxglobal,xmaxglobal,0);
    doinit;
{    fillchar(inactpage^,sizeof(inactpage^),0);}
    repeat
      seite:=byte(not boolean(seite));
      setactivepage(seite);
      setvisualpage(byte(not boolean(seite)));
      waitsync;
{      h:=actpage;actpage:=inactpage;inactpage:=h;
      setcolor(black);
      for hlinie:=0 to pred(aktlinie) do with actpage^[hlinie] do line(xa,ya,xe,ye);}
      CLEARDEVICE;
      if eingabe in [eStick,eMaus] then begin
        case modus of
          0,1:bewegeauge;
          2:bewegekorper;
        end;
        case modus of
          0:doinit;
          1:position;
        end;
      end else bewegejoystring;
      transformpunkte(WCDC,Punktl^,pred(aktpunkt));
      for hlinie:=0 to pred(aktlinie) do with liniel^[hlinie] do begin
        setcolor(farbe);
        line(punktl^[a].x,punktl^[a].y,punktl^[e].x,punktl^[e].y);
{        with actpage^[hlinie] do begin
          xa:=punktl^[a].x;ya:=punktl^[a].y;
          xe:=punktl^[e].x;ye:=punktl^[e].y
        end;}
      end;
      while keypressed do ein:=readkey;
      if ein=' ' then begin
        ein:='!';
        VRP.x:=0;vrp.y:=0;vrp.z:=0;
        NRP.x:=1;nrp.y:=1;nrp.z:=1;
        VUP.x:=0;vup.y:=1;vup.z:=0;
        XMIN:=-3;
        YMIN:=-2;
        XSIZE:=6;
        VPD:=6;
        FPD:=5;
        BPD:=-5;
        doinit;
      end;
    until ein=#27;
    closegraph;
  end;

{$L EGAVGA}
procedure EGAVGAdriver;external;

begin
  if (registerbgidriver(@EGAVGAdriver)<0) then error('Fehler beim Anmelden der Grafiktreiber!');
  new(punktl);
  new(liniel);
{  new(actpage);
  new(inactpage);}
  textbackground(blue);
  textcolor(yellow);
  clrscr;
  writeln('*** Animation ***':30);
  writeln;
  laden;
  writeln('1) Joystring');
  writeln('2) Joystick');
  writeln('3) Maus');
  repeat
    repeat until keypressed;
    while keypressed do ein:=readkey;
  until ein in ['1'..'3'];
  case ein of
    '1':begin
          eingabe:=eString;
          initJoyStringText;
        end;
    '2':begin
          eingabe:=eStick;
          initjoysticktext(0);
          jmaxx:=maxpos[0,0,1]-maxpos[0,0,0];
          mittex:=maxpos[0,0,0]+jmaxx div 2;
          jmaxy:=maxpos[0,1,1]-maxpos[0,1,0];
          mittey:=maxpos[0,1,0]+jmaxy div 2;
        end;
    '3':eingabe:=eMaus;
  end;
  animiere;
end.