unit BufFile;
interface
uses dos;
type PFileBuf=^TFileBuf;
     TFileBuf=object
       buf:pointer;
       lange,bufpos:longint;
       name:pathstr;
       nread,gepuffert:boolean;
       f:file;
       constructor Reset(aname:pathstr;faktor:word;platz:longint);
       constructor Rewrite(aname:pathstr;alange,platz:longint);
       destructor close;
       procedure read(var ziel;alange:word);
       procedure write(var quelle;alange:word);
       procedure Seek(pos:longint);
       function FilePos:Longint;
     end;

implementation
type Bytearray=array[0..65534] of byte;

constructor TFileBuf.Reset(aname:pathstr;faktor:word;platz:longint);
var such:searchrec;
begin
  name:=aname;
  such.name:=name;
  findfirst(such.name,anyfile,such);
  if doserror=0 then begin
    lange:=such.size;
    assign(f,name);
    system.reset(f,1);
    if (Lange>65536) or (maxavail<Lange*succ(faktor)+platz) then
      gepuffert:=false
    else begin
      gepuffert:=true;
      getmem(buf,Lange);
      blockread(f,buf^,Lange);
      system.close(f);
    end;
    bufpos:=0;
    nread:=false;
  end;
end;

constructor TFileBuf.Rewrite(aname:pathstr;alange,platz:longint);
begin
  name:=aname;
  lange:=alange;
  if (Lange>65536) or (maxavail<Lange+platz) then begin
    gepuffert:=false;
    assign(f,name);
    system.Rewrite(f,1);
  end else begin
    gepuffert:=true;
    getmem(buf,Lange);
  end;
  bufpos:=0;
  nread:=true;
end;

destructor TFileBuf.close;
begin
  if gepuffert then begin
    if nread then begin
      assign(f,name);
      system.rewrite(f,1);
      blockwrite(f,buf^,bufpos);
      system.close(f);
    end;
    freemem(buf,lange);
  end else system.close(f);
end;

procedure TFileBuf.read(var ziel;alange:word);
begin
  if gepuffert then move(ByteArray(buf^)[bufpos],ziel,alange)
  else blockread(f,ziel,alange);
  inc(bufpos,alange);
end;

procedure TFileBuf.write(var quelle;alange:word);
begin
  if gepuffert then move(quelle,ByteArray(buf^)[bufpos],alange)
  else blockwrite(f,quelle,alange);
  inc(bufpos,alange);
end;

procedure TFileBuf.Seek(pos:longint);
begin
  if gepuffert then bufpos:=pos else system.seek(f,pos);
end;

function TFileBuf.FilePos:Longint;
begin
  if gepuffert then filepos:=bufpos else filepos:=system.filepos(f);
end;

end.