program convert;
uses crt,dos,wizinfo,uloadpic,vga;
type bytearray=array[0..65534] of byte;
     lbyte=array[0..3] of byte;
     rgbrec=array[1..21000,0..2] of byte;
var pal:ppalette;
const TGAHeader:record
        ncid,cmt,itc:byte;
        cmo,cml:word;
        cmes:byte;
        _xor,yor,w,h:word;
        ips,idb:byte;
      end=(ncid:0;
           cmt:0;
           itc:2;
           cmo:0;
           cml:0;
           cmes:0;
           _xor:0;
           yor:0;
           w:0;
           h:0;
           ips:$18;
           idb:$20);

const headlength=15;
Type THeader=array[0..headlength] of char;

const TrueColor=0;
      NormalPal=1;
      RGBPal=2;
      SW256Pal=3;
      Pal3D=4;
      SCQSave=8;
      header:THeader=('W','i','z','A','r','t',' ','P','i','c','t','u','r','e',#$00,#$1A);

const Form:array[1..4] of char=('F','O','R','M');
      ILBMBMHD:array[1..12] of char=('I','L','B','M','B','M','H','D',#0,#0,#0,#$14);
      Head2:record
        bhi,blo,hhi,hlo:byte;
        x,y:integer;
        bit,mask,komp,fill:byte;
        trans:word;
        dx,dy:byte;
        ubhi,ublo,uhhi,uhlo:byte;
      end=(bhi:1;blo:$40;hhi:0;hlo:$c8;x:0;y:0;bit:8;mask:0;komp:0;fill:0;trans:0;dx:1;dy:1;ubhi:1;ublo:$40;uhhi:0;uhlo:$c8);
      CMAP:array[1..8] of char=('C','M','A','P',#0,#0,#3,#0);
      BODY:array[1..4] of char=('B','O','D','Y');

type PBitFile=^TBitFile;
     TBitFile=object
       f:file;
       buf:pointer;
       pos:word;
       bitpos:byte;
       constructor rewrite(name:pathstr);
       destructor close;
       procedure write(var quelle;alange:word);
       procedure bit(b:boolean);
       procedure NewLine;
     end;

procedure TBitFile.write(var quelle;alange:word);
begin
  blockwrite(f,quelle,alange);
end;

constructor TBitFile.Rewrite(name:pathstr);
begin
  assign(f,name);
  system.Rewrite(f,1);
  getmem(buf,65534);
  fillchar(buf^,65534,#0);
  bitpos:=0;
  pos:=0;
end;

destructor TBitFile.close;
begin
  blockwrite(f,buf^,pos+((bitpos+7) div 8));
  system.close(f);
end;

procedure TBitFile.bit(b:boolean);
begin
  if b then Bytearray(buf^)[pos]:=Bytearray(buf^)[pos] or ($80 shr bitpos);
  inc(bitpos);
  if bitpos=8 then begin
    bitpos:=0;
    inc(pos);
    if pos=65534 then begin
      blockwrite(f,buf^,65534);
      pos:=0;
      fillchar(buf^,65534,#0);
    end;
  end;
end;

procedure TBitFile.NewLine;
begin
  if bitpos<>0 then begin
    bitpos:=0;
    inc(pos);
    if pos=65535 then begin
      blockwrite(f,buf^,65534);
      pos:=0;
      fillchar(buf^,65534,#0);
    end;
  end;
end;

function bildname:pathstr;
var dir:dirstr;
    name:namestr;
    ext:extstr;
    suche:searchrec;
    nam:pathstr;
begin
  if paramcount<>0 then nam:=paramstr(1) else
  if getinfo<>'' then begin
    fsplit(getinfo,dir,name,ext);
    nam:=dir+name;
  end else begin
    textbackground(blue);
    textcolor(yellow);
    clrscr;
    writeln('Convert');
    writeln;
    writeln('Folgende Bilder knnen Sie ins ILBM oder Targa Format konvertieren:');
    writeln;
    suche.name:='*.PIC';
    findfirst('*.PIC',$3f,suche);
    if (Doserror<>0) then writeln('keine':10);
    while (doserror=0) do begin
      write(suche.name:20);
      findnext(suche);
    end;
    writeln;
    suche.name:='*.ZIP';
    findfirst('*.ZIP',$3f,suche);
    if (Doserror<>0) then writeln('keine gepackten Bilder':10);
    while (doserror=0) do begin
      write(suche.name:20);
      findnext(suche);
    end;
    writeln;
    write('Geben Sie den Bildnamen ein (ohne Extension) : ');
    readln(nam);
  end;
  suche.name:='*.PIC';
  findfirst(nam+'.PIC',$3f,suche);
  if doserror<>0 then begin
    writeln(nam+'.PIC nicht gefunden !');
    halt(0);
  end else setinfo(nam+'.WIZ');
  bildname:=nam;
end;


procedure setfarbe(var p:ppalette;register:word;rot,gruen,blau:byte);
begin
  p^[register,0]:=rot;p^[register,1]:=gruen;p^[register,2]:=blau;
end;

procedure calcclutrgb;
var r,b,g,redi,greeni,bluei,colorindex:integer;
begin
  for r:=0 to 7 do begin
    redi:=r*9;
    for g:=0 to 7 do begin
      greeni:=g*9;
      for b:=0 to 3 do begin
        bluei:=b*21;
        colorindex:=(r shl 3 or g) shl 2 or b;
        setfarbe(pal,colorindex,redi,greeni,bluei);
      end;
    end;
  end;
end;

procedure calcclutnormal;
var f:byte;
begin
  for f:=0 to 63 do setfarbe(pal,f,f,0,0);
  for f:=0 to 63 do setfarbe(pal,f+64,0,f,0);
  for f:=0 to 63 do setfarbe(pal,f+128,0,0,f);
  for f:=0 to 63 do setfarbe(pal,f+192,f,f,f);
end;

procedure calcclutsw256;
var n,f,m:byte;
begin
  for n:=0 to 62 do begin
    f:=n*4;
    setfarbe(pal,f,n,n,n);
    setfarbe(pal,succ(f),succ(n),n,n);
    if n<62 then setfarbe(pal,f+2,succ(n),n,n+2) else setfarbe(pal,f+2,succ(n),n,n+1);
    setfarbe(pal,f+3,n,succ(n),succ(n));
  end;
  for m:=0 to 3 do setfarbe(pal,63*4+m,n,n,n);
end;

procedure calcclut3d;
var n,m:byte;
begin
  for m:=0 to 15 do for n:=0 to 15 do setfarbe(pal,m*16+n,
       round(m*63/15),
       round(n*63/15),
       0);
end;

procedure ladebild(name:string);
var palnr:byte;
    zippfad:pathstr;
    ok:boolean;
    f,g:file;
    hilf,n,m:byte;
    dir:dirstr;
    nam:namestr;
    ext:extstr;
    k,y,x,xmax,ymax:word;
    scq,zip,wizpic:boolean;
    suche:searchrec;
    head:theader;
    h,buf:pointer;
    BitF:PBitFile;
    l:longint;

begin
  zip:=false;
  findfirst(name+'.PIC',$3f,suche);
  if doserror<>0 then begin
    findfirst(name+'.ZIP',$3f,suche);
    if doserror<>0 then begin
      writeln(name+'.PIC oder '+name+'.ZIP nicht gefunden !');
      repeat until keypressed;
      halt(1);
    end;
    getdir(0,zippfad);
    swapvectors;
    exec(zippfad+'\PKUNZIP.EXE',name+'.ZIP');
    swapvectors;
    suche.name:=name+'.PIC';
    findfirst(name+'.PIC',$3f,suche);
    if doserror<>0 then begin
      writeln('Ausfhren von:');
      writeln(zippfad+'\PKUNZIP.EXE ',name+'.ZIP');
      writeln('fehlerhaft !');
      repeat until keypressed;
      halt(2);
    end;
    zip:=true;
  end;
  fsplit(name,dir,nam,ext);
  assign(f,dir+nam+'.PIC');
  reset(f,1);
  blockread(f,head,sizeof(header));
  wizpic:=true;
  for n:=0 to headlength do wizpic:=wizpic and (head[n]=header[n]);
  if wizpic then begin
    blockread(f,palnr,sizeof(palnr));
    blockread(f,xmax,sizeof(xmax));
    blockread(f,ymax,sizeof(ymax));
    if palnr=TrueColor then begin
      writeln('Konvertiere '+dir+name+'.PIC zu einer Targa Datei');
      getmem(buf,63000);
      assign(g,dir+nam+'.TGA');
      rewrite(g,1);
      tgaheader.w:=xmax;
      tgaheader.h:=ymax;
      blockwrite(g,tgaheader,sizeof(tgaheader));
      for n:=1 to (suche.size-21) div 63000 do begin
        write('#');
        blockread(f,buf^,63000);
        for x:=1 to 21000 do begin
          m:=rgbrec(buf^)[x,0];
          rgbrec(buf^)[x,0]:=rgbrec(buf^)[x,2];
          rgbrec(buf^)[x,2]:=m;
        end;
        blockwrite(g,buf^,63000);
      end;
      if (suche.size-21) mod 63000<>0 then begin
        blockread(f,buf^,(suche.size-21) mod 63000);
        for x:=1 to (suche.size-21) mod 63000 do begin
          m:=rgbrec(buf^)[x,0];
          rgbrec(buf^)[x,0]:=rgbrec(buf^)[x,2];
          rgbrec(buf^)[x,2]:=m;
        end;
        blockwrite(g,buf^,(suche.size-21) mod 63000);
      end;
      close(g);
      close(f);
    end else begin
      if palnr and scqsave>0 then begin
        close(f);
        ok:=LoadBild(dir+nam,palnr);
        palnr:=palnr and not scqsave;
        case palnr of
          1:calcclutnormal;
          2:calcclutrgb;
          3:calcclutsw256;
          4:calcclut3d;
        end;
        if ok then shadein(0,pal);
        {writeln('Konvertiere '+dir+name+'.PIC zu einer IFF Datei');}
        new(bitf,rewrite(dir+nam+'.LBM'));
        bitf^.write(form,sizeof(form));
        l:=((360+7) div 8)*8*480+8+256*3+8+28+4;
        BitF^.write(lbyte(l)[3],1);
        BitF^.write(lbyte(l)[2],1);
        BitF^.write(lbyte(l)[1],1);
        BitF^.write(lbyte(l)[0],1);
        BitF^.write(ILBMBMHD,sizeof(ILBMBMHD));
        head2.bhi:=hi(360);
        head2.blo:=lo(360);
        head2.ubhi:=hi(360);
        head2.ublo:=lo(360);
        head2.hhi:=hi(480);
        head2.hlo:=lo(480);
        head2.uhhi:=hi(480);
        head2.uhlo:=lo(480);
        BitF^.write(head2,sizeof(head2));
        BitF^.write(CMAP,sizeof(CMAP));
        for x:=0 to 255 do for y:=0 to 2 do pal^[x,y]:=pal^[x,y] shl 2;
        BitF^.write(pal^,sizeof(pal^));
        BitF^.write(BODY,sizeof(BODY));
        l:=((360+7) div 8)*8*480;
        BitF^.write(lbyte(l)[3],1);
        BitF^.write(lbyte(l)[2],1);
        BitF^.write(lbyte(l)[1],1);
        BitF^.write(lbyte(l)[0],1);
        getmem(buf,360);
        {write('  0 %');}
        for y:=1 to 480 do begin
          {gotoxy(1,wherey);
          write(round(y/480*100):3);}
          for k:=0 to 359 do bytearray(buf^)[k]:=scqgetpixel(k,pred(y));
          scqplot(180,pred(y),100);
          for n:=0 to 7 do begin
            hilf:=1 shl n;
            for x:=0 to pred(360) do
             BitF^.bit((bytearray(buf^)[x] and hilf)>0);
          end;
        end;
        dispose(BitF,close);
      end else begin
        writeln('Konvertiere '+dir+name+'.PIC zu einer IFF Datei');
        new(bitf,rewrite(dir+nam+'.LBM'));
        bitf^.write(form,sizeof(form));
        l:=((xmax+7) div 8)*8*ymax+8+256*3+8+28+4;
        BitF^.write(lbyte(l)[3],1);
        BitF^.write(lbyte(l)[2],1);
        BitF^.write(lbyte(l)[1],1);
        BitF^.write(lbyte(l)[0],1);
        BitF^.write(ILBMBMHD,sizeof(ILBMBMHD));
        head2.bhi:=hi(xmax);
        head2.blo:=lo(xmax);
        head2.ubhi:=hi(xmax);
        head2.ublo:=lo(xmax);
        head2.hhi:=hi(ymax);
        head2.hlo:=lo(ymax);
        head2.uhhi:=hi(ymax);
        head2.uhlo:=lo(ymax);
        BitF^.write(head2,sizeof(head2));
        BitF^.write(CMAP,sizeof(CMAP));
        scq:=palnr and scqsave>0;
        palnr:=palnr and not scqsave;
        case palnr of
          1:calcclutnormal;
          2:calcclutrgb;
          3:calcclutsw256;
          4:calcclut3d;
        end;
        for x:=0 to 255 do for y:=0 to 2 do pal^[x,y]:=pal^[x,y] shl 2;
        BitF^.write(pal^,sizeof(pal^));
        BitF^.write(BODY,sizeof(BODY));
        l:=((xmax+7) div 8)*8*ymax;
        BitF^.write(lbyte(l)[3],1);
        BitF^.write(lbyte(l)[2],1);
        BitF^.write(lbyte(l)[1],1);
        BitF^.write(lbyte(l)[0],1);
        getmem(buf,xmax);
        write('  0 %');
        for y:=1 to ymax do begin
          gotoxy(1,wherey);
          write(round(y/ymax*100):3);
          blockread(f,buf^,xmax);
          for n:=0 to 7 do begin
            hilf:=1 shl n;
            for x:=0 to pred(xmax) do
             BitF^.bit((bytearray(buf^)[x] and hilf)>0);
            BitF^.NewLine;
          end;
        end;
        dispose(BitF,close);
        close(f);
      end;
    end;
  end else writeln('Kein WizArt Bild');
  if zip then erase(f);
  writeln;
end;


begin
  new(pal);
  ladebild(bildname);
end.