unit fak3d;
interface
const bgipath='';
      epsilon=1E-10;
      maxpnts=50;
      pysscrsizex=24.0;
      pysscrsizey=17.0;
      colrange = 64;
      xdat=1;
      ydat=2;
      zdat=4;
      nrmdat=8;
      texturdat=16;
      materialdat=32;
      realdat=64;
      kartemaxx=359;
      kartemaxy=479;
      flaeche=true;
      koerper=false;
      normal=0;
      isvis=1;
      isinnpc=2;
      isinwc=4;
      isindc=8;
      notused=16;
      gouraud=true;
      flat=false;

{$ifopt N+} type real=single; {$endif}
type fix = record case boolean of
             true:(fix:longint);
             false:(f:word;i:integer);
           end;
     RGB  = record r,g,b:real; end;
     RGBb = record r,g,b:byte; end;
     RGBi = record r,g,b:integer; end;
     RGBf = record r,g,b:fix; end;
     mat4=array[0..3,0..3] of real;
     vct3=record x,y,z:real; end;
     vct4=record w,x,y,z:real; end;
     vertex=record
       crd,nrm:vct3;
       c:RGB;
     end;
     polyobjtyp=array[0..maxpnts] of vertex;
     trafstackptr=^trafstacktyp;
     trafstacktyp = record
                      mc_wc,mc_npc,mc_dc,
                      wc_mc,wc_dc,wc_npc,
                      npc_mc,npc_dc:mat4;
                      vor,nach:trafstackptr;
                    end;
     shd_vtx= record x,y,z:integer; c:RGBb; end;
     polyscrtyp=array[0..maxpnts] of shd_vtx;
     zbufferspan=array[0..kartemaxx] of integer;
     spanptr=^zbufferspan;
     lstype=(ambient,infinite,positional,spot);
     surfacepropertytyp=record
                          ka,kd,ks,oe:real;os,od:rgb;
                          alpha:real;
                        end;
     plsentry = ^lsentry;
     lsentry= record
                nr:integer; typ:lstype; active:boolean;
                lc,kalc,kdlc,ksoslc:rgb;
                c1,c2,le,cosash:real;
                ld,lp:vct3;
                next,pred,
                nextactthistyp,
                predactthistyp: plsentry;
              end;
     meshpnttyp = record
                     flags:byte;
                     a:vertex;
                     h:vct4;
                     l:shd_vtx;
                   end;
     meshlinetyp=array[0..maxpnts] of meshpnttyp;
     meshtyp=record
               m:array[0..maxpnts] of ^meshlinetyp;
               xmax,ymax:byte;
               volume:vct3;
             end;
     intptr=^integer;

const e:mat4=((1.0,0.0,0.0,0.0), (0.0,1.0,0.0,0.0),
              (0.0,0.0,1.0,0.0), (0.0,0.0,0.0,1.0));
      greytab:array[0..3] of rgb=((r:1;g:1;b:1),(r:1;g:0;b:0),(r:0;g:1;b:0),(r:0;g:0;b:1));
      aktgrey:byte=0;
      e_z: vct3=(x:0.0;y:0.0;z:1.0);
      me_z:vct3=(x:0.0;y:0.0;z:-1.0);
      flipareaenabled:boolean=false;
      wireframe:boolean=false;
      trifillenable : boolean=true;
      shadingmethod : boolean = gouraud;
      surfaceproperty: surfacepropertytyp= (ka:1/3; kd:1/3; ks:1/3;
                                            oe:10; os:(r:1;g:1;b:1);
                                                   od:(r:1;g:1;b:1);
                                                   alpha:0.5);
      clipmode:(inside,outside,toclip)=toclip;
      volclipcode:integer=$FF;
      clipcube:boolean=false;
      bkcolor:rgbb=(r:0;g:0;b:0);
      bkcolorr:rgb=(r:0.0;g:0.0;b:0.0);
      nebel:boolean=false;
      ende:integer=0;
      ender:real=0;
      VRP:vct3=(x:0;y:0;z:0);
      NRP:vct3=(x:1;y:1;z:1);
      VUP:vct3=(x:0;y:0;z:1);
      XMIN:real=-1.5;
      YMIN:real=-1.1;
      XSIZE:real=3;
      VPD:real=6;
      FPD:real=5;
      BPD:real=-5;
      speicherplatz:word=$8000;
      lichtgesch:boolean=false;
      durchsichtig:boolean=false;
      p:real=0.99;
      v:vct3=(x:1;y:1;z:1);
      lichtberechnet:boolean=false;
      name:string='';
      brille:boolean=false;
      mapcolor:byte=15;
      augendist:real=0.5;
      frame:boolean=false;
      farbig:boolean=true;

var MC_WC,WC_NPC,MC_NPC,MC_DC,
    WC_MC,WC_DC,NPC_MC,NPC_DC:mat4;
    xwinsize,ywinsize:real;
    xwinofs,ywinofs:integer;
    MatsChanged:boolean;
    eyepoint:vct3;
    trafstack:trafstackptr;
    zbuffer:array[0..kartemaxy] of spanptr;
    _pixelhochzubreit:real;
    grafmode:integer;
    amblsdefined:boolean;
    amblsc:rgb;
    lslistroot,lslistend,
    firstinf,lastinf,
    firstpos,lastpos,
    firstspt,lastspt:plsentry;
    _VRP,_NRP,_VUP: vct3;
    _VPD,_FPD,_BPD,_xMin,
    _ymin,_xsize,_ysize:real;
    _lux,_luy,_rox,_roy:real;
    _ysubu,_ysubo,
    _spanmemsize,
    _xmaxglobal,
    _ymaxglobal: integer;
    _wrkarr:meshtyp;
    datei : file;
    gezeichnet:boolean;
    augenvector,hilfnrp:vct3;
    _ZRM:real;
    emshandle:word;
    totalpages:word;
    _useems:boolean;
    emsbufbegin:longint;

procedure Rotate(achse:integer;w:real); {x=1;y=2;z=3; w in Grad gegen Uhrzeigersinn}
procedure translate(xv,yv,zv:real);
procedure Scale(scx,scy,scz:real);
procedure pushtrafs;
procedure poptrafs;
procedure copytrafs;
procedure savebild;
procedure changesurfaceproperty(newka,newkd,newks,
                                newosr,newosg,newosb,
                                newoe,
                                newodr,newodg,newodb,
                                newalpha:real);
procedure changesurfacepropertybyte(newka,newkd,newks,
                                newosr,newosg,newosb,
                                newoe,
                                newodr,newodg,newodb,
                                newalpha:byte);
procedure changespeed(newp,newvx,newvy,newvz:real);
procedure norm(ebene:boolean);
procedure textur(x1,y1:byte;cr,cg,cb:real);
procedure setzelichter;
procedure addambls(nr:integer; active: boolean; lcr,lcg,lcb:real);
procedure addinfls(nr:integer; active:boolean; lcr,lcg,lcb:real; ldx,ldy,ldz:real);
procedure addposls(nr:integer; active:boolean; lcr,lcg,lcb:real; lpx,lpy,lpz,
                   c1,c2:real);
procedure addsptls(nr:integer; active:boolean; lcr,lcg,lcb:real; ldx,ldy,ldz,
                   lpx,lpy,lpz,c1,c2,le,as:real);
procedure switchls(nr:integer; on:boolean);
procedure clearls(nr:integer);
function lsnrexists(nr:integer; var lsp:plsentry):boolean;
function maxls:integer;
procedure backgroundcolor(r,g,b:real);
procedure setnebel(unsichtbar:real);
procedure defineclipvolume(xm,ym,zm,r,g,b:real);
procedure undefclipvolume;
procedure initmesh;
procedure putinmesh(x,y:integer; var crd,nrm:vct3);
procedure putnotused(x,y:integer);
procedure mesh;
procedure meshextensions(x,y:byte);
procedure setviewing(VRP,NRP,VUP:vct3;
                     xmin,ymin,xmax,ymax,vpd,fpd,bpd:real);
function dolocalinit:boolean;
procedure grafikende;
procedure grafikbegin;
procedure MCtoDCi(a:vct3; var x,y:integer);
procedure MCtoDC(a:vct3; var x,y:real);
procedure mctowc(var a:vct3);
procedure updatemats;
function VGAvorhanden:boolean;
function donorm(var v:vct3):boolean;
procedure linie3d(b,e:vct3);
procedure init;
procedure SetScreenGlobal(lux,luy,rox,roy:real);
procedure SetViewGlobal(VRP,NRP,VUP:vct3;xmin,ymin,xSize,VPD, FPD, BPD: real);
procedure error(s:string);

implementation

procedure Rotate(achse:integer;w:real); {x=1;y=2;z=3; w in Grad gegen Uhrzeigersinn}
begin
end;
procedure translate(xv,yv,zv:real);
begin
end;

procedure Scale(scx,scy,scz:real);
begin
end;
procedure pushtrafs;
begin
end;
procedure poptrafs;
begin
end;
procedure copytrafs;
begin
end;
procedure savebild;
begin
end;
procedure changesurfaceproperty(newka,newkd,newks,
                                newosr,newosg,newosb,
                                newoe,
                                newodr,newodg,newodb,
                                newalpha:real);
begin
end;
procedure changesurfacepropertybyte(newka,newkd,newks,
                                newosr,newosg,newosb,
                                newoe,
                                newodr,newodg,newodb,
                                newalpha:byte);
begin
end;
procedure changespeed(newp,newvx,newvy,newvz:real);
begin
end;
procedure norm(ebene:boolean);
begin
end;
procedure textur(x1,y1:byte;cr,cg,cb:real);
begin
end;
procedure setzelichter;
begin
end;
procedure addambls(nr:integer; active: boolean; lcr,lcg,lcb:real);
begin
end;
procedure addinfls(nr:integer; active:boolean; lcr,lcg,lcb:real; ldx,ldy,ldz:real);
begin
end;
procedure addposls(nr:integer; active:boolean; lcr,lcg,lcb:real; lpx,lpy,lpz,
                   c1,c2:real);
begin
end;
procedure addsptls(nr:integer; active:boolean; lcr,lcg,lcb:real; ldx,ldy,ldz,
                   lpx,lpy,lpz,c1,c2,le,as:real);
begin
end;
procedure switchls(nr:integer; on:boolean);
begin
end;
procedure clearls(nr:integer);
begin
end;
function lsnrexists(nr:integer; var lsp:plsentry):boolean;
begin
end;
function maxls:integer;
begin
end;
procedure backgroundcolor(r,g,b:real);
begin
end;
procedure setnebel(unsichtbar:real);
begin
end;
procedure defineclipvolume(xm,ym,zm,r,g,b:real);
begin
end;
procedure undefclipvolume;
begin
end;
procedure initmesh;
begin
end;
procedure putinmesh(x,y:integer; var crd,nrm:vct3);
begin
end;
procedure putnotused(x,y:integer);
begin
end;
procedure mesh;
begin
end;
procedure meshextensions(x,y:byte);
begin
end;
procedure setviewing(VRP,NRP,VUP:vct3;
                     xmin,ymin,xmax,ymax,vpd,fpd,bpd:real);
begin
end;
function dolocalinit:boolean;
begin
end;
procedure grafikende;
begin
end;
procedure grafikbegin;
begin
end;
procedure MCtoDCi(a:vct3; var x,y:integer);
begin
end;
procedure MCtoDC(a:vct3; var x,y:real);
begin
end;
function VGAvorhanden:boolean;
begin
end;
procedure mctowc(var a:vct3);
begin
end;
procedure updatemats;
begin
end;
function donorm(var v:vct3):boolean;
begin
end;
procedure linie3d(b,e:vct3);
begin
end;
procedure init;
begin
end;
procedure SetScreenGlobal(lux,luy,rox,roy:real);
begin
end;
procedure SetViewGlobal(VRP,NRP,VUP:vct3;xmin,ymin,xSize,VPD, FPD, BPD: real);
begin
end;
procedure error(s:string);
begin
end;
end.