function pow(x,y:real):real;
begin
  if x>1-epsilon then pow:=1 else begin
    x:=ln(x)*y; if x<-8 then pow:=0 else pow:=exp(x);
  end;
end;

procedure dolight(p:vertex; var c:rgbb; z:integer);
var lsp : plsentry;
    vl,
    vr,
    ve : vct3;
    norm,
    cosa, tcosa,
    cosb,
    cosc:real;
    la: real;
    fl,fl1:real;
    ca,cd,cs,hilf:rgb;
    a,b:single;

begin            {>=}
{  if nebel and (ende<max-z) then begin
    c.r:=bkcolor.r;
    c.g:=bkcolor.g;
    c.b:=bkcolor.b;
  end else} begin
    cd.r:=0.0;
    cd.g:=0.0;
    cd.b:=0.0;
    cs.r:=0.0;
    cs.g:=0.0;
    cs.b:=0.0;
    ve.x:=eyepoint.x - p.crd.x;
    ve.y:=eyepoint.y - p.crd.y;
    ve.z:=eyepoint.z - p.crd.z;
    if donorm(ve) then error('DoLight: Objekt geht durchs Auge !');
    Lsp:=firstInf;
    while lsp<>nil do begin
      with lsp^,p do begin
        cosa:=nrm.x * -ld.x +
              nrm.y * -ld.y +
              nrm.z * -ld.z;
        if cosa>0.0 then begin
          cd.r:= cd.r + Kdlc.r * cosa;
          cd.g:= cd.g + Kdlc.g * cosa;
          cd.b:= cd.b + Kdlc.b * cosa;
          tcosa:=2.0*cosa;
          vr.x:=tcosa*nrm.x + ld.x;
          vr.y:=tcosa*nrm.y + ld.y;
          vr.z:=tcosa*nrm.z + ld.z;
          cosb:=ve.x * vr.x +
                ve.y * vr.y +
                ve.z * vr.z;
          if cosb>0.0 then begin
            fl:=pow(cosb,surfaceproperty.oe);
            cs.r:=cs.r + ksoslc.r * fl;
            cs.g:=cs.g + ksoslc.g * fl;
            cs.b:=cs.b + ksoslc.b * fl;
          end;
        end;
      end;
      lsp:=lsp^.nextactthistyp;
    end;

    lsp:=firstpos;
    while lsp<>nil do begin
      with lsp^,p do begin
        norm:= sqrt(sqr(crd.x - lp.x)+
                    sqr(crd.y - lp.y)+
                    sqr(crd.z - lp.z));
        la := 1.0 / (c1 + c2 * norm);
        if la<0 then la:=0;
        vl.x := lp.x - crd.x;
        vl.y := lp.y - crd.y;
        vl.z := lp.z - crd.z;
        if donorm(vl) then error('DoLight: Objekt trifft Lichtquelle');
        cosa := nrm.x*vl.x+nrm.y*vl.y+nrm.z*vl.z;
        if cosa>0.0 then begin
          fl:=cosa*la;
          tcosa:=2.0*cosa;
          cd.r := cd.r + kdlc.r * fl;
          cd.g := cd.g + kdlc.g * fl;
          cd.b := cd.b + kdlc.b * fl;
          vr.x := tcosa*nrm.x - vl.x;
          vr.y := tcosa*nrm.y - vl.y;
          vr.z := tcosa*nrm.z - vl.z;
          cosb := ve.x*vr.x+ve.y*vr.y+ve.z*vr.z;
          if cosb >0.0 then begin
            fl:= pow(cosb,surfaceproperty.oe)*la;
            cs.r := cs.r + ksoslc.r * fl;
            cs.g := cs.g + ksoslc.g * fl;
            cs.b := cs.b + ksoslc.b * fl;
          end;
        end;
      end;
      lsp:=lsp^.nextactthistyp;
    end;

    lsp:=firstspt;
    while lsp<>nil do begin
      with lsp^,p do begin
        vl.x := lp.x  - crd.x;
        vl.y := lp.y  - crd.y;
        vl.z := lp.z  - crd.z;
        if donorm(vl) then error('DoLight: Objekt trifft Lichtquelle !');
        cosc := ld.x * -vl.x +
                ld.y * -vl.y +
                ld.z * -vl.z;
        if cosc > cosash then begin
          norm:=sqrt(sqr(crd.x - lp.x)+
                     sqr(crd.y - lp.y)+
                     sqr(crd.z - lp.z));
          la := 1.0 / (c1 + c2 * norm);
          if la<0 then la:=0;
          cosa := nrm.x*vl.x+nrm.y*vl.y+nrm.z*vl.z;
          if cosa>0.0 then begin
            fl1 := la*pow(cosc,le);
            fl:= cosa*fl1;
            tcosa:=2.0*cosa;
            cd.r:= cd.r + kdlc.r * fl;
            cd.g:= cd.g + kdlc.g * fl;
            cd.b:= cd.b + kdlc.b * fl;
            vr.x := tcosa*nrm.x - vl.x;
            vr.y := tcosa*nrm.y - vl.y;
            vr.z := tcosa*nrm.z - vl.z;
            cosb := ve.x*vr.x+ve.y*vr.y+ve.z*vr.z;
            if cosb >0.0 then begin
              fl:= pow(cosb,surfaceproperty.oe)*fl1;
              cs.r := cs.r + ksoslc.r * fl;
              cs.g := cs.g + ksoslc.g * fl;
              cs.b := cs.b + ksoslc.b * fl;
            end;
          end;
        end;
      end;
      lsp:=lsp^.nextactthistyp;
    end;

    if amblsdefined then begin
      ca.r:=amblsc.r * p.c.r;
      ca.g:=amblsc.g * p.c.g;
      ca.b:=amblsc.b * p.c.b;
    end else begin
      ca.r := 0.0;
      ca.g := 0.0;
      ca.b := 0.0;
    end;
    cd.r:=cd.r * p.c.r;
    cd.g:=cd.g * p.c.g;
    cd.b:=cd.b * p.c.b;
    hilf.r:=(Ca.r + Cd.r + cs.r) * colrange;
    hilf.g:=(Ca.g + Cd.g + cs.g) * colrange;
    hilf.b:=(Ca.b + Cd.b + cs.b) * colrange;
    if nebel then begin
      {a:=z-ende;
      b:=max-a;}
      {a:=(z-(max-ende))/ende;
      b:=1-a=1-z/ende};
      {a:=(z-(1000-ende))/ende;
      b:=1-a;}
      a:=z/ende;
      b:=(1-a)*colrange;
      hilf.r:=(hilf.r*a+nebelcolorr.r*b){ / max};
      hilf.g:=(hilf.g*a+nebelcolorr.g*b){ / max};
      hilf.b:=(hilf.b*a+nebelcolorr.b*b){ / max};
{!      write(lst,z,' ');}
    end;
    if hilf.r<0 then c.r:=0 else
      if hilf.r>colrange-1.5 then c.r:=pred(colrange) else c.r:=round(hilf.r);
    if hilf.g<0 then c.g:=0 else
      if hilf.g>colrange-1.5 then c.g:=pred(colrange) else c.g:=round(hilf.g);
    if hilf.b<0 then c.b:=0 else
      if hilf.b>colrange-1.5 then c.b:=pred(colrange) else c.b:=round(hilf.b);
  end;
end;

function lsnrexists(nr:integer; var lsp:plsentry):boolean;
var found:boolean;
begin
  lsp:=lslistroot;
  found:=false;
  while (lsp<>nil) and not found do begin
    found:=lsp^.nr=nr; if not found then lsp:=lsp^.next;
  end;
  lsnrexists:=found;
end;

procedure addls(lsnr:integer; lsactive:boolean; lstyp:lstype; lsc:rgb;
                C1,c2,le,as: real; ld,lp:vct3);
var s:string;
    first,
    last : ^plsentry;
    dummy: plsentry;

begin
  if lsnrexists(lsnr,dummy) then begin
    str(lsnr,s); s:='addLs: Lichtquelle Nr. '+s+' existiert schon !';
    error(s);
  end else with surfaceproperty do begin
    if LsListRoot=nil then begin
      firstinf:=nil; firstpos:=nil; firstspt:=nil;
      amblsdefined:=false;
      new(LsListRoot);
      LsListroot^.pred:=nil;
      LsListend:=lslistroot;
    end else begin
      new(LsListend^.next);
      lslistend^.next^.pred:=lslistend;
      lslistend:=lslistend^.next;
    end;
    lslistend^.next:=nil;
    lslistend^.nr:=lsnr;
    lslistend^.active:=lsactive;
    lslistend^.typ:=lstyp;
    lslistend^.lc:=lsc;
    lslistend^.kalc.r:=ka*lsc.r;
    lslistend^.kalc.g:=ka*lsc.g;
    lslistend^.kalc.b:=ka*lsc.b;
    if lstyp>ambient then begin
      lslistend^.kdlc.r:=kd*od.r*lsc.r;
      lslistend^.kdlc.g:=kd*od.g*lsc.g;
      lslistend^.kdlc.b:=kd*od.b*lsc.b;
      lslistend^.ksoslc.r:=Ks*os.r*lsc.r;
      lslistend^.ksoslc.g:=Ks*os.g*lsc.g;
      lslistend^.ksoslc.b:=Ks*os.b*lsc.b;
      if lstyp>infinite then begin
        lslistend^.lp:=lp;
        lslistend^.c1:=c1;
        lslistend^.c2:=c2;
      end;
      if lstyp in [infinite,spot] then begin
        if donorm(ld) then error('addLs: Lichtrichtung nicht definiert !');
        lslistend^.ld:=ld;
      end;
      if lstyp=spot then begin
        lslistend^.cosash:=cos(as*pi/180*0.5);
        lslistend^.le:=le;
      end;
    end;
    if lsactive then with lslistend^ do begin
      if lstyp=ambient then begin
        if amblsdefined then begin
          amblsc.r:=amblsc.r+kalc.r;
          amblsc.g:=amblsc.g+kalc.g;
          amblsc.b:=amblsc.b+kalc.b;
        end else begin
          amblsdefined:=true;
          amblsc.r:=kalc.r;
          amblsc.g:=kalc.g;
          amblsc.b:=kalc.b;
        end;
      end else begin
        case lstyp of
          infinite:   begin first:=@firstinf; last:=@lastinf; end;
          positional: begin first:=@firstpos; last:=@lastpos; end;
          spot:       begin first:=@firstspt; last:=@lastspt; end;
        end;
        if first^=nil then begin
          first^:=lslistend; last^:=first^;
          last^^.nextactthistyp:=nil;
          first^^.predactthistyp:=nil;
        end else begin
          last^^.nextactthistyp:=lslistend;
          lslistend^.predactthistyp:=last^;
          last^:=lslistend;
        end;
      end;
    end;
    lslistend^.nextactthistyp:=nil;
  end;
end;

procedure clearls(nr:integer);
var lsp:plsentry;
    s:string;
begin
  if lsnrexists(nr,lsp) then with lsp^ do begin
    if pred<>nil then pred^.next:=next;
    if next<>nil then next^.pred:=pred;
    if lsp=lslistroot then lslistroot:=next;
    if active then begin
      if typ=ambient then begin
        amblsc.r:=amblsc.r-kalc.r;
        amblsc.g:=amblsc.g-kalc.g;
        amblsc.b:=amblsc.b-kalc.b;
        amblsdefined:=abs(amblsc.r)+abs(amblsc.g)+abs(amblsc.b)>epsilon;
      end else begin
        if predactthistyp<>nil then
          predactthistyp^.nextactthistyp:=nextactthistyp
        else case typ of
          infinite:   firstinf:=nextactthistyp;
          positional: firstpos:=nextactthistyp;
          spot:       firstspt:=nextactthistyp;
        end;
        if nextactthistyp<>nil then
          nextactthistyp^.predactthistyp:=predactthistyp;
      end;
    end;
    dispose(lsp);
  end else begin
    str(nr,s); s:='ClearLs: Lichtquelle Nr. '+s+' existiert nicht !';
    error(s);
  end;
end;

procedure switchls(nr:integer; on:boolean);
var first,last: ^plsentry;
    lsp:plsentry;
    s:string;
begin
  if lsnrexists(nr,lsp) then with lsp^,surfaceproperty do begin
    if on and not active then begin
      if typ=ambient then begin
        amblsc.r:=amblsc.r+kalc.r;
        amblsc.g:=amblsc.g+kalc.g;
        amblsc.b:=amblsc.b+kalc.b;
        amblsdefined:=true;
      end else begin
        case typ of
          infinite:   begin first:=@firstinf; last:=@lastinf; end;
          positional: begin first:=@firstpos; last:=@lastpos; end;
          spot:       begin first:=@firstspt; last:=@lastspt; end;
        end;
        if first^=nil then begin
          first^:=lsp; last^:=lsp;
        end else begin
          last^^.nextactthistyp:=lsp;
          predactthistyp:=lastinf;
          last^:=lsp;
        end;
      end;
    end else if not on and active then begin
      if typ=ambient then begin
        amblsc.r:=amblsc.r-kalc.r;
        amblsc.g:=amblsc.g-kalc.g;
        amblsc.b:=amblsc.b-kalc.b;
        amblsdefined:=abs(amblsc.r)+abs(amblsc.g)+abs(amblsc.b)>epsilon;
      end else begin
        if predactthistyp<>nil then begin
          predactthistyp^.nextactthistyp:=nextactthistyp;
          nextactthistyp^.predactthistyp:=predactthistyp;
        end else begin
          case typ of
            infinite:   firstinf:=nextactthistyp;
            positional: firstpos:=nextactthistyp;
            spot:       firstspt:=nextactthistyp;
          end;
          if nextactthistyp<>nil then
            nextactthistyp^.predactthistyp:=nil;
        end;
        predactthistyp:=nil; nextactthistyp:=nil;
      end;
    end;
    active:=on;
  end else begin
    str(nr,s); s:='SwitchLs: Lichtquelle Nr. '+s+' existiert nicht !';
    error(s);
  end;
end;

function maxls:integer;
var lsp:plsentry;
    zahler:integer;
begin
  zahler:=-1;
  lsp:=lslistroot;
  while lsp<>nil do begin
    if lsp^.nr>zahler then zahler:=lsp^.nr;
    lsp:=lsp^.next;
  end;
  maxls:=zahler;
end;

procedure changesurfaceproperty(newka,newkd,newks,
                                newosr,newosg,newosb,
                                newoe,
                                newodr,newodg,newodb,
                                newalpha:real);
var lsp:plsentry;
begin
  lsp:=lslistroot;
  while lsp<>nil do begin
    with lsp^ do begin
      kalc.r:=lc.r*newka;
      kalc.g:=lc.g*newka;
      kalc.b:=lc.b*newka;
      kdlc.r:=lc.r*newodr*newkd;
      kdlc.g:=lc.g*newodg*newkd;
      kdlc.b:=lc.b*newodb*newkd;
      ksoslc.r:=lc.r*newosr*newks;
      ksoslc.g:=lc.g*newosg*newks;
      ksoslc.b:=lc.b*newosb*newks;
    end;
    lsp:=lsp^.next;
  end;
  with surfaceproperty do begin
    if amblsdefined then begin
      amblsc.r:=amblsc.r/ka*newka;
      amblsc.g:=amblsc.g/ka*newka;
      amblsc.b:=amblsc.b/ka*newka;
    end;
    ka:=newka; kd:=newkd; ks:=newks;
    os.r:=newosr;
    os.g:=newosg;
    os.b:=newosb;
    oe:=newoe;
    od.r:=newodr;
    od.g:=newodg;
    od.b:=newodb;
    durchsichtig:=newalpha<>0;
    alpha:=newalpha;
  end;
end;

procedure changesurfacepropertybyte(newka,newkd,newks,
                                newosr,newosg,newosb,
                                newoe,
                                newodr,newodg,newodb,
                                newalpha:byte);
var  newkar,newkdr,newksr,
                                newosrr,newosgr,newosbr,
                                newoer,
                                newodrr,newodgr,newodbr,
                                newalphar:real;
begin
  newkar:=newka/63;newkdr:=newkd/63;newksr:=newks/63;
  newosrr:=newosr/63;newosgr:=newosg/63;newosbr:=newosb/63;
  newoer:=newoe;
  newodrr:=newodr/63;newodgr:=newodg/63;newodbr:=newodb/63;
  newalphar:=newalpha/63;
  changesurfaceproperty(newkar,newkdr,newksr,
                                newosrr,newosgr,newosbr,
                                newoer,
                                newodrr,newodgr,newodbr,
                                newalphar
                                );
end;

procedure addambls(nr:integer; active: boolean; lcr,lcg,lcb:real);
var hilf:rgb;
begin
  hilf.r:=lcr; hilf.g:=lcg; hilf.b:=lcb;
  addls(nr,active,ambient,hilf,0,0,0,0,e_z,e_z);
end;

procedure addinfls(nr:integer; active:boolean; lcr,lcg,lcb:real; ldx,ldy,ldz:real);
var ld:vct3;
    hilf:rgb;
begin
  hilf.r:=lcr; hilf.g:=lcg; hilf.b:=lcb;
  ld.x:=ldx;ld.y:=ldy;ld.z:=ldz;
  addls(nr,active,infinite,hilf,0,0,0,0,ld,e_z);
end;

procedure addposls(nr:integer; active:boolean; lcr,lcg,lcb:real; lpx,lpy,lpz,
                   c1,c2:real);
var lp:vct3;
    hilf:rgb;
begin
  hilf.r:=lcr; hilf.g:=lcg; hilf.b:=lcb;
  lp.x:=lpx;lp.y:=lpy;lp.z:=lpz;
  addls(nr,active,positional,hilf,c1,c2,0,0,e_z,lp);
end;

procedure addsptls(nr:integer; active:boolean; lcr,lcg,lcb:real; ldx,ldy,ldz,
                   lpx,lpy,lpz,c1,c2,le,as:real);
var lp,ld:vct3;
    hilf:rgb;
begin
  hilf.r:=lcr; hilf.g:=lcg; hilf.b:=lcb;
  lp.x:=lpx;lp.y:=lpy;lp.z:=lpz;
  ld.x:=ldx;ld.y:=ldy;ld.z:=ldz;
  addls(nr,active,spot,hilf,c1,c2,le,as,ld,lp);
end;

procedure backgroundcolor(r,g,b:real);
begin
  bkcolorr.r:=r;
  bkcolorr.g:=g;
  bkcolorr.b:=b;
  bkcolor.r:=round(r*pred(colrange));
  bkcolor.g:=round(g*pred(colrange));
  bkcolor.b:=round(b*pred(colrange));
  if bkcolor.r>pred(colrange) then bkcolor.r:=pred(colrange);
  if bkcolor.g>pred(colrange) then bkcolor.g:=pred(colrange);
  if bkcolor.b>pred(colrange) then bkcolor.b:=pred(colrange);
end;

procedure correctbkcolor;
begin
  with bkcolorr do backgroundcolor(r,g,b);
end;

procedure setnebel(unsichtbar,r,g,b:real);
begin
  ender:=unsichtbar;
  nebel:=unsichtbar<>0;
  nebelcolorr.r:=r;
  nebelcolorr.g:=g;
  nebelcolorr.b:=b;
end;