unit materie;
interface
uses crt,dos,maus,vga,dreid;
type mattyp=record
       ambc,difc,spec:rgbb;
       ka,kd,ks:byte;
       oe,alpha,facetten:byte;
     end;

const mater:mattyp=(ambc:(r:63;g:63;b:63);difc:(r:63;g:63;b:63);spec:(r:63;g:63;b:63);
                    ka:3;kd:50;ks:3;oe:5;alpha:0;facetten:20);

procedure materialmischen(kugelzeichnen:boolean);

implementation

procedure materialmischen(kugelzeichnen:boolean);

const maussicht_:boolean=false;
      maxx=319;
      maxy=199;
      ende:boolean=false;
      ramenfarbe=10;
      hintergrundfarbe=0;
      blau=0;
      facetten:byte=0;
      name:namestr='NONAME';
type mausbuftyp=array[0..1,-2..2] of byte;
     Umsetztabtyp=array[0..11,0..1] of byte;
const Umsetztab:Umsetztabtyp=((($13),($33)),(($17),($37)),(($1b),($3b)),
                              (($14),($34)),(($18),($38)),(($1c),($3c)),
                              (($c0),($E0)),(($C4),($E4)),(($C8),($E8)),
                              (($01),($21)),(($04),($24)),(($08),($28)));
      matercol:mattyp=(ambc:(r:$c0;g:$14;b:$13);difc:(r:$c4;g:$18;b:$17);spec:(r:$c8;g:$1c;b:$1b);
                    ka:$01;kd:$04;ks:$08;oe:$FF;alpha:$FF;facetten:$FF);
var mausbuf:mausbuftyp;
    tasten,altx,alty,xpos,ypos:word;
    tastenzahl:word;

  procedure kugel(n:integer);
  var st,ct,sa,ca,
      cth,cah,dct,dst,dca,dsa:real;
      ps,p,pn:vertex;
      a,t:integer;
  begin
    _wrkarr.xmax:=n;
    _wrkarr.ymax:=n;
    dct:=cos(2*PI/n); dst:=sqrt(1-dct*dct);
    dca:=cos(2*PI/(2*n)); dsa:=sqrt(1-dca*dca);
    ca:=dct; sa:=dst; ct:=sa; st:=0.0;
    for a:=1 to pred(n) do begin
      for t:=0 to n do with p do begin
        crd.x:=ct; crd.y:=st; crd.z:=ca;
        nrm:=crd;
        putinmesh(a,t,crd,nrm);
        cth:=ct;
        ct:=ct*dct-st*dst;
        st:=st*dct+cth*dst;
      end;
      cah:=ca;
      ca:=ca*dca-sa*dsa;
      sa:=sa*dca+cah*dsa;
      ct:=sa; st:=0.0;
    end;
    pn.crd:=e_z; pn.nrm:=pn.crd;
    ps.crd:=me_z; ps.nrm:=ps.crd;
    for t:=0 to n do begin
      putinmesh(0,t,pn.crd,pn.nrm);
      putinmesh(n,t,ps.crd,ps.nrm);
    end;
  end;

  procedure maussetzen(x,y:word);
  var n:shortint;
  begin
    for n:=-2 to 2 do begin
      mausbuf[0,n]:=getpixel(x,y+n);
      plot(x,y+n,not mausbuf[0,n]);
    end;
    for n:=-2 to 2 do if n<>0 then begin
      mausbuf[1,n]:=getpixel(x+n,y);
      plot(x+n,y,not mausbuf[1,n]);
    end;
  end;

  procedure mausloschen(x,y:word);
  var n:shortint;
  begin
    for n:=-2 to 2 do plot(x,y+n,mausbuf[0,n]);
    for n:=-2 to 2 do if n<>0 then plot(x+n,y,mausbuf[1,n]);
  end;

  procedure mausunsicht;
  begin
    if maussicht_ then begin
      mausloschen(altx,alty);
      maussicht_:=false;
    end;
  end;

  procedure maussicht;
  begin
    if not maussicht_ then begin
      maussetzen(xpos,ypos);
      maussicht_:=true;
      altx:=xpos;alty:=ypos;
    end;
  end;

  procedure bewegezeiger;
  begin
    if maussicht_ then begin
      mausloschen(altx,alty);
      maussetzen(xpos,ypos);
    end;
    altx:=xpos; alty:=ypos;
  end;

  function mausin(x,y,xe,ye:integer):boolean;
  begin
    mausin := (xpos >= x) and (xpos <= xe) and (ypos >= y) and (ypos <= ye);
  end;

  procedure mauswarte;
  begin
    repeat until not mauskeypressed;
  end;

  procedure block(x,y,xw,yw:word;c:byte);
  var ofs,y2:word;
  begin
    ofs:=y*320+x;
    for y2:=1 to yw do begin
      fillchar(mem[$A000:ofs],xw,c);
      inc(ofs,320);
    end;
  end;

  procedure zeichne(r:byte;kugelzeichnen:boolean);
  var x,y:byte;

    procedure farbkorrektur(x,xl:word);
    var x2,y2:word;
        c,z:byte;
    begin
      for y2:=1 to 99 do for x2:=x to xl do begin
        c:=getpixel(x2,y2);
        for z:=0 to 11 do if umsetztab[z,0]=c then plot(x2,y2,umsetztab[z,1]);
      end;
    end;

  begin
    if facetten<>mater.facetten then begin
      if mater.facetten>50 then mater.facetten:=50 else
      if mater.facetten<3 then mater.facetten:=3;
      kugel(mater.facetten);
      facetten:=mater.facetten;
    end;
    mausunsicht;
    if r=0 then begin
      setscreenglobal(0,_ymaxglobal div 2,_xmaxglobal div 2-40,0);
      for x:=0 to 3 do for y:=0 to 3 do block(x*30+1,y*25+1,30-byte(x=3),25-byte(y=3),255*byte(odd(x*3+y)));
    end else begin
      setscreenglobal(_xmaxglobal div 2-40,_ymaxglobal div 2,_xmaxglobal-80,0);
      for x:=0 to 3 do for y:=0 to 3 do block(x*30+121,y*25+1,30-2*byte(x=3),25-byte(y=3),255*byte(odd(x*3+y)));
    end;
    if kugelzeichnen then begin
      while dolocalinit do mesh;
      if r=0 then farbkorrektur(1,119)
      else farbkorrektur(121,239);
    end;
    maussicht;
  end;

  procedure balken(x,y:word;l,c:byte);
  var n:byte;
      ofs:word;
  begin
    map($F);
    ofs:=y*320+x+320;
    for n:=1 to 6 do begin
      fillchar(mem[$A000:ofs],l,c);
      fillchar(mem[$A000:ofs+l],63-l,blau);
      inc(ofs,320);
    end;
  end;

  procedure farbabfragemaske(x,y:word;a:byte;c:rgbb;ac:byte;cc:rgbb);
  begin
    mausunsicht;
    waitsync;
    farbe(ac,c.r,c.g,c.b);
    farbe(cc.r,c.r,0,0);
    farbe(cc.g,0,c.g,0);
    farbe(cc.b,0,0,c.b);
    balken(x,y+1*8,a,ac);
    gotoxy(succ(x div 8)+8,succ((y+1*8) div 8));
    write(a/63:4:2);
    balken(x,y+2*8,c.r,cc.r);
    gotoxy(succ(x div 8)+8,succ((y+2*8) div 8));
    write(c.r/63:4:2);
    balken(x,y+3*8,c.g,cc.g);
    gotoxy(succ(x div 8)+8,succ((y+3*8) div 8));
    write(c.g/63:4:2);
    balken(x,y+4*8,c.b,cc.b);
    gotoxy(succ(x div 8)+8,succ((y+4*8) div 8));
    write(c.b/63:4:2);
    maussicht;
  end;

  procedure farbabfragemasketext(text:string;x,y:word;a:byte;c:rgbb;ac:byte;cc:rgbb);
  begin
    mausunsicht;
    gotoxy(succ(x div 8),succ(y div 8));
    write(text);
    farbabfragemaske(x,y,a,c,ac,cc);
  end;

  function farbabfrage(x,y:word;var a:byte;var c:rgbb):boolean;
  var gefunden:boolean;

    function wert:byte;
    begin
      wert:=xpos-x;
      gefunden:=true;
    end;

  begin
    gefunden:=false;
    if mausin(x,y+1*8,x+63,y+7+4*8) then begin
      if mausin(x,y+1*8,x+63,y+7+1*8) then a:=wert else
      if mausin(x,y+2*8,x+63,y+7+2*8) then c.r:=wert else
      if mausin(x,y+3*8,x+63,y+7+3*8) then c.g:=wert else
      if mausin(x,y+4*8,x+63,y+7+4*8) then c.b:=wert;
    end;
    farbabfrage:=gefunden;
  end;

  procedure paramabfragemaske(x,y:word;a,ac:byte);
  begin
    mausunsicht;
    waitsync;
    balken(x,y+1*8,a,ac);
    gotoxy(succ(x div 8)+8,2+(y div 8));
    write(a:3);
    maussicht;
  end;

  procedure paramabfragemasketext(text:string;x,y:word;a,ac:byte);
  begin
    mausunsicht;
    gotoxy(succ(x div 8),succ(y div 8));
    write(text);
    paramabfragemaske(x,y,a,ac);
  end;

  function paramabfrage(x,y:word;var a:byte):boolean;
  var gefunden:boolean;

    function wert:byte;
    begin
      wert:=xpos-x;
      gefunden:=true;
    end;

  begin
    gefunden:=false;
    if mausin(x,y+1*8,x+63,y+7+1*8) then a:=wert;
    paramabfrage:=gefunden;
  end;

  procedure textmaske;
  begin
    mausunsicht;
    farbabfragemasketext('Objektfarbe',0,104,mater.ka,mater.ambc,matercol.ka,matercol.ambc);
    farbabfragemasketext('Diffuse Farbe',120,104,mater.kd,mater.difc,matercol.kd,matercol.difc);
    farbabfragemasketext('Spekulare Farbe',0,104+8*5,mater.ks,mater.spec,matercol.ks,matercol.spec);
    paramabfragemasketext('Speku. Exponent',120,104+8*5,mater.oe,matercol.oe);
    paramabfragemasketext('Durchsichtig',120,104+8*7,mater.alpha,matercol.alpha);
    paramabfragemasketext('Facetten',120,104+8*9,mater.facetten,matercol.facetten);
    gotoxy(31,1);write('Ŀ');
    gotoxy(31,2);write('  EXIT  ');
    gotoxy(31,3);write('Ĵ');
    gotoxy(31,4);write('  LOAD  ');
    gotoxy(31,5);write('Ĵ');
    gotoxy(31,6);write('  SAVE  ');
    gotoxy(31,7);write('Ĵ');
    gotoxy(31,8);write('        ');
    gotoxy(31,9);write('');
    gotoxy(32,8);write(name);
    maussicht;
  end;

  procedure maske;
  var n:word;
  begin
    mausunsicht;
    map($F);
    for n:=1 to 99 do fillchar(mem[$A000:(n*320)+1],239,hintergrundfarbe);
    for n:=1 to 238 do begin plot(n,0,ramenfarbe);plot(n,100,ramenfarbe); end;
    for n:=0 to 100 do begin plot(0,n,ramenfarbe);plot(120,n,ramenfarbe);plot(239,n,ramenfarbe); end;
    textmaske;
    maussicht;
  end;

  procedure save;
  var f:text;
      dir:dirstr;
      nam:namestr;
      ext:extstr;
  begin
    fsplit(name,dir,nam,ext);
    assign(f,dir+nam+'.MAT');
    rewrite(f);
    with mater do begin
      writeln(f,'TEXTUR 50 50 ',ambc.r/63:6:3,ambc.g/63:6:3,ambc.b/63:6:3);
      writeln(f,'OBERFLCHE ',ka/63:6:3,kd/63:6:3,ks/63:6:3,spec.r/63:6:3,spec.g/63:6:3,spec.b/63:6:3,
                                oe:3,difc.r/63:6:3,difc.g/63:6:3,difc.b/63:6:3,alpha/63:6:3);
    end;
    close(f);
  end;

  procedure load;
  var f:text;
      befehl,argumente:string;
      suche:searchrec;
      dir:dirstr;
      nam:namestr;
      ext:extstr;

    procedure lesezeile;
    begin
      readln(f,befehl);
      while pos(' ',befehl)=1 do delete(befehl,1,1);
      argumente:=befehl;
      argumente:=argumente+' ';
      delete(argumente,1,pos(' ',argumente));
      befehl:=befehl+' ';
      delete(befehl,pos(' ',befehl),length(befehl)-pos(' ',befehl));
    end;

    function id(s:string):boolean;
    var gleich:boolean;
        n,k:byte;
    begin
      gleich:=true;
      K:=pred(length(befehl));
      if k=0 then k:=1;
      n:=length(s);
      if n<k then k:=n;
      for n:=1 to k do begin
        befehl[n]:=upcase(befehl[n]);
        case befehl[n] of
          '':befehl[n]:='';
          '':befehl[n]:='';
          '':befehl[n]:='';
        end;
        gleich:=gleich and (s[n]=befehl[n]);
      end;
      id:=gleich;
    end;

    function realzahl:real;
    var h:real;
        err:integer;
    begin
      while pos(' ',argumente)=1 do delete(argumente,1,1);
      argumente:=argumente+' ';
      val(copy(argumente,1,pred(pos(' ',argumente))),h,err);
      if err<>0 then begin write(^G);realzahl:=1; end else realzahl:=h;
      delete(argumente,1,pos(' ',argumente));
    end;

  begin
    fsplit(name,dir,nam,ext);
    suche.name:=dir+nam+'.MAT';
    findfirst(dir+nam+'.MAT',$3f,suche);
    if (Doserror<>0) then exit;
    assign(f,dir+nam+'.MAT');
    reset(f);
    while not eof(f) do with mater do begin
      lesezeile;
      if id('TEXTUR') then begin
       realzahl;realzahl;ambc.r:=round(realzahl*63);
       ambc.g:=round(realzahl*63);ambc.b:=round(realzahl*63);
      end else if id('OBERFLCHE') then begin
        ka:=round(realzahl*63);kd:=round(realzahl*63);ks:=round(realzahl*63);
        spec.r:=round(realzahl*63);spec.g:=round(realzahl*63);
        spec.b:=round(realzahl*63);oe:=round(realzahl);
        difc.r:=round(realzahl*63);difc.g:=round(realzahl*63);
        difc.b:=round(realzahl*63);alpha:=round(realzahl*63);
      end;
    end;
    close(f);
    textmaske;
  end;

  procedure readlnvga(var s:namestr;writex,writey,maxl:byte);
  var ein:char;
      y2,l:byte;
  begin
    s:='';
    l:=0;
    repeat
      repeat
        repeat until keypressed;
        while keypressed do ein:=upcase(readkey);
      until ein in [' '..'Z',#13,#8];
      if ein=#8 then begin
        if l>0 then begin
          dec(writex);
          delete(s,length(s),1);
          gotoxy(writex,writey);
          write(' ');
          dec(l);
        end;
      end else begin
        if (l<maxl) and (ein<>#13) then begin
          inc(l);
          s:=s+ein;
          gotoxy(writex,writey);
          write(ein);
          inc(writex);
        end;
      end;
    until ein=#13;
  end;

begin
  maussicht_:=false;
  ende:=false;
  directvideo:=false;
  mausinit(tastenzahl);
  if tastenzahl=0 then begin
    writeln('Ich habe keine Maus gefunden !');
    halt(2);
  end;
  nrp.x:=0;nrp.y:=0;nrp.z:=1;
  vup.x:=0;vup.y:=1;vup.z:=0;
  xmin:=-1.15;ymin:=-1.1;xsize:=2.3;
{  bkcolor.b:=63;}
  grafmode:=-1;
  wireframe:=false;
  init;
  addambls(succ(maxls),true,1,1,1);
  addinfls(succ(maxls),true,1,1,1,-1,-1,-1);
  addinfls(succ(maxls),true,1,1,1,1,-1,-1);
  addposls(succ(maxls),true,1,1,1,        -0.9,0,0.7,1,0);
  setviewglobal(VRP,NRP,VUP,xMin,yMin,xSize,vpd,FPd,bpd);
  maus.mausunsicht;
  xpos:=160;ypos:=100;
  maussetpos(xpos,ypos);
  mausminmaxx(2,maxx-2);
  mausminmaxy(2,maxy-2);
  maske;
  zeichne(0,kugelzeichnen);
  textur(50,50,1,0.9,0.2);
  changesurfacepropertybyte(12,12,21,63,50,30,30,63,50,12,0);
  zeichne(1,kugelzeichnen);
  maussicht;
  repeat
    repeat
      maustastpos(tasten,xpos,ypos);
    until ((xpos<>altx) or (ypos<>alty) or (tasten<>0));
    if ((xpos<>altx) or (ypos<>alty)) then bewegezeiger;
    if (tasten=1) then begin
      if ypos>100 then begin
        if farbabfrage(0,104,mater.ka,mater.ambc) then
         farbabfragemaske(0,104,mater.ka,mater.ambc,matercol.ka,matercol.ambc)
        else if farbabfrage(120,104,mater.kd,mater.difc)
         then farbabfragemaske(120,104,mater.kd,mater.difc,matercol.kd,matercol.difc)
        else if farbabfrage(0,104+8*5,mater.ks,mater.spec)
         then farbabfragemaske(0,104+8*5,mater.ks,mater.spec,matercol.ks,matercol.spec)
        else if paramabfrage(120,104+8*5,mater.oe)
         then paramabfragemaske(120,104+8*5,mater.oe,matercol.oe)
        else if paramabfrage(120,104+8*7,mater.alpha)
         then paramabfragemaske(120,104+8*7,mater.alpha,matercol.alpha)
        else if paramabfrage(120,104+8*9,mater.facetten)
         then paramabfragemaske(120,104+8*9,mater.facetten,matercol.facetten);
      end else begin
        if (xpos<240) then with mater do begin
          textur(50,50,ambc.r/64,ambc.g/64,ambc.b/64);
          changesurfacepropertybyte(ka,kd,ks,spec.r,spec.g,spec.b,
                                oe,difc.r,difc.g,difc.b,alpha);
          zeichne(byte(xpos>120),true);
        end else begin
          if ypos<20 then ende:=true else
          if ypos<36 then load else
          if ypos<52 then save else
          if ypos<68 then begin
            mausunsicht;
            gotoxy(32,8);write('        ');
            while keypressed do readkey;
            readlnvga(name,32,8,8);
            maussicht;
          end;
        end;
      end;
    end;
  until ende;
  mausunsicht;
  while maxls<>-1 do clearls(maxls);
end;

begin
end.