procedure initmesh;
var x:integer;
begin
  if memavail>((sizeof(meshlinetyp)+4)*succ(maxpnts)+freierSpeicher+20)
    then begin
    for x:=0 to maxpnts do new(_wrkarr.m[x]);
    _wrkarr.xmax:=maxpnts;
    _wrkarr.ymax:=maxpnts;
  end else error('Zu wenig Speicherplatz (InitMesh)');
end;

procedure putinmesh(x,y:integer; var crd,nrm:vct3);
begin
  with _wrkarr.m[x]^[y] do begin
    a.crd:=crd;
    a.nrm:=nrm;
    if overwriteFlags then flags:=isvis else begin
      if ((flags and notused)>0) then flags:=notused else flags:=isvis;
    end;
  end;
end;

procedure putnotused(x,y:integer);
begin
  _wrkarr.m[x]^[y].flags:=notused;
end;

procedure clinep(a,b:vct4);
var x1,y1,x2,y2,t:real;

  procedure interpol(t:real;a:vct4; var b:vct4);
  begin
    b.w:=a.w+t*(b.w-a.w);
    b.x:=a.x+t*(b.x-a.x);
    b.y:=a.y+t*(b.y-a.y);
    b.z:=a.z+t*(b.z-a.z);
  end;

  function clipit(g1,g2:real; var a:vct4; var b:vct4):boolean;
  begin
    if g1>0 then if g2<=0 then begin
      t:=g1/(g1-g2);
      interpol(t,a,b);
    end;
    if g2>0 then if g1<=0 then begin
      t:=g2/(g2-g1);
      interpol(t,b,a);
    end;
    clipit:=(g1>0) or (g2>0);
  end;

(*$ifopt b+*)(*$define bplus*)(*$b-*)(*$else*)(*$undef bplus*)(*$endif*)
begin
  if (clipmode=inside) or
     ((clipmode=toclip) and
      (((volclipcode and  1=0) or clipit(a.w-a.y,b.w-b.y,a,b)) and
       ((volclipcode and  2=0) or clipit(    a.y,    b.y,a,b)) and
       ((volclipcode and  4=0) or clipit(a.w-a.x,b.w-b.x,a,b)) and
       ((volclipcode and  8=0) or clipit(    a.x,    b.x,a,b)) and
       ((volclipcode and 16=0) or clipit(a.w-a.z,b.w-b.z,a,b)) and
       ((volclipcode and 32=0) or clipit(    a.z,    b.z,a,b))
      )
     ) then begin
    NPCtoDC(a,x1,y1);
    NPCtoDC(b,x2,y2);
    Line2d(x1,y1,x2,y2);
  end;
end;
(*$ifdef bplus*)(*$b+*)(*$endif*)

procedure defineclipvolume(xm,ym,zm,r,g,b:real);
var a:vct3;
    h:vct4;
    i,out:integer;
    x,y:byte;
begin
  if lichtgesch then begin
    clipmode:=toclip;
    volclipcode:=63;
  end else begin
    updatemats;
    volclipcode:=0;
    out:=0;
    for i:=0 to 7 do begin
      if i and 1=1 then a.x:=-xm else a.x:=xm;
      if i and 2=2 then a.y:=-ym else a.y:=ym;
      if i and 4=4 then a.z:=-zm else a.z:=zm;
      MCtoNPC(a,h);
      if h.y>h.w then volclipcode:=volclipcode or  1 else out:=out or  1;
      if h.y<0   then volclipcode:=volclipcode or  2 else out:=out or  2;
      if h.x>h.w then volclipcode:=volclipcode or  4 else out:=out or  4;
      if h.x<0   then volclipcode:=volclipcode or  8 else out:=out or  8;
      if h.z>h.w then volclipcode:=volclipcode or 16 else out:=out or 16;
      if h.z<0   then volclipcode:=volclipcode or 32 else out:=out or 32;
    end;
    if volclipcode=0 then clipmode:=inside else
    if out<$3F then begin
      clipmode:=outside;
      if keypressed then error('');
    end else clipmode:=toclip;
  end;
  _wrkarr.volume.x:=xm;
  _wrkarr.volume.y:=ym;
  _wrkarr.volume.z:=zm;
  if clipcube and (clipmode<>outside) then begin
    _wrkarr.xmax:=4;
    _wrkarr.ymax:=3;
    for x:=0 to 4 do for y:=0 to 3 do
    with _wrkarr.m[x]^[y].a,_wrkarr do begin
      crd.x:=volume.x*2*(0.5-byte((x>2) or (x=0)));
      crd.y:=volume.y*2*(0.5-byte(y<2));
      crd.z:=volume.z*2*(0.5-byte(((x and 2)=2) or (y=0) or (y=3)));
      nrm.x:=2*(0.5-byte((x>2) or (x=0)));
      nrm.y:=2*(0.5-byte(y<2));
      nrm.z:=2*(0.5-byte(((x and 2)=2) or (y=0) or (y=3)));
      _wrkarr.m[x]^[y].flags:=notused*byte((x>=2) and (y<>1) and (y<>2));
      c.r:=r;c.g:=g;c.b:=b;
    end;
    mesh;
    clipmode:=outside;
  end;
end;

procedure undefclipvolume;
begin
  volclipcode:=$FF;
  clipmode:=toclip;
end;

procedure mesh;
type indarrtyp= array[0..7] of integer;
var i,ind,x,y,xx,yy,pc:integer;
    pol,cpol:array[0..7] of meshpnttyp;
    indarr: indarrtyp;
    b1,b2,b3:boolean;

  procedure MCtoWCifneed(var p:Meshpnttyp);
  begin
    if (p.flags and isinwc)=0 then begin
      if lichtgesch then MCtoWC_vertexlightspeed(P.a,P.a)
                    else MCtoWC_vertex(P.a,P.a);
      P.flags:=p.flags or isInwc;
    end;
  end;

  procedure meshpol;
  var i,cpc:integer;
      prep,aktp,firp:meshpnttyp;
      t,amb,dif,spec:real;
      oldindarr:indarrtyp;

    procedure interpol(var intp,aktp: meshpnttyp);
    begin
      intp.h.w:=prep.h.w+t*(aktp.h.w-prep.h.w);
      intp.h.x:=prep.h.x+t*(aktp.h.x-prep.h.x);
      intp.h.y:=prep.h.y+t*(aktp.h.y-prep.h.y);
      intp.h.z:=prep.h.z+t*(aktp.h.z-prep.h.z);
      MCtoWCifneed(prep);
      MCtoWCifneed(aktp);
      intp.a.crd.x:=prep.a.crd.x+t*(aktp.a.crd.x-prep.a.crd.x);
      intp.a.crd.y:=prep.a.crd.y+t*(aktp.a.crd.y-prep.a.crd.y);
      intp.a.crd.z:=prep.a.crd.z+t*(aktp.a.crd.z-prep.a.crd.z);
      intp.a.nrm.x:=prep.a.nrm.x+t*(aktp.a.nrm.x-prep.a.nrm.x);
      intp.a.nrm.y:=prep.a.nrm.y+t*(aktp.a.nrm.y-prep.a.nrm.y);
      intp.a.nrm.z:=prep.a.nrm.z+t*(aktp.a.nrm.z-prep.a.nrm.z);
      if donorm(intp.a.nrm) then error('Normale durch Clippen=(0,0,0)');
      intp.a.c.r:=prep.a.c.r+t*(aktp.a.c.r-prep.a.c.r);
      intp.a.c.g:=prep.a.c.g+t*(aktp.a.c.g-prep.a.c.g);
      intp.a.c.b:=prep.a.c.b+t*(aktp.a.c.b-prep.a.c.b);
      intp.flags:=isinwc+isinnpc+isvis;
    end;

    procedure doclip(i:integer; g1,g2:real);
    begin
      aktp:=pol[i];
      if i=0 then begin
        firp:=aktp;
        pc:=0;
      end else if ((g1>0) and (g2<=0)) or ((g1<=0) and (g2>0)) then begin
        t:=g1/(g1-g2);
        indarr[pc]:=-1;
        interpol(cpol[pc],aktp);
        inc(pc)
      end;
      prep:=aktp;
      if g2>0 then begin
        cpol[pc]:=aktp;
        indarr[pc]:=oldindarr[i];
        inc(pc);
      end;
    end;

    function lastclip(g1,g2:real):boolean;
    var i:integer;
    begin
      if ((g1>0) and (g2<=0)) or ((g1<=0) and (g2>0)) then begin
        t:=g1/(g1-g2);
        indarr[pc]:=-1;
        interpol(cpol[pc],firp);
        inc(pc);
      end;
      for i:=0 to pred(pc) do pol[i]:=cpol[i];
      oldindarr:=indarr;
      lastclip:=pc=0;
    end;

  begin
    if ((clipmode=outside) or
       (0=  ((pol[0].flags and isvis) + (pol[1].flags and isvis) +
             (pol[2].flags and isvis) + (pol[3].flags and isvis))))
             and (not lichtgesch) then pc:=0
    else begin
      for i:=0 to 3 do with pol[i] do begin
        oldindarr[i]:=i;
        indarr[i]:=i;
        if 0=(flags and isinnpc) then begin
          if lichtgesch then mctonpclightspeed(a.crd,h)
                        else mctonpc(a.crd,h);
          flags:=flags or isinnpc;
        end;
      end;
      if clipmode=toclip then begin
        if volclipcode and 1=1 then begin
          for i:=0 to pred(pc) do
            doclip(i, prep.h.w-prep.h.y, pol[i].h.w-pol[i].h.y);
          if lastclip(prep.h.w-prep.h.y, firp.h.w-firp.h.y) then exit;
        end;
        if volclipcode and 2=2 then begin
          for i:=0 to pred(pc) do
            doclip(i, prep.h.y, pol[i].h.y);
          if lastclip(prep.h.y, firp.h.y) then exit;
        end;
        if volclipcode and 4=4 then begin
          for i:=0 to pred(pc) do
            doclip(i, prep.h.w-prep.h.x, pol[i].h.w-pol[i].h.x);
          if lastclip(prep.h.w-prep.h.x, firp.h.w-firp.h.x) then exit;
        end;
        if volclipcode and 8=8 then begin
          for i:=0 to pred(pc) do
            doclip(i, prep.h.x, pol[i].h.x);
          if lastclip(prep.h.x, firp.h.x) then exit;
        end;
        if volclipcode and 16=16 then begin
          for i:=0 to pred(pc) do
            doclip(i, prep.h.w-prep.h.z, pol[i].h.w-pol[i].h.z);
          if lastclip(prep.h.w-prep.h.z, firp.h.w-firp.h.z) then exit;
        end;
        if volclipcode and 32=32 then begin
          for i:=0 to pred(pc) do
            doclip(i, prep.h.z, pol[i].h.z);
          if lastclip(prep.h.z, firp.h.z) then exit;
        end;
      end;
      for i:=0 to pred(pc) do with pol[i],pol[i].l do begin
        mctowcifneed(pol[i]);
        if 0=(flags and isindc) then begin
          wctodc(a.crd,x,y,z);
          dolight(a,c,z);
          flags:=flags or isindc;
        end;
      end;
      for i:=2 to pred(pc) do filltria(pol[0].l,pol[pred(i)].l,pol[i].l);
    end;
  end;

begin
  updatemats;
  if not (wireframe and flipareaenabled) then
  for x:=0 to _Wrkarr.xmax do
   for y:=0 to _wrkarr.ymax do with _wrkarr.m[x]^[y] do
    flags:=(flags and notused) or byte(flipnormal(a));
  if lichtgesch then calclight;
  if clipmode=inside then begin
    if wireframe then begin
      for x:=0 to pred(_wrkarr.xmax) do begin
        if keypressed then error('');
        for y:=0 to pred(_wrkarr.ymax) do
         if 0=(_wrkarr.m[x]^[y].flags and notused) then begin
          b1:=boolean(_wrkarr.m[x]^[y].flags and isvis);
          b2:=boolean(_wrkarr.m[x]^[succ(y)].flags and isvis);
          b3:=boolean(_wrkarr.m[succ(x)]^[y].flags and isvis);
          if b1 or b2 or b3 then with _wrkarr.m[x]^[y] do begin
            if 0=(flags and isindc) then begin
              mctodci(a.crd,l.x,l.y);
              flags:=flags or isindc;
            end;
          end;
          if b1 or b2 then with _wrkarr.m[x]^[succ(y)] do begin
            if 0=(flags and isindc) then begin
              mctodci(a.crd,l.x,l.y);
              flags:=flags or isindc;
            end;
            map(mapcolor);
            line(_wrkarr.m[x]^[y].l.x,_wrkarr.m[x]^[y].l.y,
                 _wrkarr.m[x]^[succ(y)].l.x,_wrkarr.m[x]^[succ(y)].l.y);
          end;
          if b1 or b3 then with _wrkarr.m[succ(x)]^[y] do begin
            if 0=(flags and isindc) then begin
              mctodci(a.crd,l.x,l.y);
              flags:=flags or isindc;
            end;
            map(mapcolor);
            line(_wrkarr.m[x]^[y].l.x,_wrkarr.m[x]^[y].l.y,
                 _wrkarr.m[succ(x)]^[y].l.x,_wrkarr.m[succ(x)]^[y].l.y);
          end;
        end;
      end;
    end else begin
      for x:=0 to pred(_wrkarr.xmax) do begin
        if keypressed then error('');
        for y:=0 to pred(_wrkarr.ymax) do
         if 0=(_wrkarr.m[x]^[y].flags and notused) then begin
          if 0<>((_wrkarr.m[x]^[y].flags and isvis) +
              (_wrkarr.m[succ(x)]^[y].flags and isvis) +
              (_wrkarr.m[x]^[succ(y)].flags and isvis) +
              (_wrkarr.m[succ(x)]^[succ(y)].flags and isvis)) then begin
            for xx:=0 to 1 do for yy:=0 to 1 do begin
              with _wrkarr.m[x+xx]^[y+yy],_wrkarr.m[x+xx]^[y+yy].l do begin
                if 0=(flags and isinwc) then begin
                  mctowc_vertex(a,a); flags:=flags or isinwc;
                end;
                if 0=(flags and isindc) then begin
                  wctodc(a.crd,x,y,z); dolight(a,c,z); flags:=flags or isindc;
                end;
              end;
            end;
            filltria(_wrkarr.m[x]^[y].l,
                     _wrkarr.m[succ(x)]^[y].l,
                     _wrkarr.m[succ(x)]^[succ(y)].l);
            filltria(_wrkarr.m[x]^[y].l,
                     _wrkarr.m[x]^[succ(y)].l,
                     _wrkarr.m[succ(x)]^[succ(y)].l);
          end;
        end;
      end;
    end;
  end else if clipmode=toclip then begin
    if wireframe then begin
      for x:=0 to pred(_wrkarr.xmax) do begin
        if keypressed then error('');
        for y:=0 to pred(_wrkarr.ymax) do
         if 0=(_wrkarr.m[x]^[y].flags and notused) then begin
          b1:=boolean(_wrkarr.m[x]^[y].flags and isvis);
          b2:=boolean(_wrkarr.m[x]^[succ(y)].flags and isvis);
          b3:=boolean(_wrkarr.m[succ(x)]^[y].flags and isvis);
          if b1 or b2 or b3 then with _wrkarr.m[x]^[y] do begin
            if 0=(flags and isinnpc) then begin
              if lichtgesch then mctonpclightspeed(a.crd,h)
                            else mctonpc(a.crd,h);
              flags:=flags or isinnpc;
            end;
          end;
          if b1 or b2 then with _wrkarr.m[x]^[succ(y)] do begin
            if 0=(flags and isinnpc) then begin
              if lichtgesch then mctonpclightspeed(a.crd,h)
                            else mctonpc(a.crd,h);
              flags:=flags or isinnpc;
            end;
            clinep(_wrkarr.m[x]^[y].h,_wrkarr.m[x]^[succ(y)].h);
          end;
          if b1 or b3 then with _wrkarr.m[succ(x)]^[y] do begin
            if 0=(flags and isinnpc) then begin
              if lichtgesch then mctonpclightspeed(a.crd,h)
                            else mctonpc(a.crd,h);
              flags:=flags or isinnpc;
            end;
            clinep(_wrkarr.m[x]^[y].h,_wrkarr.m[succ(x)]^[y].h);
          end;
        end;
      end;
    end else begin
      for x:=0 to pred(_wrkarr.xmax) do begin
        if keypressed then error('');
        for y:=0 to pred(_wrkarr.ymax) do
         if 0=(_wrkarr.m[x]^[y].flags and notused) then begin
          pol[0]:=_wrkarr.m[x]^[y];
          pol[1]:=_wrkarr.m[x]^[succ(y)];
          pol[2]:=_wrkarr.m[succ(x)]^[succ(y)];
          pol[3]:=_wrkarr.m[succ(x)]^[y];
          pc:=4;
          meshpol;
          for i:=0 to pred(pc) do begin
            ind:=indarr[i];
            if ind<>-1 then begin
              xx:=x+(ind shr 1);
              if (ind<1) or (ind>2) then yy:=y else yy:=succ(y);
              _wrkarr.m[xx]^[yy]:=pol[i];
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure norm(ebene:boolean);
var a,b:vct3;
    betrag:real;
    x,y,x1,y1,x2,y2,x3,y3,x4,y4:integer;
begin
  if ((_wrkarr.xmax>0) and (_wrkarr.ymax>0)) then begin
    for y1:=0 to pred(_wrkarr.ymax) do
    for x1:=0 to pred(_wrkarr.xmax) do with _wrkarr.m[x1]^[y1].h,_wrkarr.m[x1]^[y1].a do begin
      a.x:=_wrkarr.m[succ(x1)]^[y1].a.crd.x-crd.x;
      a.y:=_wrkarr.m[succ(x1)]^[y1].a.crd.y-crd.y;
      a.z:=_wrkarr.m[succ(x1)]^[y1].a.crd.z-crd.z;
      b.x:=_wrkarr.m[x1]^[succ(y1)].a.crd.x-crd.x;
      b.y:=_wrkarr.m[x1]^[succ(y1)].a.crd.y-crd.y;
      b.z:=_wrkarr.m[x1]^[succ(y1)].a.crd.z-crd.z;
      x:=a.y*b.z-a.z*b.y;
      y:=a.z*b.x-a.x*b.z;
      z:=a.x*b.y-a.y*b.x;
      betrag:=sqrt(x*x+y*y+z*z);
      if betrag<>0 then betrag:=1/betrag;
      x:=x*betrag;
      y:=y*betrag;
      z:=z*betrag;
    end;
    with _wrkarr.m[maxpnts]^[maxpnts].h do begin
      x:=0;
      y:=0;
      z:=0;
    end;
    for y:=0 to _wrkarr.ymax do
    for x:=0 to _wrkarr.xmax do begin
      x1:=x;       if (x1=_wrkarr.xmax) then x1:=0;
      y1:=y;       if (y1=_wrkarr.ymax) then y1:=0;
      x2:=x;       if (x2=_wrkarr.xmax) then x2:=0;
      y2:=pred(y); if (y2<0) then y2:=pred(_wrkarr.ymax);
      x3:=pred(x); if (x3<0) then x3:=pred(_wrkarr.xmax);
      y3:=y;       if (y3=_wrkarr.ymax) then y3:=0;
      x4:=pred(x); if (x4<0) then x4:=pred(_wrkarr.xmax);
      y4:=pred(y); if (y4<0) then y4:=pred(_wrkarr.ymax);
      if ebene then begin
        if x=0 then begin
          x3:=maxpnts; y3:=maxpnts; x4:=maxpnts; y4:=maxpnts;
        end;
        if x=_wrkarr.xmax then begin
          x1:=maxpnts; y1:=maxpnts; x2:=maxpnts; y2:=maxpnts;
        end;
        if y=0 then begin
          x2:=maxpnts; y2:=maxpnts; x4:=maxpnts; y4:=maxpnts;
        end;
        if y=_wrkarr.ymax then begin
          x1:=maxpnts; y1:=maxpnts; x3:=maxpnts; y3:=maxpnts;
        end;
      end;
      _wrkarr.m[x]^[y].a.nrm.x:=_wrkarr.m[x1]^[y1].h.x+_wrkarr.m[x2]^[y2].h.x+
                              _wrkarr.m[x3]^[y3].h.x+_wrkarr.m[x4]^[y4].h.x;
      _wrkarr.m[x]^[y].a.nrm.y:=_wrkarr.m[x1]^[y1].h.y+_wrkarr.m[x2]^[y2].h.y+
                              _wrkarr.m[x3]^[y3].h.y+_wrkarr.m[x4]^[y4].h.y;
      _wrkarr.m[x]^[y].a.nrm.z:=_wrkarr.m[x1]^[y1].h.z+_wrkarr.m[x2]^[y2].h.z+
                              _wrkarr.m[x3]^[y3].h.z+_wrkarr.m[x4]^[y4].h.z;
    end;
  end else error('Das Mesh ist zu klein zum Normieren !');
end;

procedure textur(x1,y1:byte;cr,cg,cb:real);
var c:rgb;
    x,y:byte;
begin
  c.r:=cr; c.g:=cg; c.b:=cb;
  if x1>maxpnts then x1:=maxpnts;
  if y1>maxpnts then y1:=maxpnts;
  for y:=0 to y1 do for x:=0 to x1 do begin
    _wrkarr.m[x]^[y].a.c:=c;
  end;
  overwriteflags:=true;
end;

procedure meshextensions(x,y:byte);
begin
  _wrkarr.xmax:=x;
  _wrkarr.ymax:=y;
end;

procedure linie3d(b,e:vct3);
var a,s:vct4;
    c,d:shd_vtx;
begin
  updatemats;
  if lichtgesch then mctonpclightspeed(b,a)
                  else mctonpc(b,a);
    if lichtgesch then mctonpclightspeed(e,s)
                  else mctonpc(e,s);
  if wireframe then clinep(a,s)
  else begin

  end;
end;
