unit objekte;
{$N+}{$E+}
interface
uses dreid;
procedure kugel(n1,n2:integer;r,g,b:real);
procedure torus(r1,r2:real;n1,n2:integer;r,g,b:real);
procedure wuerfel(r,g,b:real);
procedure ebene(n1,n2:integer;r,g,b:real);
procedure zylinder(n1,n2,n3:integer;r,g,b:real);
procedure saule(n1,n2:integer;r,g,b:real);
procedure drawtori(n1,n2:integer);
procedure drawmolecule(n:integer);
procedure drawring(n:integer);
procedure kette(n1,n2:byte);
procedure schachbrett(n1,n2:byte;r1,g1,b1,r2,g2,b2:real);
procedure dreieck(x1,y1,z1,x2,y2,z2,x3,y3,z3:real);
procedure viereck(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:real);

implementation

procedure kugel(n1,n2:integer;r,g,b:real);
var st,ct,sa,ca,
    cth,cah,dct,dst,dca,dsa:real;
    ps,p,pn:vertex;
    a,t:integer;

begin
  defineclipvolume(1,1,1,r,g,b);
  if clipmode<>outside then begin
    _wrkarr.xmax:=n2;
    _wrkarr.ymax:=n1;
    dct:=cos(2*PI/n1); dst:=sqrt(1-dct*dct);
    dca:=cos(2*PI/(2*n2)); dsa:=sqrt(1-dca*dca);
    ca:=dct; sa:=dst; ct:=sa; st:=0.0;
    for a:=1 to pred(n2) do begin
      for t:=0 to n1 do with p do begin
        crd.x:=ct; crd.y:=st; crd.z:=ca;
        nrm:=crd;
        putinmesh(a,t,crd,nrm);
        cth:=ct;
        ct:=ct*dct-st*dst;
        st:=st*dct+cth*dst;
      end;
      cah:=ca;
      ca:=ca*dca-sa*dsa;
      sa:=sa*dca+cah*dsa;
      ct:=sa; st:=0.0;
    end;
    pn.crd:=e_z; pn.nrm:=pn.crd;
    ps.crd:=me_z; ps.nrm:=ps.crd;
    for t:=0 to n1 do begin
      putinmesh(0,t,pn.crd,pn.nrm);
      putinmesh(n2,t,ps.crd,ps.nrm);
    end;
    mesh;
  end;
  undefclipvolume;
end;

procedure torus(r1,r2:real;n1,n2:integer;r,g,b:real);
var cth,cah,dct,dst,st,ct,ct1,st1,dca,dsa,ca,sa: real;
    p: vertex;
    a,t: integer;
begin
  defineclipvolume(r1+r2,r1+r2,r2,r,g,b);
  if clipmode<>outside then begin
    _wrkarr.xmax:=n2;
    _wrkarr.ymax:=n1;
    dct:=cos(2.0*pi/n1);  dst:=sqrt(1.0-(dct*dct));
    dca:=cos(2.0*pi/n2);  dsa:=sqrt(1.0-(dca*dca));
    ca:=r2; sa:=0.0;
    for a:=0 to n2 do begin
      ct:=r1+sa; st:=0.0; ct1:=r1; st1:=0.0;
      for t:=0 to n1 do with p do begin
        crd.x:=ct; crd.y:=st; crd.z:=ca;
        nrm.x:=ct-ct1; nrm.y:=st-st1; nrm.z:=ca;
        putinmesh(a,t,crd,nrm);
        cth:=ct;
        ct:=ct * dct - st * dst;
        st:=st * dct + cth * dst;
        cth:=ct1;
        ct1:=ct1 * dct - st1 * dst;
        st1:=st1 * dct + cth * dst;
      end;
      cah:=ca; ca:=ca*dca-sa*dsa; sa:=sa*dca+cah*dsa;
    end;
    mesh;
  end;
  undefclipvolume;
end;

{rocedure wuerfel(r,g,b:real);
var x,y:byte;
begin
  defineclipvolume(1,1,1,r,g,b);
  if clipmode<>outside then begin
    _wrkarr.xmax:=4;
    _wrkarr.ymax:=3;
    for x:=0 to 4 do for y:=0 to 3 do
    with _wrkarr.m[x]^[y].a,_wrkarr do begin
      crd.x:=volume.x*2*(0.5-byte((x>2) or (x=0)));
      crd.y:=volume.y*2*(0.5-byte(y<2));
      crd.z:=volume.z*2*(0.5-byte(((x and 2)=2) or (y=0) or (y=3)));
      nrm.x:=2*(0.5-byte((x>2) or (x=0)));
      nrm.y:=2*(0.5-byte(y<2));
      nrm.z:=2*(0.5-byte(((x and 2)=2) or (y=0) or (y=3)));
      _wrkarr.m[x]^[y].flags:=byte((x<2) or (y=1) or (y=2));
    end;
    mesh;
  end;
  undefclipvolume;
end;}

procedure wuerfel(r,g,b:real);
var x,y:byte;
    nrm,crd:vct3;
begin
  defineclipvolume(1,1,1,r,g,b);
  if clipmode<>outside then begin
    _wrkarr.xmax:=5;
    _wrkarr.ymax:=3;
    nrm.x:= 0; nrm.y:= 1;nrm.z:= 0; {oben}
    crd.x:=-1; crd.y:= 1;crd.z:=-1;putinmesh(0,0,crd,nrm);
    crd.x:= 1; crd.y:= 1;crd.z:=-1;putinmesh(1,0,crd,nrm);
    crd.x:= 1; crd.y:= 1;crd.z:= 1;putinmesh(1,1,crd,nrm);
    crd.x:=-1; crd.y:= 1;crd.z:= 1;putinmesh(0,1,crd,nrm);
    nrm.x:= 0; nrm.y:= 0;nrm.z:= 1; {vorn}
    crd.x:=-1; crd.y:= 1;crd.z:= 1;putinmesh(2,0,crd,nrm);
    crd.x:= 1; crd.y:= 1;crd.z:= 1;putinmesh(3,0,crd,nrm);
    crd.x:= 1; crd.y:=-1;crd.z:= 1;putinmesh(3,1,crd,nrm);
    crd.x:=-1; crd.y:=-1;crd.z:= 1;putinmesh(2,1,crd,nrm);
    nrm.x:= 1; nrm.y:= 0;nrm.z:= 0; {links}
    crd.x:= 1; crd.y:= 1;crd.z:= 1;putinmesh(4,0,crd,nrm);
    crd.x:= 1; crd.y:= 1;crd.z:=-1;putinmesh(5,0,crd,nrm);
    crd.x:= 1; crd.y:=-1;crd.z:=-1;putinmesh(5,1,crd,nrm);
    crd.x:= 1; crd.y:=-1;crd.z:= 1;putinmesh(4,1,crd,nrm);
    nrm.x:= 0; nrm.y:=-1;nrm.z:= 0; {unten}
    crd.x:=-1; crd.y:=-1;crd.z:= 1;putinmesh(0,2,crd,nrm);
    crd.x:= 1; crd.y:=-1;crd.z:= 1;putinmesh(1,2,crd,nrm);
    crd.x:= 1; crd.y:=-1;crd.z:=-1;putinmesh(1,3,crd,nrm);
    crd.x:=-1; crd.y:=-1;crd.z:=-1;putinmesh(0,3,crd,nrm);
    nrm.x:= 0; nrm.y:= 0;nrm.z:=-1; {hinten}
    crd.x:= 1; crd.y:= 1;crd.z:=-1;putinmesh(2,2,crd,nrm);
    crd.x:=-1; crd.y:= 1;crd.z:=-1;putinmesh(3,2,crd,nrm);
    crd.x:=-1; crd.y:=-1;crd.z:=-1;putinmesh(3,3,crd,nrm);
    crd.x:= 1; crd.y:=-1;crd.z:=-1;putinmesh(2,3,crd,nrm);
    nrm.x:=-1; nrm.y:= 0;nrm.z:= 0; {rechts}
    crd.x:=-1; crd.y:= 1;crd.z:=-1;putinmesh(4,2,crd,nrm);
    crd.x:=-1; crd.y:= 1;crd.z:= 1;putinmesh(5,2,crd,nrm);
    crd.x:=-1; crd.y:=-1;crd.z:= 1;putinmesh(5,3,crd,nrm);
    crd.x:=-1; crd.y:=-1;crd.z:=-1;putinmesh(4,3,crd,nrm);
    for x:=0 to 5 do for y:=0 to 3 do if (x=1) or (x=3) or (y=1) then putnotused(x,y);
    mesh;
  end;
  undefclipvolume;
end;

procedure ebene(n1,n2:integer;r,g,b:real);
var p:vertex;
    x,y:byte;
    xdist,ydist:real;
begin
  defineclipvolume(1,1,0.0000001,r,g,b);
  if clipmode<>outside then with p do begin
    _wrkarr.xmax:=n1;
    _wrkarr.ymax:=n2;
    xdist:=2 / n1;
    ydist:=2 / n2;
    nrm.x:=0;nrm.y:=0;nrm.z:=1; crd.z:=0;
    crd.x:=-1;
    for x:=0 to n1 do begin
      crd.y:=-1;
      for y:=0 to n2 do begin
        putinmesh(x,y,crd,nrm);
        crd.y:=crd.y+ydist;
      end;
      crd.x:=crd.x+xdist;
    end;
    mesh;
  end;
  undefclipvolume;
end;

procedure zylinder(n1,n2,n3:integer;r,g,b:real);
var p:vertex;
    a,t:byte;      {n1:sttzpunkte im kreis;n2:sp von S zu N;n3:sp im deckel}
    dc,ds,st,ct,sn,cn,ch:real;
    crdx,crdy,nrmx,nrmy:real;
begin
  defineclipvolume(1,1,1,r,g,b);
  if clipmode<>outside then with p do begin
    _wrkarr.xmax:=n1;
    _wrkarr.ymax:=n2;
    dc:=cos(2*PI/n1); ds:=sqrt(1-dc*dc);
    for a:=0 to n1 do begin
      if a<=n3 then begin
        crdy:=1; crdx:=a/n3;
      end else if a<(n1-n3) then begin
        crdy:=1-(a-n3)*2/(succ(n1)-2*succ(n3)); crdx:=1;
      end else begin
        crdy:=-1; crdx:=(n1-a)/n3;
      end;
      p.crd.z:=crdy;
      st:=0;
      ct:=crdx;
      for t:=0 to n2 do with p do begin
        p.crd.x:=ct; p.crd.y:=st;
        putinmesh(a,t,crd,nrm);
        ch:=ct;
        ct:=ct*dc-st*ds;
        st:=st*dc+ch*ds;
      end;
    end;
{    dc:=cos(2*PI/n1); ds:=sqrt(1-dc*dc);
    for a:=0 to n2 do begin
      if a<=n3 then begin
        crdy:=1; if a=0 then crdx:=0 else crdx:=n3/a;
        nrmy:=1; if a=n3 then nrmx:=1 else nrmx:=0;
      end else if a<(n2-n3) then begin
        crdx:=1; crdy:=1-(a-n3)*2/(succ(n2)-2*succ(n3));
        nrmx:=1; nrmy:=0;
      end else begin
        crdy:=-1; if n2=a then crdx:=0 else crdx:=n3/(n2-a);
        nrmx:=0; nrmy:=-1;
      end;
      p.crd.z:=crdy;
      p.nrm.z:=nrmy;
      st:=0;
      ct:=crdx;
      sn:=0;
      cn:=nrmx;
      for t:=0 to n1 do with p do begin
        crd.x:=ct; crd.y:=st;
        nrm.x:=cn; nrm.y:=sn;
        putinmesh(a,t,crd,nrm);
        ch:=ct;
        ct:=ct*dc-st*ds;
        st:=st*dc+ch*ds;
        ch:=cn;
        cn:=cn*dc-sn*ds;
        sn:=sn*dc+ch*ds;
      end;
    end;}
    norm(koerper);
    mesh;
  end;
  undefclipvolume;
end;

procedure saule(n1,n2:integer;r,g,b:real);
var p:vertex;
    a,t:byte;      {n1:sttzpunkte im kreis;n2:sp von S zu N}
    dc,ds,st,ct,sn,cn,ch:real;
    crdx,crdy,nrmx,nrmy:real;
begin
  defineclipvolume(-1,1,1,r,g,b);
  if clipmode<>outside then with p do begin
    _wrkarr.xmax:=n1;
    _wrkarr.ymax:=n2;
    dc:=cos(2*PI/n1); ds:=sqrt(1-dc*dc);
    ct:=1{ds};st:=0;
    for a:=0 to n1 do begin
      crd.x:=ct; crd.y:=st;
      for t:=0 to n2 do with p do begin
        crd.z:=2*t/n2-1;
        nrm:=crd;
        nrm.z:=0;
        putinmesh(a,t,crd,nrm);
      end;
      ch:=ct;
      ct:=ct*dc-st*ds;
      st:=st*dc+ch*ds;
    end;
    mesh;
  end;
  undefclipvolume;
end;


{procedure standart(n1,n2:integer;r,g,b:real);
var p:vertex;
    x,y:byte;
begin
  defineclipvolume(1,1,1,r,g,b);
  if clipmode<>outside then with p do begin
    _wrkarr.xmax:=n1;
    _wrkarr.ymax:=n2;

    mesh;
  end;
  undefclipvolume;
end;}

procedure drawtori(n1,n2:integer);
var oldsurfaceproperty:surfacepropertytyp;
begin
  oldsurfaceproperty:=surfaceproperty;
  pushtrafs;
    changesurfaceproperty(0.2,0.8,0.1,1,1,1,20,1,1,1,0);
    textur(n1,n2,1,0,0);
    torus(1,0.2,n1,n2,1,0,0);
    changesurfaceproperty(0.2,0.3,0.3,1,0.9,0.6,20,1,0.9,0.2,0);
    rotate(1,90);
    textur(n1,n2,0,1,0);
    torus(1,0.2,n1,n2,0,1,0);
  copytrafs;
    rotate(2,90);
    changesurfaceproperty(0.1,0.1,0.8,1,1,1,20,1,1,1,0);
    textur(n1,n2,0,0,1);
    torus(1,0.2,n1,n2,0,0,1);
  poptrafs;
  with oldsurfaceproperty do
    changesurfaceproperty(ka,kd,ks,os.r,os.g,os.b,oe,od.r,od.g,od.b,0);
end;

procedure drawmolecule(n:integer);
begin
  pushtrafs;
    scale(0.3,0.3,0.3);
    textur(n,n,1,1,1);
    kugel(n,n,1,1,1);
    pushtrafs;
      rotate(3,45);
      translate(0.0,0.9,0.0);
      scale(0.6,0.6,0.6);
      textur(n,n,1,0,0);
      kugel(n,n,1,0,0);
    copytrafs;
      rotate(3,-45);
      translate(0.0,0.9,0.0);
      scale(0.6,0.6,0.6);
      kugel(n,n,1,0,0);
    poptrafs;
  poptrafs;
end;

procedure drawring(n:integer);
var i:integer;
begin
  for i:=0 to 5 do begin
    rotate(3,60);
    pushtrafs;
      translate(0.0,0.7,0.0);
      drawmolecule(n);
    poptrafs;
  end;
end;

procedure kette(n1,n2:byte);
var i:integer;
    col:byte;
begin
  pushtrafs;
    translate(0.0,0.0,-2.0);
    for i:=0 to 49 do begin
      rotate(3,18);
      translate(0.0,0.0,0.07);
      pushtrafs;
        if not odd(i) then rotate(2,18);
        translate(0.0,1.0,0.0);
        if odd(i) then rotate(1,90);
        textur(n1,n2,i*1/49,(49-i)*1/49,abs(20-i)*1/49);
        torus(0.25,0.07,n1,n2,i*1/49,(49-i)*1/49,abs(20-i)*1/49);
      poptrafs;
    end;
  poptrafs;
end;

procedure schachbrett(n1,n2:byte;r1,g1,b1,r2,g2,b2:real);
var schwarz:boolean;
    x,y:byte;
begin
  if (n1<1) or (n2<1) then error('Schachbrett zu klein!');
  schwarz:=true;
  pushtrafs;
    textur(5,5,r1,g1,b1);
    scale(0.5,0.5,1);
    changesurfaceproperty(0.25,0.3,0.5,1,1,1,50,0.1,0.1,0.1,0);
    translate(-4,-4,0);
    for y:=1 to n1 do begin
      pushtrafs;
        for x:=1 to n2 do begin
          if schwarz then ebene(5,5,r1,g1,b1);
          schwarz:=not schwarz;
          translate(2,0,0);
        end;
      poptrafs;
      translate(0,2,0);
      schwarz:=not schwarz;
    end;
  poptrafs;
  pushtrafs;
    schwarz:=false;
    textur(_wrkarr.xmax,_wrkarr.ymax,r2,g2,b2);
    scale(0.5,0.5,1);
    translate(-4,-4,0);
    changesurfaceproperty(0.1,0.4,0.5,1,1,1,50,0.6,0.6,1,0);
    for y:=1 to n1 do begin
      pushtrafs;
        for x:=1 to n2 do begin
          if schwarz then ebene(5,5,r2,g2,b2);
          schwarz:=not schwarz;
          translate(2,0,0);
        end;
      poptrafs;
      translate(0,2,0);
      schwarz:=not schwarz;
    end;
  poptrafs;
end;

procedure dreieck(x1,y1,z1,x2,y2,z2,x3,y3,z3:real);
var p:vertex;
begin
  p.nrm.x:= (y2-y1)*(z3-z1)-(z2-z1)*(y3-y1);
  p.nrm.y:=-(x2-x1)*(z3-z1)+(z2-z1)*(x3-x1);
  p.nrm.z:= (x2-x1)*(y3-y1)-(y2-y1)*(x3-x1);
  if donorm(p.nrm) then error('Dreieck fehlerhaft');
  p.crd.x:=x1;p.crd.y:=y1;p.crd.z:=z1;
  putinmesh(0,0,p.crd,p.nrm);
  p.crd.x:=x2;p.crd.y:=y2;p.crd.z:=z2;
  putinmesh(0,1,p.crd,p.nrm);
  p.crd.x:=x3;p.crd.y:=y3;p.crd.z:=z3;
  putinmesh(1,0,p.crd,p.nrm);
  putinmesh(1,1,p.crd,p.nrm);
  _wrkarr.xmax:=1;
  _wrkarr.ymax:=1;
  mesh;
end;

procedure viereck(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:real);
var p:vertex;
begin
  p.nrm.x:= (y2-y1)*(z3-z1)-(z2-z1)*(y3-y1);
  p.nrm.y:=-(x2-x1)*(z3-z1)+(z2-z1)*(x3-x1);
  p.nrm.z:= (x2-x1)*(y3-y1)-(y2-y1)*(x3-x1);
  if donorm(p.nrm) then error('Viereck fehlerhaft');
  p.crd.x:=x1;p.crd.y:=y1;p.crd.z:=z1;
  putinmesh(0,0,p.crd,p.nrm);
  p.crd.x:=x2;p.crd.y:=y2;p.crd.z:=z2;
  putinmesh(0,1,p.crd,p.nrm);
  p.crd.x:=x3;p.crd.y:=y3;p.crd.z:=z3;
  putinmesh(1,1,p.crd,p.nrm);
  p.crd.x:=x4;p.crd.y:=y4;p.crd.z:=z4;
  putinmesh(1,0,p.crd,p.nrm);
  _wrkarr.xmax:=1;
  _wrkarr.ymax:=1;
  mesh;
end;

end.