unit upic;
interface
uses dos,ems,vga;
const TrueColor=0;
      NormalPal=1;
      RGBPal=2;
      SW256Pal=3;
      Pal3D=4;
      SCQSave=8;
      header:array[0..15] of char=('W','i','z','A','r','t',' ','P','i','c','t','u','r','e',#$00,#$1A);
type PByte=^Byte;
     PRGB=^TRGB;
     TRGB=array[0..2] of byte;

procedure savebild(name:pathstr;grafikmodus:integer;brille:boolean;farbig:byte);
function GetEMSVideoRAM(x,y:word;hintergrund:byte):boolean;
function GetEMSVideoTrueColor(x,y:word;hintergrund:TRGB):boolean;
function GetEMSPunktRAM(x,y:word):PByte;
function GetEMSPunktTrueColor(x,y:word):PRGB;
procedure CloseEMSVideo;

implementation
var EMSVideoHandle:word;
    EMSVideoPages:word;
    EMSVideobufbegin:longint;
    EMSVideoGrose:longint;
    EMSVideoModus:boolean;
    xmax,ymax:word;
const useEMSVideo:boolean=false;
      EMSVideoOn:boolean=false;
      ModusRam=true;
      ModusTrueColor=false;

procedure savebild(name:pathstr;grafikmodus:integer;brille:boolean;farbig:byte);
var f:file;
    n:byte;
    palnr:byte;
    dir:dirstr;
    nam:namestr;
    ext:extstr;
    page:word;
begin
  fsplit(name,dir,nam,ext);
  assign(f,dir+nam+'.PIC');
  rewrite(f,1);
  blockwrite(f,header,sizeof(header));
  if brille then palnr:=3 else palnr:=farbig;
  if Modustruecolor=EMSVideoModus then palnr:=0 else palnr:=succ(palnr);
  if (not emsvideoon) then begin
    if (grafikmodus=-2) then begin
      palnr:=palnr or SCQSave;
      xmax:=360;
      ymax:=480;
    end;
    if (grafikmodus=-1) then begin
      xmax:=320;
      ymax:=200;
    end;
  end;
  blockwrite(f,palnr,sizeof(palnr));
  blockwrite(f,xmax,sizeof(xmax));
  blockwrite(f,ymax,sizeof(ymax));
  if emsvideoon then begin
    for page:=0 to pred(EMSVideoPages) do begin
      mappage(emsvideohandle,page,2);
      if page<>pred(EMSVideoPages) then blockwrite(f,mem[emsframeaddr:$8000],$4000)
      else blockwrite(f,mem[emsframeaddr:$8000],EMSVideoGrose-pred(EMSVideoPages)*$4000);
    end;
  end else begin
    case grafikmodus of
    -1:blockwrite(f,mem[$A000:0],64000);
    -2:begin
         for n:=0 to 3 do begin
           readmap(n);
           blockwrite(f,mem[$A000:0],43200);
         end;
       end;
    end;
  end;
  close(f);
end;

function GetEMSVideoRAM(x,y:word;hintergrund:byte):boolean;
var i:integer;
    availpages:word;
    ok:boolean;
    page:word;
    pages:byte;
begin
  ok:=false;
  if emmavail then begin
    i:=0;
    emsmemory(EMSVideopages,availpages);
    inc(i,emmresult);
    emsvideogrose:=succ(longint(x))*succ(longint(y));
    EMSVideoPages:=(emsvideogrose+$3FFF) div $4000;
    if availpages>=EMSVideoPages then begin
      Writeln('Belege ',EMSVideoPages,' Seiten EMS Speicher zu 16kB');
      emsVideohandle:=allocatepages(EMSVideoPages);
      inc(i,emmresult);
      for page:=0 to pred(EMSVideoPages) do begin
        mappage(EMSVideoHandle,page,2);
        inc(i,emmresult);
        fillchar(mem[emsframeaddr:$8000],$4000,hintergrund);
      end;
      if EMSVideoPages>2 then pages:=2 else pages:=EMSVideoPages;
      for page:=0 to pred(pages) do mappage(EMSVideoHandle,page,page+2);
      inc(i,emmresult);
      emsVideobufbegin:=0;
      useemsVideo:=true;
      EMSVideoModus:=Modusram;
      ok:=i=0;
      EMSVideoOn:=ok;
    end;
  end;
  getemsvideoRam:=ok;
  xmax:=succ(x);
  ymax:=succ(y);
end;

function GetEMSVideoTrueColor(x,y:word;hintergrund:TRGB):boolean;
var i:integer;
    availpages:word;
    ok:boolean;
    pages,offset,m:byte;
    page,n:word;
begin
  ok:=false;
  if emmavail then begin
    i:=0;
    emsmemory(EMSVideopages,availpages);
    inc(i,emmresult);
    emsvideogrose:=succ(longint(x))*succ(longint(y))*3;
    EMSVideoPages:=(EMSVideoGrose+$3FFF) div $4000;
    if availpages>=EMSVideoPages then begin
      Writeln('Belege ',EMSVideoPages,' Seiten EMS Speicher zu 16kB');
      emsVideohandle:=allocatepages(EMSVideoPages);
      inc(i,emmresult);
      offset:=0;
      for page:=0 to pred(EMSVideoPages) do begin
        mappage(EMSVideoHandle,page,2);
        inc(i,emmresult);
        for n:=0 to pred($4000 div 3) do begin
          for m:=0 to 2 do mem[emsframeaddr:$8000+n*3+offset+m]:=Hintergrund[m];
        end;
        case offset of
          0:begin
              for m:=0 to 2 do mem[emsframeaddr:$8000+($4000 div 3)*3+m]:=Hintergrund[m];
              mem[emsframeaddr:$8000+succ($4000 div 3)*3]:=Hintergrund[0];
              offset:=2;
            end;
          2:begin
              move(Hintergrund[1],mem[emsframeaddr:$8000],2);
              move(Hintergrund,mem[emsframeaddr:$8000+pred(succ($4000 div 3)*3)],2);
              offset:=1;
            end;
          1:begin
              mem[emsframeaddr:$8000]:=Hintergrund[2];
              move(Hintergrund,mem[emsframeaddr:$8000+(succ($4000 div 3)*3)-2],3);
              offset:=0;
            end;
        end;
      end;
      if EMSVideoPages>2 then pages:=2 else pages:=EMSVideoPages;
      for page:=0 to pred(pages) do mappage(EMSVideoHandle,page,page+2);
      inc(i,emmresult);
      emsVideobufbegin:=0;
      useemsVideo:=true;
      EMSVideoModus:=ModusTrueColor;
      ok:=i=0;
      EMSVideoOn:=ok;
    end;
  end;
  getemsvideoTrueColor:=ok;
  xmax:=succ(x);
  ymax:=succ(y);
end;

procedure CloseEMSVideo;
begin
  if EMSVideoOn then begin
    restorepagemap(emsvideohandle);
    deallocatepages(emsvideohandle);
    EMSVideoOn:=false;
  end;
end;

function GetEMSPunktRAM(x,y:word):PByte;{x=0..pred(xmax);y=0..pred(ymax)}
var bytenr,offset:longint;
    page:word;
    emsbegin:integer;
begin
  bytenr:=longint(y)*longint(xmax)+longint(x);
  offset:=bytenr-emsvideobufbegin;
  if (offset>=0) and (offset<=$7FFF-xmax) then
    GetEMSPunktRAM:=@mem[emsframeaddr:$8000+offset]
  else begin
    emsbegin:=bytenr div $4000;
    if emsbegin+{pred(pages)}1>=EMSVideoPages then emsbegin:=EMSVideoPages-1{pred(pages)};
    if emsbegin>0 then dec(emsbegin);
    if emsbegin<0 then emsbegin:=0;
    for page:=0 to {pred(pages)}1 do mappage(EMSVideoHandle,emsbegin+page,page+2);
    EMSVideoBufBegin:=longint(emsbegin)*$4000;
    GetEMSPunktRAM:=@mem[emsframeaddr:bytenr-EMSVideoBufBegin+$8000];
  end;
end;

function GetEMSPunktTrueColor(x,y:word):PRGB;
var bytenr,offset:longint;
    page:word;
    emsbegin:integer;
begin
  bytenr:=(longint(y)*longint(xmax)+longint(x))*3;
  offset:=bytenr-emsvideobufbegin;
  if (offset>=6) and (offset<=$7FFF-6-xmax) then
    GetEMSPunktTrueColor:=@mem[emsframeaddr:$8000+offset]
  else begin
    emsbegin:=bytenr div $4000;
    if emsbegin+{pred(pages)}1>=EMSVideoPages then emsbegin:=EMSVideoPages-1{pred(pages)};
    if emsbegin>0 then dec(emsbegin);
    if emsbegin<0 then emsbegin:=0;
    for page:=0 to {pred(pages)}1 do mappage(EMSVideoHandle,emsbegin+page,page+2);
    EMSVideoBufBegin:=longint(emsbegin)*$4000;
    GetEMSPunktTrueColor:=@mem[emsframeaddr:bytenr-EMSVideoBufBegin+$8000];
  end;
end;

end.