program zeichensatz;
uses mausb,crt,dos;
type zeichensatztyp=array[0..255,1..16] of byte;
     ptrtyp = record
                case boolean of
                  true: (p:pointer);
                  false: (offs,segm:word);
                end;
var zs:zeichensatztyp;
    zsdatei:file of zeichensatztyp;
    zsname:namestr;
    aktzeichen:byte;
    ein:char;
    mausx,mausy,tasten:integer;
    verandert:boolean;

procedure setblockspecifier(bl:byte);
var regs:registers;
begin
  regs.ax:=$1103;regs.bl:=bl;
  intr($10,regs);
end;

{function bildschirm_information(zsnummer:byte):pointer;

var hilfptr:ptrtyp;
    regs:registers;
begin
  with regs do begin
    ax:=$1130;bl:=zsnummer;
    intr($10,regs);
    hilfptr.segm:=es;
    hilfptr.offs:=bp+256*8+256*14-3+19*16;
  end;
  bildschirm_information:=hilfptr.p;
end;}

procedure ladetextuserzs;
var regs:registers;
    hilfptr:ptrtyp;
begin
  with regs do begin
    hilfptr.p:=@zs;
    ax:=$1100;bh:=16;bl:=3;cx:=256;dx:=0;
    es:=hilfptr.segm;bp:=hilfptr.offs;
    intr($10,regs);
  end;
end;

procedure ladezeichen(nummer:byte);
var regs:registers;
    hilfptr:ptrtyp;
begin
  with regs do begin
    hilfptr.p:=@zs;
    ax:=$1100;bh:=16;bl:=3;cx:=1;dx:=nummer;
    es:=hilfptr.segm;bp:=hilfptr.offs+16*nummer;
    intr($10,regs);
  end;
end;

procedure print(x,y:byte;zeichen:char;attribut:byte);
begin
  memw[$b800:y*160+x*2]:=byte(zeichen)+attribut*256;
end;

procedure attribut(x,y,attrib:byte);
begin
  mem[$b800:succ(y*160+x*2)]:=attrib;
end;

procedure bildschirminit;
var zahler,x,y:byte;
begin
  textbackground(blue);
  textcolor(green);
  clrscr;
  gotoxy(25,1);
  textcolor(magenta);
  writeln('*** Zeichensatz Editor ***');
  textcolor(green);
  write('A) Name des Aktuellen Zeichensatzes: ');
  textcolor(red);
  writeln(zsname+'.ZS');
  textcolor(green);
  writeln('B) Zeichensatz laden');
  writeln('C) Zeichensatz sichern');
  writeln('D) Lsche Zeichen        E) Kopiere Zeichen');
  writeln('F) Ende');
  writeln('Mit Cursortaste Buchstabe aussuchen, mit Maus edieren');
                         writeln('Ŀ');
  for zahler:=1 to 16 do if (zahler=3) or (zahler=6) or (zahler=12) then
                         writeln('        ') else
                         writeln('        ');
                         write  ('');
  x:=11;y:=8;
  for zahler:=0 to 255 do begin
    print(x,y,char(zahler),30);
    x:=x+2;
    if x>=79 then begin
      y:=y+2;
      x:=11;
    end;
  end;
end;

function bin(a:byte):string;
const
  d:array [0..1] of char = ' ';
var zahler : byte;
    hilf : string[8];
begin
  for zahler:=7 downto 0 do hilf[8-zahler]:=d[((a shr zahler) and 1)];
  hilf[0] := chr(8);
  bin:=hilf;
end;

procedure zeichen(z:byte);
var zahler:byte;
begin
  if verandert then ladezeichen(aktzeichen);
  verandert:=false;
  attribut(11+(aktzeichen mod 34)*2,8+(aktzeichen div 33)*2,30);
  aktzeichen:=z;
  attribut(11+(aktzeichen mod 34)*2,8+(aktzeichen div 33)*2,31);
  mausunsicht;
  for zahler:=1 to 16 do begin
    gotoxy(2,8+zahler);
    writeln(bin(zs[z,zahler]));
  end;
  maussicht;
end;

procedure edit;
var x,y:byte;
begin
  verandert:=true;
  x:=mausx-2;
  y:=mausy-8;
  case tasten of
  1:begin
      zs[aktzeichen,Y]:=zs[aktzeichen,y] or ($80 shr x);
      print(pred(mausx),pred(mausy),'',green+16);
    end;
  2:begin
      zs[aktzeichen,Y]:=zs[aktzeichen,y] and ($ff xor ($80 shr x));
      print(pred(mausx),pred(mausy),' ',green+16);
    end;
  end;
end;

procedure mausinitialisation;
var vorhanden:boolean;
    tasten:word;
begin
  mausinit(vorhanden,tasten);
  if not vorhanden then begin
    textcolor(red+blink);
    writeln('Keine Maus gefunden !',^G);
    halt(1);
  end;
  maustextcursor(1,1,5);
  maussicht;
end;

procedure sichern;
begin
  if zsname='ROM_8x16' then zsname:='Zeichens';
  assign(zsdatei,zsname+'.ZS');
  rewrite(zsdatei);
  write(zsdatei,zs);
  close(zsdatei);
end;

procedure laden;
begin
  assign(zsdatei,zsname+'.ZS');
  reset(zsdatei);
  read(zsdatei,zs);
  close(zsdatei);
  zeichen(aktzeichen);
  ladetextuserzs;
end;

procedure zsnameneu;
begin
  mausunsicht;
  textcolor(red);
  repeat
    gotoxy(38,2);
    readln(zsname);
    while zsname[1]=' ' do delete(zsname,1,1);
    if pos(' ',zsname)>0 then zsname:=copy(zsname,1,pos(' ',zsname));
    if length(zsname)>8 then zsname:=copy(zsname,1,8);
  until zsname<>'';
  gotoxy(38,2);
  write(zsname,'.ZS         ');
  textcolor(green);
  maussicht;
end;

procedure loesche;
var zahler:byte;
begin
  for zahler:=1 to 16 do zs[aktzeichen,zahler]:=0;
  verandert:=true;
  zeichen(aktzeichen);
end;

procedure kopiere;
var z,zahler:byte;
begin
  repeat until not mauskeypressed;
  for z:=1 to 10 do begin
    sound(z*100);delay(10);
  end;
  nosound;
  repeat until mauskeypressed;
  mausgetstatus(mausx,mausy,tasten,true);
  z:=((mausx-11)div 2)+((mausy-8) div 2)*34;
  for zahler:=1 to 16 do zs[aktzeichen,zahler]:=zs[z,zahler];
  verandert:=true;
end;

begin
  zsname:='ROM_8x16';
  laden;
  ladetextuserzs;
  setblockspecifier($0C);
  bildschirminit;
  mausinitialisation;
  aktzeichen:=0;
  verandert:=false;
  zeichen(0);
  repeat
    repeat until keypressed or mauskeypressed;
    while keypressed do ein:=upcase(readkey);
    mausgetstatus(mausx,mausy,tasten,true);
    if (mausx>=11) and (mausy>=8) then zeichen(((mausx-11)div 2)+((mausy-8) div 2)*34);
    if (mausx<10) and (mausy>8) and (mausx>1) and (mausy<25) then edit;
    if (mausy=4) or (ein='C') then sichern;
    if (mausy=3) or (ein='B') then laden;
    if (mausy=2) or (ein='A') then zsnameneu;
    if ((mausy=5) and (mausx<24)) or (ein='D') or (tasten=3) then loesche;
    if ((mausy=5) and (mausx>24)) or (ein='E') then kopiere;
  until (ein='F') or (mausy=6);
  mausunsicht;
  clrscr;
end.