program MagicPictures;
uses crt,dos,graph;
const maxx:word=639;
      maxy:word=479;
      maxc:integer=15;
      rep:integer=70;
      maxl=100;
      dots:integer=1;
      colrange:byte=1;
      tiefe:integer=14;
Type PByteArray=^TByteArray;
     TByteArray=array[0..65534] of byte;

     PZbuf=^TZBuf;
     TZBuf=object
       dy,ny,bufx,bufy:word;
       qx,qy,tiefe:byte;
       list:array[0..maxl] of PByteArray;
       constructor init(ax,ay:word;atiefe:byte);
       constructor Lade(ax,ay:word;name:pathstr;atiefe:byte);
       destructor done;
       procedure PutPixel(ax,ay:word;c:byte);
       function GetPixel(ax,ay:word):shortint;
       procedure demo;
     end;

     PMagic=^TMagic;
     TMagic=object
       ZBuf:TZBuf;
       start,anf,ende:integer;
       maxx,maxy,maxc,rep:word;
       dots:boolean;
       zufall:boolean;
       grafikart:byte;
       constructor init(zname,bname:pathstr;amaxx,amaxy,amaxc,arep:word;atiefe:byte);
       destructor done;
       procedure run;
       procedure Grafikan;
       procedure Grafikaus;
       procedure lademaske(name:pathstr);
       procedure zufallsmaske;
       procedure zufallslinie(x1,x2,y:word);
       {procedure PutPixel(x,y:word;c:byte);
       function GetPixel(x,y:word):byte;}
       procedure HelpDots(r:byte);
       procedure save(name:pathstr);
     end;

{*** TZbuf ***}

constructor TZBuf.init(ax,ay:word;atiefe:byte);
var n:word;
begin
  tiefe:=atiefe;
  bufx:=ax;
  bufy:=ay;
  qx:=1;
  qy:=1;
  dy:=65536 div succ(maxx);
  ny:=succ(succ(maxy) div dy);
  for n:=0 to pred(ny) do begin
    getmem(list[n],dy*succ(maxx));
    fillchar(list[n]^,dy*succ(maxx),#0);
  end;
end;

constructor TZBuf.Lade(ax,ay:word;name:pathstr;atiefe:byte);
var f:file;
    s:searchrec;
    n,lese:word;
    l:longint;
    typ:byte;
    err:boolean;
type THeader=array[0..15] of char;
const Header:THeader=('W','i','z','A','r','t',' ','P','i','c','t','u','r','e',#$00,#$1A);
var head:Theader;
begin
  tiefe:=atiefe;
  s.name:=name;
  findfirst(name,anyfile,s);
  if doserror<>0 then begin
    writeln('Datei ',name,' nicht gefunden');
    halt(1);
  end;
  l:=s.size;
  assign(f,name);
  reset(f,1);
  blockread(f,head,sizeof(head));
  err:=false;
  for n:=0 to 15 do err:=err or (head[n]<>header[n]);
  blockread(f,typ,1);
  if err or (typ<>3) then begin
    writeln('Datei ',name,' keine WizArt Tiefendatei!');
    halt(1);
  end;
  blockread(f,bufx,2);
  blockread(f,bufy,2);
  qx:=succ(ax) div bufx;
  qy:=succ(ay) div bufy;
  bufx:=pred(bufx);
  bufy:=pred(bufy);
  dy:=65536 div succ(bufx);
  ny:=succ(succ(bufy) div dy);
  writeln('Lade ',name);
  for n:=0 to pred(ny) do begin
    getmem(list[n],dy*succ(bufx));
    if dy*succ(bufx)<l then lese:=dy*succ(bufx) else lese:=l;
    blockread(f,list[n]^,lese);
    dec(l,lese);
  end;
  close(f);
end;

destructor TZbuf.Done;
var n:word;
begin
  for n:=0 to pred(ny) do freemem(list[n],dy*succ(bufx));
end;

Procedure TZBuf.PutPixel(ax,ay:word;c:byte);
begin
  list[ay div dy]^[(ay mod dy)*succ(bufx)+ax]:=c;
end;

Function TZBuf.GetPixel(ax,ay:word):shortint;
var {h2,}h:byte;
begin
  ay:=ay div qy;
  h:=list[ay div dy]^[(ay mod dy)*succ(bufx)+(ax div qx)];
  {if random(h mod 4)>1 then h2:=1 else h2:=0;}
  GetPixel:=-shortint((h div tiefe){+h2});
end;

Procedure TZBuf.demo;
var r,dx,dey,x,y:word;
    w:byte;
begin
  write('berechne Demo Zeile   0');
  dx:=bufx div 2;
  dey:=bufy div 2;
  for y:=0 to bufy do begin
    gotoxy(wherex-3,wherey);write(y:3);
    for x:=0 to bufx do begin
      r:=(sqr((x-dx) div 16)+sqr((y-dey) div 16));
      {putpixel(x,y,32-round(16*sin(sqrt(r)/50)));}
      putpixel(x,y,32-(r div 10));
    end;
  end;
end;

{--- Ende TZBuf ---}

{*** TMagic ***}

constructor TMagic.Init(zname,bname:pathstr;amaxx,amaxy,amaxc,arep:word;atiefe:byte);
begin
  maxx:=amaxx;
  maxy:=amaxy;
  maxc:=amaxc;
  rep:=arep;
  anf:=(succ(maxx)-rep) div 2;
  start:=anf;
  ende:=anf+rep;
  if zname='' then begin
    ZBuf.Init(amaxx,amaxy,atiefe);
    ZBuf.Demo
  end else ZBuf.Lade(amaxx,amaxy,zname,atiefe);
  grafikan;
  zufall:=(bname='');
  if zufall then zufallsmaske else LadeMaske(BName);
end;

destructor TMagic.Done;
begin
  ZBuf.Done;
  grafikaus;
end;

procedure TMagic.run;
var x,y,hx:integer;

  procedure linie(x1,x2,y:integer;anf:boolean);
  begin
    if zufall then zufallslinie(succ(x1),pred(x2),y)
    else begin
      if anf then setcolor(getpixel(x2,y)) else setcolor(getpixel(x1,y));
      line(succ(x1),y,pred(x2),y)
    end;
  end;

begin
  for y:=0 to maxy do begin
    if keypressed then exit;
    anf:=start;ende:=start+rep;
    for x:=start to maxx do begin
      hx:=x+rep+ZBuf.Getpixel(x,y);
      if hx<=maxx then begin
        if hx>succ(ende) then linie(ende,hx,y,false);
        ende:=hx;
        putpixel(hx,y,getpixel(x,y));
      end;
    end;
    if ende<maxx then linie(ende,succ(maxx),y,false);
    for x:=start+rep downto 0 do begin
      hx:=x-rep-ZBuf.Getpixel(x-rep,y);
      if hx>=0 then begin
        if hx<pred(anf) then linie(hx,anf,y,true);
        anf:=hx;
        putpixel(hx,y,getpixel(x,y));
      end;
    end;
    if anf<>0 then linie(-1,anf,y,true);
  end;
end;

procedure TMagic.HelpDots(r:byte);
begin
  setfillstyle(solidfill,black);
  pieslice(start,maxy div 2,0,360,r);
  pieslice(start+rep+ZBuf.Getpixel(start,maxy div 2),maxy div 2,0,360,r);
  write(^g);
end;

{$L EGAVGA}
procedure EGAVGAdriver;external;

procedure TMagic.Grafikan;
var gd,gm:integer;
begin
  if (maxx=639) and (maxy=479) and (maxc<=15) then begin
    if (registerbgidriver(@EGAVGAdriver)<0) then begin
       writeln('Fehler beim Anmelden der Grafiktreiber!');
       halt(1);
    end;
    detectgraph(gd,gm);
    if gd<>vga then begin
       writeln('Keine VGA gefunden!');
       halt(1);
    end;
    initgraph(gd,gm,'');
    grafikart:=0;
    if maxc=1 then colrange:=15;
  end else begin
    grafikart:=255;
    writeln('Grafikmodus (',maxx,'/',maxy,'/',maxc,') nicht verfgbar !');
    halt(1);
  end;
end;

procedure TMagic.Grafikaus;
begin
  if grafikart=0 then closegraph;
end;

procedure TMagic.lademaske(name:pathstr);
var s:searchrec;
    n:byte;
    f:file;

  procedure map(mask:byte);
  begin
    port[$3c4]:=2;
    port[$3c5]:=mask;
  end;

begin
  s.name:=name;
  findfirst(name,anyfile,s);
  if doserror<>0 then begin
    closegraph;
    writeln('Datei ',name,' nicht gefunden');
    halt(1);
  end;
  assign(f,name);
  reset(f,1);
  for n:=0 to 3 do begin
    map(1 shl n);
    blockread(f,mem[$a000:0],38400);
  end;
  close(f);
end;

procedure TMagic.zufallsmaske;
var y,x:word;
begin
  for x:=start to start+rep do for y:=0 to maxy do putpixel(x,y,colrange*random(succ(maxc)));
end;

procedure TMagic.zufallslinie(x1,x2,y:word);
var x:word;
begin
  if (x1<=x2) then
  for x:=x1 to x2 do putpixel(x,y,colrange*random(succ(maxc))) else write(^G);
end;
{
procedure TMagic.putpixel(x,y:word;c:byte);
begin
  graph.putpixel(x,y,c);
end;

function TMagic.GetPixel(x,y:word):byte;
begin
  getpixel:=graph.getpixel(x,y);
end;
}
procedure TMagic.save(name:pathstr);
begin
end;

{--- Ende TMagic ---}

var Magic:TMagic;
    zname,bname:pathstr;
    n:byte;
    s:string;
    error:boolean;

  procedure getzahl(s:string;var z:integer;min,max:integer);
  var err,h:integer;
  begin
    val(s,h,err);
    if (err=0) and (h>=min) and (h<=max) then z:=h;
  end;

  procedure anleitung;
  var out:text;
  begin
    assign(out,'');
    rewrite(out);
    writeln(out);
    writeln(out,' *** Magic Pictures ***');
    writeln(out);
    writeln(out,'Dieses Programm erstellt rumliche Illusionsbilder.');
    writeln(out,'Halten Sie Ihr Gesicht dicht vor den Bildschirm und schauen Sie');
    writeln(out,'durch Ihn hindurch ins unendliche. Dadurch schielen Sie nach');
    writeln(out,'auen und die Fixierhilfpunkte wandern in die Mitte. (Sie sehen');
    writeln(out,'dann drei Punkte.) Entfernen Sie nun Ihr Gesicht langsam vom');
    writeln(out,'Bildschirm. Nun sollte ein dreidimensionales Bild vor Ihnen');
    writeln(out,'auftauchen.');
    writeln(out,'');
    writeln(out,'MagicPic braucht eine Tiefendatei, die die Tiefe jedes Punktes von 0 bis 255');
    writeln(out,'enthlt. Solche Dateien werden z.B. vom CAD-System WizArt erstellt.');
    writeln(out,'Auerdem kann eine Maskendatei verwendet werden, die 640*480*16');
    writeln(out,'Bildpunkte Bitplaneweise enthalten mu. Dies wird z.B. durch GetMaske erstellt.');
    writeln(out);
    writeln(out,'Parameter');
    writeln(out);
    writeln(out,'Z=Tiefendateiname');
    writeln(out,'B=Maskenbilddateiname');
    writeln(out,'C=Farbanzahl [15] (1..15)');
    writeln(out,'H=Fixierhilfe an,aus [1] (1,0)');
    writeln(out,'R=Periodenbreite [70] (1,640)');
    writeln(out,'T=Bildtiefe [14] (1,255)');
    close(out);
  end;

begin
  zname:='';
  bname:='';
  error:=false;
  if paramcount>0 then for n:=1 to paramcount do begin
    s:=paramstr(n);
    if s[2]='=' then begin
      case upcase(s[1]) of
      'Z':zname:=copy(s,3,255);
      'B':bname:=copy(s,3,255);
      'R':getzahl(copy(s,3,255),rep,1,maxx);
      'C':getzahl(copy(s,3,255),maxc,0,15);
      'H':getzahl(copy(s,3,255),dots,0,1);
      'T':getzahl(copy(s,3,255),tiefe,1,255);
      else error:=true;
      end;
    end else error:=true;
  end else anleitung;
  if error then anleitung;
  Magic.Init(zname,bname,maxx,maxy,maxc,rep,tiefe);
  Magic.Run;
  if dots=1 then Magic.HelpDots(5);
  write(^g);
  while keypressed do readkey;
  repeat until keypressed;
  while keypressed do readkey;
  Magic.Done;
end.