unit Matrizen;
interface
Type P3DPoint= ^T3DPoint;
     T3dPoint=record x,y,z:single; end;
     P3DRect=^T3dRect;
     T3DRect=record T,R,S:T3DPoint; end;
     PMatrix=^TMatrix;
     TMatrix=array[0..3,1..3] of single;
     PKoorSys=^TKoorSys;
     TKoorSys=array[0..6] of T3DPoint;

{           W X Y Z Ergebnis
         T  1 0 0 0
         x  0 1 0 0
         y  0 0 1 0
         z  0 0 0 1}

const Matrix3d:TMatrix=((0,0,0),
                        (1,0,0),
                        (0,-1,0),
                        (-0.5,+0.5,1));
      yzMatrix:TMatrix=((0,0,0),
                        (0,0,0),
                        (0,-1,0),
                        (-1,0,1));
      xzMatrix:TMatrix=((0,0,0),
                        (1,0,0),
                        (0,0,0),
                        (0,1,1));
      xyMatrix:TMatrix=((0,0,0),
                        (1,0,0),
                        (0,-1,0),
                        (0,0,1));
      e:TMatrix=((0,0,0),
                 (1,0,0),
                 (0,1,0),
                 (0,0,1));
      e3DRect:T3DRect=(T:(x:0;y:0;z:0);
                       R:(x:0;y:0;z:0);
                       S:(x:1;y:1;z:1));

procedure Rotate(achse:integer;w:real);
procedure translate(t:T3DPoint);
procedure Scale(s:T3DPoint);
procedure SetMC_WC(var AMC_WC:TMatrix);
procedure CalcMC_WC(var AMC_WC:TMatrix;pos:T3DRect);
procedure CalcPos(AMC_WC:TMatrix;var pos:T3DRect);
procedure CalcPoint(a:T3DPoint;var b:T3DPoint);
procedure CalcKoorSys(var KoorSys:TKoorSys);
procedure CalcWC_DC(var AWC_DC:TMatrix;xmin,ymin,zoom:single;breite,hohe:word);
procedure SetWC_DC(var AWC_DC:TMatrix);
procedure PushTrafs;
Procedure PopTrafs;
procedure GetMC_WC(var t:TMatrix);

implementation
Type PTrafKette=^TTrafKette;
     TTrafKette=record
       next:PTrafKette;
       MC_WC:TMatrix;
     end;

const NormKoorSys:TKoorSys=((x:0;y:0;z:0),
                            (x:1;y:0;z:0),(x:-1;y:0;z:0),
                            (x:0;y:1;z:0),(x:0;y:-1;z:0),
                            (x:0;y:0;z:1),(x:0;y:0;z:-1));
var MC_WC,WC_DC,MC_DC:TMatrix;
const Trafs:PTrafKette=nil;

procedure mulmat(a,b:TMatrix; var c:TMatrix);
{Multipliziert 4*4 Matrize a mit Matrize b und gibt das Ergebnis in c zurck}
var i:integer;
begin
  for i:=1 to 3 do begin
    c[0,i]:=b[0,i]+a[0,1]*b[1,i]+a[0,2]*b[2,i]+a[0,3]*b[3,i];
    c[1,i]:=       a[1,1]*b[1,i]+a[1,2]*b[2,i]+a[1,3]*b[3,i];
    c[2,i]:=       a[2,1]*b[1,i]+a[2,2]*b[2,i]+a[2,3]*b[3,i];
    c[3,i]:=       a[3,1]*b[1,i]+a[3,2]*b[2,i]+a[3,3]*b[3,i];
  end;
end;

procedure Rotate(achse:integer;w:real);
{verndert MC_WC so, da das Objekt um w Grad um die Achse (1=x,2=y,3=z) gedreht wird}
var s,c:real;
    M:TMatrix;
begin
  M:=E;
  w:=w*pi/180.0;
  s:=sin(w); c:=cos(w);
  case achse of
    1: begin M[2][2]:=c; M[2][3]:=s; M[3][2]:=-s; M[3][3]:=c; end;
    2: begin M[1][1]:=c; M[1][3]:=-s; M[3][1]:=s; M[3][3]:=c; end;
    3: begin M[1][1]:=c; M[1][2]:=s; M[2][1]:=-s; M[2][2]:=c; end;
  end;
  MulMat(M,MC_WC,MC_WC);
end;

procedure translate(t:T3DPoint);
{verndert MC_WC so, da das Objekt um den Vektor t verschoben wird}
var M:TMatrix;
begin
  M:=E;
  M[0][1]:=t.x; M[0][2]:=t.y; M[0][3]:=t.z;
  MulMat(M,MC_WC,MC_WC);
end;

procedure Scale(s:T3DPoint);
{verndert MC_WC so, da das Objekt um s in x,y bzw. z Richtung gedeht wird}
var M:TMatrix;
begin
  m:=E;
  m[1][1]:=s.x; m[2][2]:=s.y; m[3][3]:=s.z;
  MulMat(M,MC_WC,MC_WC);
end;



procedure CalcMC_WC(var AMC_WC:TMatrix;pos:T3DRect);
{Berechnet aus der Translatipn, der Skalierung und der Rotation die in pos
 stehen die MC_WC = AMC_WC Matrix}
{MC = Modell Koordinaten System
 WC = Welt Koordinaten System
 DC = Bildschirm Koordinaten System}

begin
  MC_WC:=E;
  Translate(pos.T); {verschieben}
  Rotate(1,pos.r.x);{rotieren um x}
  Rotate(2,pos.r.y);{rotieren um y}
  Rotate(3,pos.r.z);{rotieren um z}
  Scale(pos.s);     {verzerren}
  AMC_WC:=MC_WC;    {zurckgeben des Ergebnisses}
end;

function arcsin(x:single):single;
{Berechnet den Arcus Sinus Mithilfe einer Umrechnung auf den Arcus Tangens}
begin
  if abs(x)<1 then arcsin:=arctan(x/sqrt(1-sqr(x))) else begin
    if x<0 then arcsin:=-pi/2 else arcsin:=pi/2;
  end;
end;

function arccos(x:single):single;
{Berechnet den Arcus Cosinus Mithilfe einer Umrechnung auf den Arcus Tangens}
var h:single;
begin
  if (x<>0)  then begin
    if abs(x)<1 then begin
      h:=arctan(sqrt(1-sqr(x))/abs(x));
      if x<0 then arccos:=pi-h else arccos:=h;
    end else if x<=-1 then arccos:=pi else arccos:=0;
  end else begin
    arccos:=pi/2;
  end;
end;

procedure asin(c:single;var b1,b2:single);
begin
  b1:=arcsin(c);
  if b1<0 then begin
    b1:=b1+2*pi;
    b2:=3*pi-b1;{b1 ist grer 1.5pi}
  end else begin
    b2:=pi-b1;
  end;
end;

procedure acos(c:single;var b1,b2:single);
begin
  b1:=arccos(c);
  b2:=2*pi-b1;
end;

procedure CalcPos(AMC_WC:TMatrix;var pos:T3DRect);
{Diese Procedur ist die Umkehrfunktion von CalcMC_WC
 Und berechnet die Parameter der 5 Transformationen, die auf AMC_WC gefhrt
 haben}
var p:T3dPoint;
    ck,lb2,cw1,cw2,cw3,cw4:single;

  procedure CalcPointWC(AMC_WC:TMatrix;a:T3dPoint;var b:T3dPoint);
  {Berechnet einen Punkt mit der aMC_WC Matrix in das WC}
  var w:single;
  begin
    with a do begin
      b.x:=(AMC_WC[0][1] + x*AMC_WC[1][1] + y*AMC_WC[2][1] + z*AMC_WC[3][1]);
      b.y:=(AMC_WC[0][2] + x*AMC_WC[1][2] + y*AMC_WC[2][2] + z*AMC_WC[3][2]);
      b.z:=(AMC_WC[0][3] + x*AMC_WC[1][3] + y*AMC_WC[2][3] + z*AMC_WC[3][3]);
    end;
  end;

  function dist(a,b:T3DPoint):single;
  {Berechnet den Abstand zweier Punkte}
  begin
    dist:=sqrt(sqr(a.x-b.x)+sqr(a.y-b.y)+sqr(a.z-b.z));
  end;

  procedure compare(a1,a2,b1,b2:single;var a:single);
  var g,gh:single;
  begin
    g:=abs(a1-b1);
    a:=a1;
    gh:=abs(a1-b2);
    if gh<g then g:=gh;
    gh:=abs(a2-b1);
    if gh<g then begin
      a:=a2;
      g:=gh;
    end;
    gh:=abs(a2-b2);
    if gh<g then a:=a2;
  end;

begin
  p.x:=0;
  p.y:=0;
  p.z:=0;
  CalcPointWC(AMC_WC,p,pos.T);
  p.x:=1;
  CalcPointWC(AMC_WC,p,p);
  pos.S.x:=dist(p,pos.T);
  p.x:=0;
  p.y:=1;
  p.z:=0;
  CalcPointWC(AMC_WC,p,p);
  pos.S.y:=dist(p,pos.T);
  p.x:=0;
  p.y:=0;
  p.z:=1;
  CalcPointWC(AMC_WC,p,p);
  pos.S.z:=dist(p,pos.T);
  asin(AMC_WC[3,1]/pos.s.z,pos.R.y,lb2);
  ck:=cos(pos.R.y);
  acos(AMC_WC[1,1]/pos.s.x/ck,cw1,cw2);
  asin(-AMC_WC[2,1]/pos.s.y/ck,cw3,cw4);
  compare(cw1,cw2,cw3,cw4,pos.R.z);
  asin(-AMC_WC[3,2]/pos.s.z/ck,cw1,cw2);
  acos(AMC_WC[3,3]/pos.s.z/ck,cw3,cw4);
  compare(cw1,cw2,cw3,cw4,pos.R.x);
  pos.r.x:=pos.r.x*180/pi;
  pos.r.y:=pos.r.y*180/pi;
  pos.r.z:=pos.r.z*180/pi;
end;

procedure SetMC_WC(var AMC_WC:TMatrix);
{Dient dazu die aktuelle Matrix MC_WC auf einen schon vorher berechneten Wert zu setzen}
begin
  MC_WC:=AMC_WC;
end;

procedure SetWC_DC(var AWC_DC:TMatrix);
{Setzt die aktuelle Matrix WC_DC auf einen schon vorher berechneten Wert
 und berechnet MC_DC}
begin
  WC_DC:=AWC_DC;
  mulmat(MC_WC,WC_DC,MC_DC);
end;

procedure CalcWC_DC(var AWC_DC:TMatrix;xmin,ymin,zoom:single;breite,hohe:word);
{xmin,ymin:Koordinaten die im Bildschirmmittelpunkt erscheinen sollen
 zoom:Vergrerungsfaktor}
var M:TMatrix;
    s:single;
{Berechnet aus den Daten die WC_DC Matrix und lt MC_DC berechnen}
begin
  m:=e;
  m[1][1]:=zoom; m[2][2]:=zoom; m[3][3]:=zoom;
  Mulmat(AWC_DC,M,AWC_DC);
  M[0,1]:= (xmin*zoom+(breite/2));
  M[0,2]:= (ymin*zoom+(hohe/2));
  Mulmat(AWC_DC,M,AWC_DC);
  m:=e;
  {if hohe<breite then s:=hohe/breite*zoom else s:=breite/hohe*zoom;}
  SetWC_DC(AWC_DC);
end;

procedure CalcPoint(a:T3DPoint;var b:T3DPoint);
{Berechnet einen Punkt mit der aktuellen MC_DC Matrix}
var w:single;
begin
  with a do begin
    b.x:=(MC_DC[0][1] + x*MC_DC[1][1] + y*MC_DC[2][1] + z*MC_DC[3][1]);
    b.y:=(MC_DC[0][2] + x*MC_DC[1][2] + y*MC_DC[2][2] + z*MC_DC[3][2]);
    b.z:=(MC_DC[0][3] + x*MC_DC[1][3] + y*MC_DC[2][3] + z*MC_DC[3][3]);
  end;
end;

procedure CalcKoorSys(var KoorSys:TKoorSys);
{Berechnet die 6 Eckpunkte und den Mittelpunkt eines 3D Kreuzes}
var n:byte;
begin
  for n:=0 to 6 do begin
    CalcPoint(NormKoorSys[n],KoorSys[n]);
  end;
end;

procedure PushTrafs;
var hTraf:PTrafKette;
begin
  new(HTraf);
  HTraf^.mc_wc:=MC_WC;
  htraf^.next:=trafs;
  trafs:=htraf;
end;

Procedure PopTrafs;
var hTraf:PTrafKette;
begin
  if Trafs<>nil then begin
    MC_WC:=Trafs^.mc_wc;
    HTraf:=trafs;
    trafs:=trafs^.next;
    dispose(htraf);
  end;
end;

procedure GetMC_WC(var t:TMatrix);
begin
  t:=MC_WC;
end;

begin
  MC_WC:=E;
  WC_DC:=E;
  MC_DC:=E;
end.