procedure cline(a,b:vct4);
var x1,y1,x2,y2,t:real;

  procedure interpol(t:real;a:vct4; var b:vct4);
  begin
    b.w:=a.w+t*(b.w-a.w);
    b.x:=a.x+t*(b.x-a.x);
    b.y:=a.y+t*(b.y-a.y);
    b.z:=a.z+t*(b.z-a.z);
  end;

  function doclip(g1,g2:real; var a:vct4; var b:vct4):boolean;
  begin
    if g1>0 then if g2<=0 then begin
      t:=g1/(g1-g2);
      interpol(t,a,b);
    end;
    if g2>0 then if g1<=0 then begin
      t:=g2/(g2-g1);
      interpol(t,b,a);
    end;
    doclip:=(g1>0) or (G2>0);
  end;

begin
  if doclip(a.w-a.y,b.w-b.y,a,b) then
    if doclip(a.y,b.y,a,b) then
      if doclip(a.w-a.x,b.w-b.x,a,b) then
        if doclip(a.x,b.x,a,b) then
          if doclip(a.w-a.z,b.w-b.z,a,b) then
            if doclip(a.z,b.z,a,b) then begin
              NPCtoDC(a,x1,y1);
              NPCtoDC(a,x2,y2);
              Line2d(x1,y1,x2,y2);
            end;
end;

procedure polyclip(var Pointcnt:integer; var apoints: polyobjtyp);
var i,pc:integer;
    hPoints,hclippoints:array[0..maxpnts] of vct4;
    aclippoints:array[0..maxpnts] of vertex;
    preph,aktph,firph:vct4;
    prepa,aktpa,firpa:vertex;
    t:real;

procedure interpol(var iph,aktph:vct4;var ipa,aktpa:vertex);
begin
  iph.w:=preph.w+t*(aktph.w-preph.w);
  iph.x:=preph.x+t*(aktph.x-preph.x);
  iph.y:=preph.y+t*(aktph.y-preph.y);
  iph.z:=preph.z+t*(aktph.z-preph.z);

  ipa.crd.x:=prepa.crd.x+t*(aktpa.crd.x-prepa.crd.x);
  ipa.crd.y:=prepa.crd.y+t*(aktpa.crd.y-prepa.crd.y);
  ipa.crd.z:=prepa.crd.z+t*(aktpa.crd.z-prepa.crd.z);
  ipa.nrm.x:=prepa.nrm.x+t*(aktpa.nrm.x-prepa.nrm.x);
  ipa.nrm.y:=prepa.nrm.y+t*(aktpa.nrm.y-prepa.nrm.y);
  ipa.nrm.z:=prepa.nrm.z+t*(aktpa.nrm.z-prepa.nrm.z);
  ipa.c.r:=prepa.c.r+t*(aktpa.c.r-prepa.c.r);
  ipa.c.g:=prepa.c.g+t*(aktpa.c.g-prepa.c.g);
  ipa.c.b:=prepa.c.b+t*(aktpa.c.b-prepa.c.b);
  if donorm(ipa.nrm) then error('Normale durch clippen=(0,0,0)');
end;

procedure doclip(i:integer;g1,g2:real);
begin
  aktph:=hpoints[i];aktpa:=apoints[i];
  if i=0 then begin
    firph:=aktph;
    firpa:=aktpa;
    pc:=0;
  end else if ((g1>0) and (g2<=0)) or ((g1<=0) and (g2>0)) then begin
    t:=g1/(g1-g2);
    interpol(hclippoints[pc],aktph,aclippoints[pc],aktpa);
    inc(pc);
  end;
  preph:=aktph; prepa:=aktpa;
  if g2>0 then begin
    hclippoints[pc]:=aktph; aclippoints[pc]:=aktpa;
    inc(pc);
  end;
end;

function lastclip(g1,g2:real):boolean;
var i:integer;
begin
  if ((g1>0) and (g2<=0)) or ((g1<=0) and (g2>0)) then begin
    t:=g1/(g1-g2);
    interpol(hclippoints[pc],firph,aclippoints[pc],firpa);
    inc(pc);
  end;
  for i:=0 to pred(pc) do begin
    hpoints[i]:=hclippoints[i];
    apoints[i]:=aclippoints[i];
  end;
  pointcnt:=pc;
  lastclip:=pointcnt=0;
end;

begin
  for i:=0 to pred(pointcnt) do begin
    mctonpc(apoints[i].crd,hpoints[i]);
  end;
  for i:=0 to pred(pointcnt) do
    doclip(i,preph.w-preph.y,hpoints[i].w-hpoints[i].y);
  if lastclip(preph.w-preph.y,firph.w-firph.y) then exit;

  for i:=0 to pred(pointcnt) do
    doclip(i,preph.y,hpoints[i].y);
  if lastclip(preph.y,firph.y) then exit;

  for i:=0 to pred(pointcnt) do
    doclip(i,preph.w-preph.x,hpoints[i].w-hpoints[i].x);
  if lastclip(preph.w-preph.x,firph.w-firph.x) then exit;

  for i:=0 to pred(pointcnt) do
    doclip(i,preph.x,hpoints[i].x);
  if lastclip(preph.x,firph.x) then exit;

  for i:=0 to pred(pointcnt) do
    doclip(i,preph.w-preph.z,hpoints[i].w-hpoints[i].z);
  if lastclip(preph.w-preph.z,firph.w-firph.z) then exit;

  for i:=0 to pred(pointcnt) do
    doclip(i,preph.z,hpoints[i].z);
  if lastclip(preph.z,firph.z) then exit;
end;