unit grafik;
interface
uses vga,ems,crt,dos,graph;
{$ifopt N+ } type real=single; {$ENDIF}
const maxpnts=20;
      epsilon=1E-10;
      pysscrsizex=24.0;
      pysscrsizey=17.0;
      colrange = 256;
      speicherplatz:word=$8000;
      bgipath='';
      kartemaxx=359;
      kartemaxy=479;
type mat4=array[0..3,0..3] of real;
     vct3=record x,y,z:real; end;
     vct4=record w,x,y,z:real; end;
     RGB  = record r,g,b:real; end;
     RGBb = record r,g,b:byte; end;
     RGBi = record r,g,b:integer; end;
     vertex=record
       crd,nrm:vct3;
       c:RGB;
     end;
     polyobjtyp=array[0..maxpnts] of vertex;
     trafstackptr=^trafstacktyp;
     trafstacktyp = record
                      mc_wc,mc_npc,mc_dc,
                      wc_mc,wc_dc,wc_npc,
                      npc_mc,npc_dc:mat4;
                      vor,nach:trafstackptr;
                    end;
     shd_vtx= record x,y,z:integer; c:RGBb; end;
     polyscrtyp=array[0..maxpnts] of shd_vtx;
     zbufferspan=array[0..kartemaxx-1] of integer;
     spanptr=^zbufferspan;
     fix = record case boolean of
             true:(fix:longint);
             false:(f:word;i:integer);
           end;
     fixRGB = record r,g,b:fix; end;
     shadingmeth=(gouraud,flat);
     intptr=^integer;
const clipmode:(inside,outside,toclip)=toclip;
      volclipcode:integer=$FF;
      XMIN:real=-1.5;
      YMIN:real=-1.1;
      lichtgesch:boolean=false;
      clipcube:boolean=false;
      p:real=0.99;
      v:vct3=(x:1;y:1;z:1);
      e:mat4=((1.0,0.0,0.0,0.0), (0.0,1.0,0.0,0.0),
              (0.0,0.0,1.0,0.0), (0.0,0.0,0.0,1.0));
      flipareaenabled:boolean=false;
      trifillenable : boolean=true;
      shadingmethod : shadingmeth = gouraud;
      _useems:boolean=false;
      name:namestr='';
      brille:boolean=false;
      mapcolor:byte=15;
      augendist:real=0.5;
      frame:boolean=false;
      wireframe:boolean=false;
      bkcolor:rgbb=(r:0;g:0;b:0);
      VRP:vct3=(x:0;y:0;z:0);
      NRP:vct3=(x:-0.2;y:-3;z:0.3);
      VUP:vct3=(x:0;y:0;z:1);
      XSize:real=3.5; VPD:real=7; FPD:real=1.3; BPD:real=-1.3;
      grafmode:integer=0;
      eyepoint:vct3=(x:1;y:1;z:1);
var MC_WC,WC_NPC,MC_NPC,MC_DC,
    WC_MC,WC_DC,NPC_MC,NPC_DC:mat4;
    xwinsize,ywinsize:real;
    xwinofs,ywinofs:integer;
    MatsChanged:boolean;
    trafstack:trafstackptr;
    zbuffer:array[0..pred(kartemaxy)] of spanptr;
    _pixelhochzubreit:real;
    _VRP,_NRP,_VUP: vct3;
    _VPD,_FPD,_BPD,_xMin,
    _ymin,_xsize,_ysize:real;
    _lux,_luy,_rox,_roy:real;
    _ysubu,_ysubo,
    _spanmemsize,
    _xmaxglobal,
    _ymaxglobal: integer;
    emshandle:word;
    totalpages:word;
    emsbufbegin:longint;

function donorm(var v:vct3):boolean;
procedure setviewing(VRP,NRP,VUP:vct3;
                     xmin,ymin,xmax,ymax,vpd,fpd,bpd:real);
procedure SetViewGlobal(VRP,NRP,VUP:vct3;xmin,ymin,xSize,VPD, FPD, BPD: real);
procedure SetScreenGlobal(lux,luy,rox,roy:real);
procedure SetScreen(lux,luy,rox,roy:real;frame:boolean);
function dolocalinit:boolean;
procedure MCtoDCi(a:vct3; var x,y:integer);
procedure MCtoDC3(a:vct3; var ps:shd_vtx);
procedure mctonpc(a:vct3;var as:vct4);
procedure updatemats;
procedure cline(a,b:vct4);
procedure polyclip(var pointcnt:integer; var apoints:polyobjtyp);
procedure filltria(p1,p2,p3:shd_vtx);
procedure error(s:string);
procedure linie3d(b,e:vct3);
procedure grafikinit;
procedure grafikbegin;
procedure grafikende;
procedure rgb_line(x1,y1,x2,y2,r,g,b:integer);
procedure coldot(x,y:integer; r,g,b:integer);
procedure savebild;

implementation

procedure line2d(x1r,y1r,x2r,y2r:real);
begin
  map(mapcolor);
  line(round(x1r),round(y1r),round(x2r),round(y2r));
end;


(*$I VIEWing.INC  *)
(*$I CLIPPing.INC *)
(*$I SHADing.INC  *)

function VGAvorhanden:boolean;
var mode,driver:integer;
begin
  detectgraph(mode,driver);
  VGAvorhanden:=mode=9;
end;

PROCEDURE grafikinit;
VAR zahler:byte;
    graphdriver,grapherror: integer;
begin
  (*-A-*)
  case grafmode of
  -1:begin
       videomodus($13);
       _xmaxglobal:=319; _ymaxglobal:=199;
       setclutrgb;
     end;
  -2:begin
       scqmode;
       _xmaxglobal:=359; _ymaxglobal:=479;
       setclutrgb;
     end;
  else begin
         graphdriver:=detect;
         initgraph(graphdriver,grafmode,bgipath);
         grapherror:=graphresult;
         if (grapherror<>GrOK) then begin
           clrscr;
           textcolor(red);
           writeln('Grafik Fehler:');
           writeln(GraphErrorMsg(grapherror));
           repeat until keypressed;
           halt(1);
         end;
         _xmaxglobal:=getmaxx; _ymaxglobal:=getmaxy;
       end;
  end;
  _pixelhochzubreit:=((pysscrsizey/succ(_ymaxglobal)) /
                      (pysscrsizex/succ(_xmaxglobal)));
  (*-E-*)
  MC_WC:=E;
  trafstack:=nil;
  if (grafmode<0) then begin
    zahler:=((bkcolor.r shl 2) and $e0) or ((bkcolor.g shr 1) and $1C) or (bkcolor.b shr 4);
    map($F);
    fillchar(mem[$A000:0],$FFFF,zahler);
  end;
end;


procedure savebild;
var n:byte;
    datei:file;
begin
  if grafmode=-1 then begin
    assign(datei,name+'.PIC');
    rewrite(datei,1);
    blockwrite(datei,mem[$A000:0],64000);
    close(datei);
  end;
  if grafmode=-2 then begin
    assign(datei,name+'.PIC');
    rewrite(datei,1);
    for n:=0 to 3 do begin
      readmap(n);
      blockwrite(datei,mem[$A000:0],43200);
    end;
    close(datei);
  end;
end;

procedure grafikende;
begin
  if grafmode<0 then vgaende else closegraph;
end;

procedure error(s:string);
var c:char;
begin
  if grafmode<0 then vgaende else closegraph;
  if s<>'' then begin
    textcolor(yellow);
    textbackground(blue);
    write(#7,s);
    c:=readkey;
  end else write(#7);
  halt;
end;

procedure rgb_line(x1,y1,x2,y2,r,g,b:integer);
type intf=record case boolean of
            true:(fix:longint);
            false:(f:word;i:integer);
          end;
var dyddx,dxddy,sy,sx:intf; dy,dx,h:integer;
begin
  dy:=abs(y2-y1); dx:=abs(x2-x1);
  if (dx>dy) then begin
    if x2<x1 then begin h:=x1; x1:=x2; x2:=h; h:=y1; y1:=y2; y2:=h; end;
    coldot(x1,y1,r,g,b);
    if dx<>0 then begin
      sy.i:=y1; sy.f:=$8000;
      dyddx.i:=y2-y1; dyddx.f:=0;dyddx.fix:=dyddx.fix div dx;
      while x1<x2-1 do begin
        inc(x1); inc(sy.fix,dyddx.fix); coldot(x1,sy.i,r,g,b);
      end;
      coldot(x2,y2,r,g,b);
    end;
  end else begin
    if y2<y1 then begin h:=x1; x1:=x2; x2:=h; h:=y1; y1:=y2; y2:=h; end;
    coldot(x1,y1,r,g,b);
    if dy<>0 then begin
      sx.i:=x1; sx.f:=$8000;
      dxddy.i:=x2-x1; dxddy.f:=0;dxddy.fix:=dxddy.fix div dy;
      while y1<y2-1 do begin
        inc(y1); inc(sx.fix,dxddy.fix); coldot(sx.i,y1,r,g,b);
      end;
      coldot(x2,y2,r,g,b);
    end;
  end;
end;

procedure linie3d(b,e:vct3);
var a,s:vct4;
    c,d:shd_vtx;

  procedure clinep(a,b:vct4);
  var x1,y1,x2,y2,t:real;

    procedure interpol(t:real;a:vct4; var b:vct4);
    begin
      b.w:=a.w+t*(b.w-a.w);
      b.x:=a.x+t*(b.x-a.x);
      b.y:=a.y+t*(b.y-a.y);
      b.z:=a.z+t*(b.z-a.z);
    end;

    function clipit(g1,g2:real; var a:vct4; var b:vct4):boolean;
    begin
      if g1>0 then if g2<=0 then begin
        t:=g1/(g1-g2);
        interpol(t,a,b);
      end;
      if g2>0 then if g1<=0 then begin
        t:=g2/(g2-g1);
        interpol(t,b,a);
      end;
      clipit:=(g1>0) or (g2>0);
    end;

  (*$ifopt b+*)(*$define bplus*)(*$b-*)(*$else*)(*$undef bplus*)(*$endif*)
  begin
    if (clipmode=inside) or
       ((clipmode=toclip) and
        (((volclipcode and  1=0) or clipit(a.w-a.y,b.w-b.y,a,b)) and
         ((volclipcode and  2=0) or clipit(    a.y,    b.y,a,b)) and
         ((volclipcode and  4=0) or clipit(a.w-a.x,b.w-b.x,a,b)) and
         ((volclipcode and  8=0) or clipit(    a.x,    b.x,a,b)) and
         ((volclipcode and 16=0) or clipit(a.w-a.z,b.w-b.z,a,b)) and
         ((volclipcode and 32=0) or clipit(    a.z,    b.z,a,b))
        )
       ) then begin
      NPCtoDC(a,x1,y1);
      NPCtoDC(b,x2,y2);
      Line2d(x1,y1,x2,y2);
    end;
  end;
  (*$ifdef bplus*)(*$b+*)(*$endif*)

begin
  updatemats;
  mctonpc(b,a);
  mctonpc(e,s);
  if wireframe then clinep(a,s)
end;

procedure grafikbegin;
begin
  while keypressed do readkey;
  grafikinit;
  setviewglobal(VRP,NRP,VUP,xMin,yMin,xSize,vpd,FPd,bpd);
  setscreenglobal(0,_ymaxglobal,_xmaxglobal,0);
end;

{$L EGAVGA}
procedure EGAVGAdriver;external;

begin
  if (registerbgidriver(@EGAVGAdriver)<0) then error('Fehler beim Anmelden der Grafiktreiber!');
  wireframe:=not VGAvorhanden;
  if wireframe then grafmode:=0 else grafmode:=-2;
end.