procedure FillFFTab;
const ds0=PlaneWCSize0/PlaneSize; ds1=PlaneWCSize1/PlaneSize;
      da0=ds0*ds0; da1=ds1*ds1;
var i,j,ind:integer; x0,x1,y1,y0:real; MemNeed:longint;
begin
  MemNeed:=(longint(PlaneSize)*PlaneSize+PlaneSize*2) div 8*SizeOf(real);
  if MemNeed>SizeOf(BigArr) then
    Error('Kein Platz fr Deltaformfaktoren !');
  GetMem(dFFa0,MemNeed);
  if HighMidEnabled then GetMem(dFFa1,MemNeed);
  ind:=0;
  for i:=0 to PlaneHalf-1 do begin
    x0:=i*ds0+ds0/2; x1:=i*ds1+ds1/2;
    for j:=0 to i do begin
      y0:=j*ds0+ds0/2; y1:=j*ds1+ds1/2;
      if (y0<=PlaneWCSize1/2) and
         (x0<PlaneWCSize1/2) and HighMidEnabled then
           BigArr(dFFa0^)[ind]:=0
      else BigArr(dFFa0^)[ind]:=da0/Pi/Sqr(Sqr(x0)+Sqr(y0)+1);
      if HighMidEnabled then
        BigArr(dFFa1^)[ind]:=da1/Pi/Sqr(Sqr(x1)+Sqr(y1)+1);
      Inc(ind);
    end;
  end;
end;

procedure GetPlaneMem;
var i:integer;
begin
  for i:=0 to PlaneSize-1 do begin
    if MaxAvail<SizeOf(plane[0]) then Error('Kein Platz mehr fr Plane !');
    New(plane[i]);
  end;
end;

procedure ReleasePlaneMem;
var i:integer;
begin
  for i:=0 to PlaneSize-1 do Dispose(plane[i]);
end;

procedure ClearPlane;
var i:integer;
begin
  for i:=0 to PlaneSize-1 do
    FillChar(plane[i]^,SizeOf(PlaneSpanTyp),char(-1));
end;

procedure PutPnt(x,y,z,aNr:integer);
var a:pointer;
begin
  a:=@plane[y]^[x];
  if z>planePix(a^).z then begin
    planePix(a^).z:=z;
    planePix(a^).ind:=aNr;
  end;
end;

procedure Line(x1,y1,z1,x2,y2,z2,aNr:integer);
var x,y,z,dyDDx,dxDDy,dzDDt:fix;
    DX,dy : integer;

  procedure SwapPnts;
  var h:integer;
  begin
    h:=x1; x1:=x2; x2:=h;
    h:=y1; y1:=y2; y2:=h;
    h:=z1; z1:=z2; z2:=h;
  end;

begin
  DX:=Abs(x2-x1);
  dy:=Abs(y2-y1);
  z.i:=z1; z.f:=$8000;
  dzDDt.i:=z2-z1; dzDDt.f:=0;
  if (dy>DX) then begin
    if (y2<y1) then SwapPnts;
    PutPnt(x1,y1,z1,aNr);
    if dy<>0 then begin
      x.i:=x1; x.f:=$8000;
      dxDDy.i:=x2-x1; dxDDy.f:=0;
      dxDDy.fix:=dxDDy.fix div dy;
      dzDDt.fix:=dzDDt.fix div dy;
      while y1<Pred(y2) do begin
        Inc(y1);
        Inc(x.fix,dxDDy.fix);
        Inc(z.fix,dzDDt.fix);
        PutPnt(x.i,y1,z.i,aNr);
      end;
      PutPnt(x2,y2,z2,aNr);
    end;
  end else begin
    if (x2<x1) then SwapPnts;
    PutPnt(x1,y1,z1,aNr);
    if DX<>0 then begin
      y.i:=y1; y.f:=$8000;
      dyDDx.i:=y2-y1; dyDDx.f:=0;
      dyDDx.fix:=dyDDx.fix div DX;
      dzDDt.fix:=dzDDt.fix div DX;
      while x1<Pred(x2) do begin
        Inc(x1);
        Inc(y.fix,dyDDx.fix);
        Inc(z.fix,dzDDt.fix);
        PutPnt(x1,y.i,z.i,aNr);
      end;
      PutPnt(x2,y2,z2,aNr);
    end;
  end;
end;

procedure Span(ltor:boolean;y:integer;x1,x2:integer;z,dz:fix;aNr:integer);
var l:pointer;
begin
  l:=@plane[y]^[x1];
  if ltor then while x1<Pred(x2) do begin
    Inc(x1);
    Inc(longint(l),SizeOf(planePix));
    Inc(z.fix,dz.fix);
    if z.i>planePix(l^).z then begin
      planePix(l^).z:=z.i;
      planePix(l^).ind:=aNr;
    end;
  end else while x1>Succ(x2) do begin
    Dec(x1);
    Dec(longint(l),SizeOf(planePix));
    Dec(z.fix,dz.fix);
    if z.i>planePix(l^).z then begin
      planePix(l^).z:=z.i;
      planePix(l^).ind:=aNr;
    end;
  end;
end;

procedure AreaToPlane(pCnt:integer;var Pol:RadPolTyp; aNr:integer);
var p1,p2,p3,p4,ph:radVct;
    x21,x31,x32,
    y21,y31,y32,
    z21,z31,z32:integer;
    ex,ez,
    e1x,e1z,
    edx,edz,
    e1dx,e1dz,
    dzddx:fix;
    dzddxr: real;
    n: longint;
    trinr:integer;
begin
  for trinr:=0 to pCnt-3 do begin
    p1:=Pol[0];p2:=Pol[1+trinr];p3:=Pol[2+trinr];
    if p1.y>p2.y then begin ph:=p1;p1:=p2;p2:=ph; end;
    if p1.y>p3.y then begin ph:=p1;p1:=p3;p3:=ph; end;
    if p2.y>p3.y then begin ph:=p2;p2:=p3;p3:=ph; end;
    p1.z:=p1.z-Random(10);p2.z:=p2.z-Random(10);p3.z:=p3.z-Random(10);
    y31:=p3.y -p1.y;
    if y31<>0 then begin
      y21:=p2.y -p1.y; x21:=p2.x -p1.x;
      x31:=p3.x -p1.x;
      n:=longint(y21)*x31-longint(y31)*x21;
      if n<>0 then begin
        PutPnt(p1.x,p1.y,p1.z,aNr);
        Inc(p1.y);
        z31:=p3.z-p1.z; z21:=p2.z-p1.z;
        ex.i:=p1.x; ex.f:=$8000;
        ez.i:=p1.z; ez.f:=$8000;
        edx.i:=x31; edx.f:=0;
        edx.fix:=edx.fix div y31;
        edz.i:=z31; edz.f:=0;
        edz.fix:=edz.fix div y31;
        dzddxr:=(longint(y21)*z31-longint(y31)*z21)/n;
        if dzddxr>MaxInt then dzddxr:=10000 else
        if dzddxr<-MaxInt then dzddxr:=-10000;
        dzddx.fix:=Round(dzddxr*65536.0);
        if y21<>0 then begin
          e1x.fix:=ex.fix;
          e1z.fix:=ez.fix;
          e1dx.i:=x21; e1dx.f:=0;
          e1dx.fix:=e1dx.fix div y21;
          e1dz.i:=z21; e1dz.f:=0;
          e1dz.fix:=e1dz.fix div y21;
          while p1.y<p2.y do begin
            Inc(ex.fix,edx.fix);
            Inc(ez.fix,edz.fix);
            Inc(e1x.fix,e1dx.fix);
            Inc(e1z.fix,e1dz.fix);
            PutPnt(ex.i,p1.y,ez.i,aNr);
            PutPnt(e1x.i,p1.y,e1z.i,aNr);
            Span(n<0,p1.y,ex.i,e1x.i,ez,dzddx,aNr);
            Inc(p1.y);
          end;
          Inc(ex.fix,edx.fix);
          Inc(ez.fix,edz.fix);
        end;
        p1.y:=p2.y;
        PutPnt(ex.i,p1.y,ez.i,aNr);
        PutPnt(p2.x,p2.y,p2.z,aNr);
        Span(n<0,p1.y,ex.i,p2.x,ez,dzddx,aNr);
        Inc(p1.y);
        y32:=p3.y -p2.y;
        if y32<>0 then begin
          x32:=p3.x -p2.x; z32:=p3.z -p2.z;
          e1x.i:=p2.x; e1x.f:=$8000;
          e1z.i:=p2.z; e1z.f:=$8000;
          e1dx.i:=x32; e1dx.f:=0;  e1dx.fix:=e1dx.fix div y32;
          e1dz.i:=z32; e1dz.f:=0;  e1dz.fix:=e1dz.fix div y32;
          while p1.y<p3.y do begin
            Inc(ex.fix,edx.fix);
            Inc(ez.fix,edz.fix);
            Inc(e1x.fix,e1dx.fix);
            Inc(e1z.fix,e1dz.fix);
            PutPnt(e1x.i,p1.y,e1z.i,aNr);
            PutPnt(ex.i,p1.y,ez.i,aNr);
            Span(n<0,p1.y,ex.i,e1x.i,ez,dzddx,aNr);
            Inc(p1.y);
          end;
        end;
        PutPnt(p3.x,p3.y,p3.z,aNr);
      end else Line(p1.x,p1.y,p1.z,p3.x,p3.y,p3.z,aNr);
    end else Line(p1.x,p1.y,p1.z,p3.x,p3.y,p3.z,aNr);
  end;
end;

procedure NPCtoDC(var p:radVct);
begin
  p.x:=Round(NPC_DC[0,1]+p.crd4.x/p.crd4.w*NPC_DC[1,1]);
  p.y:=Round(NPC_DC[0,2]+p.crd4.y/p.crd4.w*NPC_DC[2,2]);
  p.z:=Round(NPC_DC[0,3]+p.crd4.z/p.crd4.w*NPC_DC[3,3]);
end;

procedure OneAreaToPlane(aNr,SeenFrom:integer);
var paNr:paInfTyp;
    j,mArea,pc:integer;Pol:RadPolTyp;
    ClipCodeIn,ClipCodeOut:byte;

  procedure radClip(var pCnt:integer; var oPol:RadPolTyp);
  var i,pc:integer;
      cPol:RadPolTyp;
      prep,aktp,firp:radVct;
      t:real;

    procedure Interpol(var ip,aktp:radVct);
    begin
      ip.crd4.w:=prep.crd4.w+t*(aktp.crd4.w-prep.crd4.w);
      ip.crd4.x:=prep.crd4.x+t*(aktp.crd4.x-prep.crd4.x);
      ip.crd4.y:=prep.crd4.y+t*(aktp.crd4.y-prep.crd4.y);
      ip.crd4.z:=prep.crd4.z+t*(aktp.crd4.z-prep.crd4.z);
    end;

    procedure DoClip(i:integer;g1,g2:real);
    begin
      aktp:=oPol[i];
      if i=0 then begin firp:=aktp; pc:=0; end
      else if ((g1>0) and (g2<=0)) or ((g1<=0) and (g2>0)) then begin
        t:=g1/(g1-g2);
        Interpol(cPol[pc],aktp);
        Inc(pc);
      end;
      prep:=aktp;
      if g2>0 then begin cPol[pc]:=aktp; Inc(pc); end;
    end;

    function LastClip(g1,g2:real):boolean;
    var i:integer;
    begin
      if ((g1>0) and (g2<=0)) or ((g1<=0) and (g2>0)) then begin
        t:=g1/(g1-g2); Interpol(cPol[pc],firp); Inc(pc);
      end;
      for i:=0 to pc-1 do oPol[i]:=cPol[i];
      pCnt:=pc; LastClip:=pCnt=0;
    end;

  begin
    with prep.crd4 do begin x:=0;y:=0;z:=0;w:=0; end;
    for i:=0 to pCnt-1 do
     DoClip(i,prep.crd4.w-prep.crd4.x,oPol[i].crd4.w-oPol[i].crd4.x);
    if LastClip(prep.crd4.w-prep.crd4.x,firp.crd4.w-firp.crd4.x) then Exit;
    for i:=0 to pCnt-1 do DoClip(i,prep.crd4.x,oPol[i].crd4.x);
    if LastClip(prep.crd4.x,firp.crd4.x) then Exit;
    for i:=0 to pCnt-1 do
      DoClip(i,prep.crd4.w-prep.crd4.y,oPol[i].crd4.w-oPol[i].crd4.y);
    if LastClip(prep.crd4.w-prep.crd4.y,firp.crd4.w-firp.crd4.y) then Exit;
    for i:=0 to pCnt-1 do
      DoClip(i,prep.crd4.y,oPol[i].crd4.y);
    if LastClip(prep.crd4.y,firp.crd4.y) then Exit;
    for i:=0 to pCnt-1 do
      DoClip(i,prep.crd4.w-prep.crd4.z,oPol[i].crd4.w-oPol[i].crd4.z);
    if LastClip(prep.crd4.w-prep.crd4.z,firp.crd4.w-firp.crd4.z) then Exit;
    for i:=0 to pCnt-1 do
      DoClip(i,prep.crd4.z,oPol[i].crd4.z);
    if LastClip(prep.crd4.z,firp.crd4.z) then Exit;
  end;

begin
  paNr:=aArr[aNr];
  mArea:=aArr[SeenFrom]^.mInd;
  if paNr^.mInd<>mArea then begin
    Pol[0]:=pArr[paNr^.pInd[0]]^;
    ClipCodeIn:=Pol[0].cMask; ClipCodeOut:=$FF and ClipCodeIn;
    if IsFrontFace(Pol[0].crd3,paNr^.nrm) then begin
      pc:=4;
      for j:=1 to 3 do begin
        Pol[j]:=pArr[paNr^.pInd[j]]^;
        ClipCodeIn:=ClipCodeIn or Pol[j].cMask;
        ClipCodeOut:=ClipCodeOut and Pol[j].cMask;
      end;
      if ClipCodeIn and $3F=0 then AreaToPlane(pc,Pol,aNr)
      else if ClipCodeOut and $3F=0 then begin
        radClip(pc,Pol);
        if pc>2 then begin
          for j:=0 to pc-1 do NPCtoDC(Pol[j]);
          AreaToPlane(pc,Pol,aNr);
        end;
      end;
    end;
  end;
end;

procedure CalcNPCDCClipCode(var p:radVct);
begin
  with p,p.crd4 do begin
    MCtoNPC(crd3,crd4);
    if x>w then cMask:=1 else if x<0 then cMask:=2 else cMask:=0;
    if y>w then cMask:=cMask or  4 else if y<0 then cMask:=cMask or 8;
    if z>w then cMask:=cMask or 16 else if z<0 then cMask:=cMask or 32;
    if cMask and $3F=0 then NPCtoDC(p);
  end;
end;

procedure AreasToPlane(SeenFrom:integer);
var i:integer;
begin
  for i:=0 to pCnt do CalcNPCDCClipCode(pArr[i]^);
  for i:=0 to aCnt do OneAreaToPlane(i,SeenFrom);
end;

procedure PlaneToFrame;
var x,y,ind:integer; c:rgbB; p:pPlaneSpanTyp;
begin
  if DisplayPlane and (anzeige<>nichts) then for y:=0 to PlaneSize-1 do begin
    p:=plane[y];
    for x:=0 to PlaneSize-1 do begin
      ind:=p^[x].ind;
      if ind>=0 then begin
        c:=aArr[ind]^.c[0]; coldot(x,y,c.r,c.g,c.b);
      end else coldot(x,y,0,0,0);
    end;
  end;
end;

procedure PlaneToFormFaks(PlaneNr:integer);
var x,y,ii,jj:integer; aNr:integer; pa:paInfTyp; p:^BigArr;
begin
  if PlaneNr=0 then p:=dFFa0
   else if HighMidEnabled then p:=dFFa1 else Exit;
  for x:=0 to PlaneSize-1 do begin
    if x<PlaneHalf then ii:=PlaneHalf-1-x else ii:=x-PlaneHalf;
    for y:=0 to PlaneSize-1 do begin
      aNr:=plane[x]^[y].ind;
      if aNr<>-1 then begin
        pa:=aArr[aNr];
        if y<PlaneHalf then jj:=PlaneHalf-1-y else jj:=y-PlaneHalf;
        if jj>ii then pa^.FormFak:=pa^.FormFak+p^[(Sqr(jj)+jj) div 2+ii]
        else pa^.FormFak:=pa^.FormFak+p^[(Sqr(ii)+ii) div 2+jj];
      end;
    end;
  end;
end;
