program Radio;
uses Crt,dos,graph,koords,Grafik;
type anzeigetyp=(draht,solid,nichts);
const MaxPnts=3000; MaxAreas=3000;
      PlaneSize=128; PlaneHalf=planesize div 2;
      HighMidEnabled:boolean=true;
      PlaneWCSize0=10;
      PlaneWCSize1=2;
      DisplayPlane:boolean=true;
      Maxl:real=0.2;
      RGB_0:RGB=(r:0;g:0;b:0);
      anzeige:anzeigetyp=draht;
      i:integer=0;
      geladen:boolean=false;

type radVct=record
              crd3:vct3; crd4:vct4;
              x,y,z:integer; cMask:byte;
            end;
     RadPolTyp=array[0..9] of radVct;
     fourIndTyp=array[0..3] of integer;
     fourColTyp=array[0..3] of rgbB;
     aInfTyp=record
               pInd,nind:fourIndTyp;
               c:fourColTyp;
               mInd:integer;
               b,dBA:RGB;
               Refl:RGB;
               nrm:vct3;
               AWidth,FormFak:real;
             end;
     paInfTyp=^aInfTyp;
     planePix=record ind,z:integer; end;
     PlaneSpanTyp=array[0..PlaneSize-1] of planePix;
     pPlaneSpanTyp=^PlaneSpanTyp;
     BigArr=array[0..64000 div SizeOf(real)] of real;

var pArr:array[0..MaxPnts] of ^radVct;
    aArr:array[0..MaxAreas] of paInfTyp;
    pCnt,aCnt:integer;
    plane:array[0..PlaneSize-1] of pPlaneSpanTyp;
    TotAWidth:real;
    Ambi,AverageColor:RGB;
    dFFa0,dFFa1:pointer;
    yMin:real;
    ein:char;

function len(x,y,z:real):real;
begin
  len:=Sqrt(Sqr(x)+Sqr(y)+Sqr(z));
end;

function IsFrontFace(var p,n:vct3):boolean;
var d:real;
begin
  d:=p.x*n.x+p.y*n.y+p.z*n.z;
  IsFrontFace:=( -d*NPC_MC[3,0]+n.x*NPC_MC[3,1]+
                n.y*NPC_MC[3,2]+n.z*NPC_MC[3,3])>0;
end;

procedure MarkArea(nr,r,g,b:integer);
var j:integer; x1,y1,x2,y2:integer;
    ymin:real;
begin
  yMin:=-XSize/2*_PixelHochZuBreit*((_YmaxGlobal+1)/(_XmaxGlobal+1));
  SetViewing(VRP,NRP,VUP,-XSize/2,yMin,XSize/2,-yMin,VPD,FPD,BPD);
  SetScreen(0,_YmaxGlobal,_XmaxGlobal,0,false);
  Updatemats;
  for j:=0 to 1 do begin
    MCtoDCi(pArr[aArr[nr]^.pInd[j]]^.crd3,x1,y1);
    MCtoDCi(pArr[aArr[nr]^.pInd[(j+2 and 3)]]^.crd3,x2,y2);
    rgb_line(x1,y1,x2,y2,r,g,b);
  end;
end;

{$I PLANE.INC}

procedure NewPoint;
begin
  Inc(pCnt);
  if pCnt>MaxPnts then Error('Mehr Punkte als Platz fr Pointer!');
  if MemAvail<10240 then Error('Zu viele Punkte ! < 10KByte Platz !');
  New(pArr[pCnt]);
end;

procedure NewArea;
begin
  Inc(aCnt);
  if aCnt>MaxAreas then Error('Mehr Flchen als Platz fr Pointer !');
  if MemAvail<10240 then Error('Zu viele Punkte ! < 10KByte Platz !');
  New(aArr[aCnt]);
end;

procedure CalcNrmandSetAreaWidth(var Area:aInfTyp);
var po,n1,n2:vct3; p:array[0..2] of vct3;
    i:integer; l1,l2:real;
begin
  po:=pArr[Area.pInd[0]]^.crd3;
  for i:=0 to 2 do begin
    p[i].x:=pArr[Area.pInd[i+1]]^.crd3.x-po.x;
    p[i].y:=pArr[Area.pInd[i+1]]^.crd3.y-po.y;
    p[i].z:=pArr[Area.pInd[i+1]]^.crd3.z-po.z;
  end;
  n1.x:=p[0].y*p[1].z-p[1].y*p[0].z; n2.x:=p[1].y*p[2].z-p[2].y*p[1].z;
  n1.y:=p[0].z*p[1].x-p[1].z*p[0].x; n2.y:=p[1].z*p[2].x-p[2].z*p[1].x;
  n1.z:=p[0].x*p[1].y-p[1].x*p[0].y; n2.z:=p[1].x*p[2].y-p[2].x*p[1].y;
  l1:=len(n1.x,n1.y,n1.z); l2:=len(n2.x,n2.y,n2.z);
  Area.AWidth:=0.5*(l1+l2);
  if Abs(l1)<Epsilon then begin l1:=l2; n1:=n2; end;
  if Abs(l1)<Epsilon then Error('Viereck hat keine Flche !');
  Area.nrm.x:=n1.x/l1; Area.nrm.y:=n1.y/l1; Area.nrm.z:=n1.z/l1;
end;

procedure GeometryDivideArea(var Area:aInfTyp);
var l1,l2,l3,l4,dl1,dl2:real;
    di1,di2,dj,pi1,pi2,pij:vct3;
    i,j,sc,dc1,dc2,h,lofs,pInd,pInd0,pInd1,pInd2,pInd3:integer;
    p0,p1,p2,p3:vct3;
    FirstNewA:integer;
    paCnt:paInfTyp;
begin
  p0:=pArr[Area.pInd[0]]^.crd3; p1:=pArr[Area.pInd[1]]^.crd3;
  p2:=pArr[Area.pInd[2]]^.crd3; p3:=pArr[Area.pInd[3]]^.crd3;
  l1:=len(p1.x-p0.x,p1.y-p0.y,p1.z-p0.z);
  l2:=len(p3.x-p2.x,p3.y-p2.y,p3.z-p2.z);
  if l2>l1 then dl1:=l2 else dl1:=l1;
  l3:=len(p2.x-p1.x,p2.y-p1.y,p2.z-p1.z);
  l4:=len(p0.x-p3.x,p0.y-p3.y,p0.z-p3.z);
  if l4>l3 then dl2:=l4 else dl2:=l3;
  dc1:=Round(dl1/Maxl); dc2:=Round(dl2/Maxl);
  if dc1<2 then dc1:=2; if dc2<2 then dc2:=2;
  di1.x:=(p1.x-p0.x)/dc1; di2.x:=(p2.x-p3.x)/dc1;
  di1.y:=(p1.y-p0.y)/dc1; di2.y:=(p2.y-p3.y)/dc1;
  di1.z:=(p1.z-p0.z)/dc1; di2.z:=(p2.z-p3.z)/dc1;
  pi1:=p0; pi2:=p3;
  FirstNewA:=aCnt+1;
  for i:=0 to dc1 do begin
    pij:=pi1;
    dj.x:=(pi2.x-pi1.x)/dc2;
    dj.y:=(pi2.y-pi1.y)/dc2;
    dj.z:=(pi2.z-pi1.z)/dc2;
    for j:=0 to dc2 do begin
      pInd:=pCnt+1;
      if not ( ((i=0) and (j=0)) or ((i=dc1) and (j=0)) or
               ((i=0) and (j=dc2)) or ((i=dc1) and (j=dc2)) ) then begin
        NewPoint;
        pArr[pCnt]^.crd3:=pij;
      end;
      pij.x:=pij.x+dj.x;
      pij.y:=pij.y+dj.y;
      pij.z:=pij.z+dj.z;
      if (i<dc1) and (j<dc2) then begin
        if (i=0) or (i=dc1-1) then lofs:=dc2 else lofs:=dc2+1;
        pInd0:=pInd; pInd1:=pInd0+lofs; pInd2:=pInd1+1; pInd3:=pInd0+1;
        if (i=0) and (j=0) then begin
          pInd0:=Area.pInd[0]; Dec(pInd1); Dec(pInd2); Dec(pInd3);
        end;
        if (i=dc1-1) and (j=0) then pInd1:=Area.pInd[1];
        if (i=dc1-1) and (j=dc2-1) then pInd2:=Area.pInd[2];
        if (i=0) and (j=dc2-1) then pInd3:=Area.pInd[3];
        NewArea; paCnt:=aArr[aCnt]; paCnt^:=Area;
        with paCnt^ do begin
          pInd[0]:=pInd0; pInd[1]:=pInd1; pInd[2]:=pInd2; pInd[3]:=pInd3;
          if j>    0 then nind[0]:=aCnt  -1 else nind[0]:=aCnt;
          if i<dc1-1 then nind[1]:=aCnt+dc2 else nind[1]:=aCnt;
          if j<dc2-1 then nind[2]:=aCnt  +1 else nind[2]:=aCnt;
          if i>    0 then nind[3]:=aCnt-dc2 else nind[3]:=aCnt;
        end;
      end;
    end;
    pi1.x:=pi1.x+di1.x; pi1.y:=pi1.y+di1.y; pi1.z:=pi1.z+di1.z;
    pi2.x:=pi2.x+di2.x; pi2.y:=pi2.y+di2.y; pi2.z:=pi2.z+di2.z;
  end;
  for i:=0 to (dc1*dc2)-1 do begin
    CalcNrmandSetAreaWidth(aArr[FirstNewA+i]^);
    with aArr[FirstNewA+i]^ do begin
      l1:=AWidth/Area.AWidth;
      dBA.r:=dBA.r*l1; dBA.g:=dBA.g*l1; dBA.b:=dBA.b*l1;
    end;
  end;
end;

procedure ReadAscFile(fName:string);
var f:text; s:string; ispnt:boolean;
    LineCnt,i,h,er,PlaneCnt:integer;
    sh:string;Area:aInfTyp;

  procedure InpErr(ErrStr:string);
  begin
    grafikende; Write('Fehler in Datei ',fName,', Zeile ',LineCnt,': ');
    Writeln(ErrStr); Write('Gelesen bis:',s); Readln; Close(f); Halt;
  end;

  procedure DeltoandSpaces(ToHere:integer);
  begin
    Delete(s,1,ToHere);
    while (Length(s)<>0) and (s[1]=' ') do Delete(s,1,1);
  end;

  function GetR:real;
  var r:real; er1,er2:integer; sh:string;
  begin
    Val(s,r,er1); if er1<>0 then begin
      sh:=Copy(s,1,er1-1); Val(sh,r,er2);
      if er2<>0 then InpErr('Zahl erwartet');
      DeltoandSpaces(er1);
    end else s:='';
    GetR:=r;
  end;

begin
  TotAWidth:=0; PlaneCnt:=0;
  AverageColor:=RGB_0; Ambi:=RGB_0;
  {$I-} Assign(f,fName); Reset(f); {$I+}
  LineCnt:=0; if IOResult<>0 then InpErr('Datei existiert nicht !');
  ispnt:=true; aCnt:=-1; pCnt:=-1;
  while not Eof(f) do begin
    Readln(f,s); Inc(LineCnt);
    if Pos(';',s)<>0 then Delete(s,Pos(';',s),255);
    if s<>'' then begin
      if Pos('A:',s)=1 then begin
        DeltoandSpaces(2);
        ispnt:=false;
      end;
      if Pos('H:',s)=1 then begin
        DeltoandSpaces(2);
        bkcolor.r:=round(getr*64);bkcolor.g:=round(getr*64);bkcolor.b:=round(getr*64);
      end;
      if Pos('Name:',s)=1 then begin
        DeltoandSpaces(5);
        name:=s;
      end;
      if ispnt then begin
        NewPoint;
        with pArr[pCnt]^.crd3 do begin x:=GetR; y:=GetR; z:=GetR; end;
      end else begin
        with Area do begin
          mInd:=PlaneCnt;
          b:=RGB_0; dBA:=RGB_0;
          for i:=0 to 3 do begin
            pInd[i]:=Round(GetR);
            if pInd[i]>pCnt then InpErr('unbekannter Punkt');
          end;
          CalcNrmandSetAreaWidth(Area);
          TotAWidth:=TotAWidth+AWidth;
          Refl.r:=GetR;Refl.g:=GetR;Refl.b:=GetR;
          with AverageColor do begin
            r:=r+Refl.r*AWidth;g:=g+Refl.g*AWidth;b:=b+Refl.b*AWidth;
          end;
          if Length(s)<>0 then if s[1]='E' then begin
            DeltoandSpaces(1);
            b.r:=GetR;b.g:=GetR;b.b:=GetR;
            dBA.r:=b.r*AWidth; Ambi.r:=Ambi.r+dBA.r;
            dBA.g:=b.g*AWidth; Ambi.g:=Ambi.g+dBA.g;
            dBA.b:=b.b*AWidth; Ambi.b:=Ambi.b+dBA.b;
          end;
          GeometryDivideArea(Area);
          Inc(PlaneCnt);
          if Length(s)<>0 then if s[1]='F' then begin
            DeltoandSpaces(1);
            with AverageColor do begin
              r:=r+Refl.r*AWidth;g:=g+Refl.g*AWidth;b:=b+Refl.b*AWidth;
            end;
            TotAWidth:=TotAWidth+AWidth;
            Ambi.r:=Ambi.r+dBA.r;
            Ambi.g:=Ambi.g+dBA.g;
            Ambi.b:=Ambi.b+dBA.b;
            h:=pInd[1];pInd[1]:=pInd[3];pInd[3]:=h;
            GeometryDivideArea(Area);
            Inc(PlaneCnt);
          end;
        end;
      end;
      if s<>'' then InpErr('Zeilenende erwartet !');
    end;
  end;
  Close(f);
  with AverageColor do begin
    r:=1-(r/TotAWidth); g:=1-(g/TotAWidth);b:=1-(b/TotAWidth);
    if (Abs(r)<Epsilon) or  (Abs(g)<Epsilon) or (Abs(b)<Epsilon) then
     Error('Alle Flchen reflektieren ideal, Programm konvergiert nicht !');
    r:=1/r;g:=1/g;b:=1/b;
  end;
  with Ambi do begin
    r:=r/TotAWidth*AverageColor.r;
    g:=g/TotAWidth*AverageColor.g;
    b:=b/TotAWidth*AverageColor.b;
  end;
  geladen:=true;
end;

procedure CalcVTXCols;
var i,j,n1,n2,n3:integer;
    pn1,pn2,pn3:paInfTyp;
    co:RGB; col:rgbB;

  function sClamb(s:real):byte;
  begin
    if s<0 then sClamb:=0 else if s>=ColRange then sClamb:=ColRange-1 else
     sClamb:=Trunc(s);
  end;

begin
  for i:=0 to aCnt do with aArr[i]^ do begin
    for j:=0 to 3 do begin
      n1:=nind[j]; n2:=nind[(j+3) and 3];
      pn1:=aArr[n1];
      pn2:=aArr[n2];
      if n1<>i then n3:=pn1^.nind[(j+3) and 3] else n3:=pn2^.nind[j];
      pn3:=aArr[n3];
      co.r:=((b.r+Ambi.r*Refl.r)+(pn1^.b.r+Ambi.r*pn1^.Refl.r)+
             (pn2^.b.r+Ambi.r*pn2^.Refl.r)+(pn3^.b.r+Ambi.r*pn3^.Refl.r))
             /4*ColRange;
      co.g:=((b.g+Ambi.g*Refl.g)+(pn1^.b.g+Ambi.g*pn1^.Refl.g)+
             (pn2^.b.g+Ambi.g*pn2^.Refl.g)+(pn3^.b.g+Ambi.g*pn3^.Refl.g))
             /4*ColRange;
      co.b:=((b.b+Ambi.b*Refl.b)+(pn1^.b.b+Ambi.b*pn1^.Refl.b)+
             (pn2^.b.b+Ambi.b*pn2^.Refl.b)+(pn3^.b.b+Ambi.b*pn3^.Refl.b))
             /4*ColRange;
      col.r:=sClamb(co.r);
      col.g:=sClamb(co.g);
      col.b:=sClamb(co.b);
      c[j]:=col;
    end;
  end;
end;

procedure DrawWire;
var i,j:integer;
begin
  for i:=0 to pCnt do with pArr[i]^ do MCtoDCi(crd3,x,y);
  for i:=0 to aCnt do with aArr[i]^ do
   if IsFrontFace(pArr[pInd[0]]^.crd3,nrm) then for j:=0 to 3 do
    if grafmode<0 then rgb_line(pArr[pInd[j]]^.x,pArr[aArr[i]^.pInd[j]]^.y,
         pArr[pInd[(j+1) and 3]]^.x,pArr[pInd[(j+1) and 3]]^.y,255,255,255)
     else graph.line(pArr[pInd[j]]^.x,pArr[aArr[i]^.pInd[j]]^.y,
         pArr[pInd[(j+1) and 3]]^.x,pArr[pInd[(j+1) and 3]]^.y);
end;

procedure DrawAsWire;
var ymin:real;
begin
  yMin:=-XSize/2*_PixelHochZuBreit*((_YmaxGlobal+1)/(_XmaxGlobal+1));
  SetViewing(VRP,NRP,VUP,-XSize/2,yMin,XSize/2,-yMin,VPD,FPD,BPD);
  SetScreen(0,_YmaxGlobal,_XmaxGlobal,0,false);
  Updatemats;
  if grafmode=0 then graph.setcolor(white);
  DRawwire;
end;

procedure DrawSolid;
var i,j,pc:integer;
    o:PolyObjTyp;
    s:PolyScrTyp;

  procedure Draw4;
  begin
    if Sqr(s[0].c.r-s[2].c.r)+Sqr(s[0].c.g-s[2].c.g)+Sqr(s[0].c.b-s[2].c.b)<
       Sqr(s[1].c.r-s[3].c.r)+Sqr(s[1].c.g-s[3].c.g)+Sqr(s[1].c.b-s[3].c.b)
    then begin FillTria(s[0],s[1],s[2]); FillTria(s[0],s[2],s[3]); end
    else begin FillTria(s[0],s[1],s[3]); FillTria(s[1],s[2],s[3]); end;
  end;

begin
  for i:=0 to aCnt do with aArr[i]^ do begin
    if KeyPressed then Error('');
    if IsFrontFace(pArr[pInd[0]]^.crd3,nrm) then begin
      pc:=4;
      for j:=0 to 3 do begin
        o[j].crd:=pArr[pInd[j]]^.crd3; o[j].nrm:=nrm;
        with o[j],aArr[i]^.c[j] do begin c.r:=r; c.g:=g;c.b:=b; end;
      end;
      PolyClip(pc,o);
      for j:=0 to pc-1 do begin
        MCtoDC3(o[j].crd,s[j]);
        with s[j].c,o[j] do begin
          r:=Round(c.r);g:=Round(c.g);b:=Round(c.b);
        end;
      end;
      if pc=4 then Draw4 else
       for j:=2 to pc-1 do FillTria(s[0],s[j-1],s[j]);
    end;
  end;
end;

procedure DrawAsSolid;
var ymin:real;
begin
  yMin:=-XSize/2*_PixelHochZuBreit*((_YmaxGlobal+1)/(_XmaxGlobal+1));
  SetViewGlobal(VRP,NRP,VUP,-Xsize/2,yMin,XSize,VPD,FPD,BPD);
  SetScreenGlobal(0,_YmaxGlobal,_XmaxGlobal,0);
  while DoLocalInit do begin
    Updatemats;
    DrawSolid;
  end;
end;

procedure ShareEnergy(aNr:integer);
var sVRP,sNRP,sVUP:vct3;
    p1,p2,p3,p4:vct3;
    mArea,i:integer; pa:paInfTyp;

  procedure FormFaksToEnergy;
  var i:integer; Pi:paInfTyp;
      radr,radg,radb:real; aErg:RGB;
  begin
    aErg:=pa^.dBA;
    for i:=0 to aCnt do begin
      Pi:=aArr[i];
      if Pi^.mInd<>mArea then with Pi^ do begin
        radr:=Refl.r*pa^.dBA.r*FormFak;
        radg:=Refl.g*pa^.dBA.g*FormFak;
        radb:=Refl.b*pa^.dBA.b*FormFak;
        dBA.r:=dBA.r+radr;
        dBA.g:=dBA.g+radg;
        dBA.b:=dBA.b+radb;
        aErg.r:=aErg.r-radr;aErg.g:=aErg.g-radg;aErg.b:=aErg.b-radb;
        b.r:=b.r+radr/AWidth;
        b.g:=b.g+radg/AWidth;
        b.b:=b.b+radb/AWidth;
      end;
    end;
    Ambi.r:=Ambi.r-AverageColor.r*aErg.r/TotAWidth;
    Ambi.g:=Ambi.g-AverageColor.g*aErg.g/TotAWidth;
    Ambi.b:=Ambi.b-AverageColor.b*aErg.b/TotAWidth;
  end;

  function jitter(p1,p2,p3,p4:real):real;
  var pa,pe:real;
  begin
    pa:=p1+Random*(p2-p1);pe:=p4+Random*(p3-p4);
    jitter:=pa+Random*(pe-pa);
  end;

begin
  Randomize;
  pa:=aArr[aNr]; with pa^ do begin
    mArea:=mInd;
    p1:=pArr[pInd[0]]^.crd3;
    p2:=pArr[pInd[1]]^.crd3;
    p3:=pArr[pInd[2]]^.crd3;
    p4:=pArr[pInd[3]]^.crd3;
    sNRP.x:=jitter(p1.x,p2.x,p3.x,p4.x);
    sNRP.y:=jitter(p1.y,p2.y,p3.y,p4.y);
    sNRP.z:=jitter(p1.z,p2.z,p3.z,p4.z);
    sVRP.x:=sNRP.x+NRM.x;
    sVRP.y:=sNRP.y+NRM.y;
    sVRP.z:=sNRP.z+NRM.z;
    sVUP.x:=Random-0.5;
    sVUP.y:=Random-0.5;
    sVUP.z:=Random-0.5;
    SetViewing(sVRP,sNRP,sVUP,-PlaneWCSize0/2,-PlaneWCSize0/2,
               PlaneWCSize0/2,PlaneWCSize0/2,1,0.95,-2);
    SetScreen(0,PlaneSize-1,PlaneSize-1,0,false);
    Updatemats;
    ClearPlane; for i:=0 to aCnt do aArr[i]^.FormFak:=0;
    AreasToPlane(aNr); PlaneToFormFaks(0);
    if HighMidEnabled then begin
      PlaneToFrame;
      SetViewing(sVRP,sNRP,sVUP,-PlaneWCSize1/2,-PlaneWCSize1/2,
                 PlaneWCSize1/2,PlaneWCSize1/2,1,0.95,-2);
      Updatemats;
      ClearPlane;
      AreasToPlane(aNr); PlaneToFormFaks(1);
    end;
    FormFaksToEnergy;
    PlaneToFrame;
    dBA:=RGB_0;
  end;
end;

function SearchBAMax:integer;
var i,nr:integer; BAakt,BAmax:real;
begin
  BAmax:=0; nr:=0;
  for i:=0 to aCnt do begin
    with aArr[i]^ do BAakt:=Sqr(dBA.r)+Sqr(dBA.b)+Sqr(dBA.g);
    if BAakt>BAmax then begin BAmax:=BAakt; nr:=i; end;
  end;
  SearchBAMax:=nr;
end;

procedure laden;
var name:namestr;
    suche:searchrec;
begin
  suche.name:='*.SCN';
  findfirst('*.SCN',$3f,suche);
  while (doserror=0) do begin
    write(suche.name:20);
    findnext(suche);
  end;
  writeln;
  write('Geben Sie den Bilddateinamen ein (ohne Extension) : ');
  readln(name);
  suche.name:=name+'.SCN';
  findfirst(name+'.SCN',$3f,suche);
  if doserror=0 then readascfile(name+'.SCN') else begin
    textcolor(red);
    writeln(name+'.SCN nicht gefunden !',^G);
    delay(1000);
  end;
end;

procedure iteration;
var aNr:integer;
begin
  GetPlaneMem;
  if anzeige<>nichts then begin
    grafmode:=-2;
    grafikinit;
  end;
  if (((anzeige=solid) or displayplane) and (anzeige<>nichts)) then CalcVTXCols;
  case anzeige of
    draht:DrawAsWire;
    solid:DrawAsSolid;
    nichts:write('Iterationen :',i:4);
  end;
  repeat
    inc(i);
    aNr:=SearchBAMax;
    if anzeige<>nichts then MarkArea(aNr,255,0,0) else begin
      gotoxy(wherex-3,wherey);
      write(i:3);
    end;
    ShareEnergy(aNr);
    if (displayplane and (anzeige<>nichts)) then CalcVTXCols;
  until keypressed;
  if not (displayplane and (anzeige<>nichts)) then CalcVTXCols;
  while keypressed do ein:=readkey;
  if anzeige<>nichts then grafikende;
  ReleasePlaneMem;
end;

procedure anzeigen;
begin
  repeat
    while abfrage do if not ende then begin
      if grafmode<0 then drawsolid else begin
        graph.setcolor(white);
        drawwire;
      end;
    end;
    if not ende then begin
      grafikbegin;
      if grafmode<0 then drawassolid else drawaswire;
      if name<>'' then savebild;
      write(^G);
      repeat until keypressed;
      grafikende;
    end;
  until ende;
end;

procedure Maske;
begin
  textbackground(blue);
  textcolor(yellow);
  clrscr;
  writeln('*** Radiosity ***':30);
  writeln;
  writeln('A) Szenerie einlesen');
  write('B) Maxl = ');
  textcolor(lightmagenta);
  writeln(maxl:6:3);
  if geladen then textcolor(yellow) else textcolor(lightgray);
  writeln('C) Iterationen ausfhren');
  textcolor(yellow);
  write('   1) ');
  textcolor(lightmagenta);
  if highmidenabled then writeln('Zwei Ebenen werden berechnet !')
  else writeln('Eine Ebene wird berechnet !');
  textcolor(yellow);
  write('   2) Die Ebene wird');textcolor(lightmagenta);
  if not displayplane then write(' nicht');
  textcolor(yellow);
  writeln(' angezeigt !      ');
  write('   3) ');textcolor(lightmagenta);
  case anzeige of
    draht:write('Ein Drahtgittermodell');
    solid:write('Ein Flchenmodell');
    nichts:write('Nichts');
  end;
  textcolor(yellow);
  writeln(' wird angezeigt !');
  if geladen then textcolor(yellow) else textcolor(lightgray);
  writeln('D) Bild anzeigen');
  textcolor(yellow);
  writeln('E) Ende');
end;

function getreal(r:real;s:string):real;
var s1:string;
    rh:real;
    err:integer;
begin
  textcolor(lightgreen); write(s:55,'? ');
  textcolor(lightmagenta); write('[',r:8:4,']');
  readln(s1);
  if s1='' then getreal:=r else begin
    val(s1,rh,err);
    if err<>0 then begin
      if upcase(s1[1])='Q' then error('Auf Wiedersehen !');
      getreal:=r;
    end else getreal:=rh;
  end;
end;

begin
  FillFFTab;
  if paramcount<>0 then readASCFile(paramstr(1)+'.SCN');
  repeat
    maske;
    repeat until keypressed;
    while keypressed do ein:=upcase(readkey);
    case ein of
      'A':laden;
      'B':maxl:=getreal(maxl,'Gebe die Auflsung an');
      'C':if geladen then iteration;
      '1':highmidenabled:=not highmidenabled;
      '2':displayplane:=not displayplane;
      '3':begin inc(anzeige); if byte(anzeige)>=3 then anzeige:=draht; end;
      'D':if geladen then anzeigen;
    end;
  until ein='E';
end.
