unit vgargb;
interface
const RGB_xsize=360;
      RGB_ysize=480;
      kartemaxx=359;
      kartemaxy=479;
procedure rgb_dot(x,y:word;r,g,b:word);
procedure rgb_line(x1,y1,x2,y2,r,g,b:integer);
procedure rgb_on;
procedure rgb_off;

implementation
uses dos,vga;

procedure setclutrgb;
var r,b,g,redi,greeni,bluei,colorindex:integer;
begin
  for r:=0 to 7 do begin
    redi:=r*9;
    for g:=0 to 7 do begin
      greeni:=g*9;
      for b:=0 to 3 do begin
        bluei:=b*21;
        colorindex:=(r shl 3 or g) shl 2 or b;
        farbe(colorindex,redi,greeni,bluei);
      end;
    end;
  end;
end;

PROCEDURE rgb_on;
begin
  scqmode;
  setclutrgb;
end;

procedure rgb_off;
begin
  vgaende;
end;

procedure savepic(name:string);
var n:byte;
    datei:file;
begin
  assign(datei,name+'.PIC');
  rewrite(datei,1);
  for n:=0 to 3 do begin
    readmap(n);
    blockwrite(datei,mem[$A000:0],43200);
  end;
  close(datei);
end;

procedure loadpic(name:string);
var datei:file;
    n:byte;
begin
  scqmode;
  setclutrgb;
  assign(datei,name+'.PIC');
  reset(datei,1);
  for n:=0 to 3 do begin
    map(16-(1 shl n));
    blockread(datei,mem[$A000:0],43200);
  end;
  close(datei);
end;

procedure rgb_dot(x,y:word; r,g,b:word);
var cmp,
    ri,gi,bi,
    rr,gr,br:integer;
    hilf:byte;
const dm:array[0..3,0..3] of byte =
         ((0,8,2,10),(12,4,14,6),
          (3,11,1,9),(15,7,13,5));
begin
  {$R-}
  r:=r div 4;
  g:=g div 4;
  b:=b div 4;
  cmp:=dm[x and 3,y and 3];
  if r<0 then ri:=0 else if r>63 then ri:=7 else begin
    ri:=r shr 3-1;
    rr:=(r and 7) shl 1;
    if rr>cmp then inc(ri)
    else if ri<0 then ri:=0;
  end;
  if g<0 then gi:=0 else if g>63 then gi:=7 else begin
    gi:=g shr 3-1;
    gr:=(g and 7) shl 1;
    if gr>cmp then inc(gi)
    else if gi<0 then gi:=0;
  end;
  if b<0 then bi:=0 else if b>63 then bi:=7 else begin
    bi:=b shr 4-1;
    br:=b and 15;
    if br>cmp then inc(bi)
    else if bi<0 then bi:=0;
  end;
  hilf:=ri*32+gi*4+bi;
  asm
    mov cx,x
    cmp y,480
    jae @ausserhalb
    cmp cx,360
    jae @ausserhalb
    mov ax,90
    mul y
    mov dx,x
    shr dx,1
    shr dx,1
    add ax,dx
    mov di,ax
    mov dx,$03c4
    mov al,2
    out dx,al
    inc dx
    and cl,3
    mov al,1
    shl al,cl
    out dx,al
    mov ax,$a000
    mov es,ax
    mov al,hilf
    mov es:[di],al
    @ausserhalb:
  end;
end;

procedure rgb_line(x1,y1,x2,y2,r,g,b:integer);
type intf=record case boolean of
            true:(fix:longint);
            false:(f:word;i:integer);
          end;
var dyddx,dxddy,sy,sx:intf; dy,dx,h:integer;
begin
  dy:=abs(y2-y1); dx:=abs(x2-x1);
  if (dx>dy) then begin
    if x2<x1 then begin h:=x1; x1:=x2; x2:=h; h:=y1; y1:=y2; y2:=h; end;
    rgb_dot(x1,y1,r,g,b);
    if dx<>0 then begin
      sy.i:=y1; sy.f:=$8000;
      dyddx.i:=y2-y1; dyddx.f:=0;dyddx.fix:=dyddx.fix div dx;
      while x1<x2-1 do begin
        inc(x1); inc(sy.fix,dyddx.fix); rgb_dot(x1,sy.i,r,g,b);
      end;
      rgb_dot(x2,y2,r,g,b);
    end;
  end else begin
    if y2<y1 then begin h:=x1; x1:=x2; x2:=h; h:=y1; y1:=y2; y2:=h; end;
    rgb_dot(x1,y1,r,g,b);
    if dy<>0 then begin
      sx.i:=x1; sx.f:=$8000;
      dxddy.i:=x2-x1; dxddy.f:=0;dxddy.fix:=dxddy.fix div dy;
      while y1<y2-1 do begin
        inc(y1); inc(sx.fix,dxddy.fix); rgb_dot(sx.i,y1,r,g,b);
      end;
      rgb_dot(x2,y2,r,g,b);
    end;
  end;
end;

end.