function donorm(var v:vct3):boolean;
var norm:real;
begin
  norm:=sqrt(sqr(v.x)+sqr(v.y)+sqr(v.z));
  if abs(norm)<epsilon then donorm:=true else begin
    v.x:=v.x / norm; v.y:=v.y / norm; v.z:=v.z /norm;
    donorm:=false;
  end;
end;

procedure mulmat(a,b:mat4; var c:mat4);
var i:integer;
begin
  for i:=0 to 3 do begin
    c[0,i]:=a[0,0]*b[0,i]+a[0,1]*b[1,i]+a[0,2]*b[2,i]+a[0,3]*b[3,i];
    c[1,i]:=a[1,0]*b[0,i]+a[1,1]*b[1,i]+a[1,2]*b[2,i]+a[1,3]*b[3,i];
    c[2,i]:=a[2,0]*b[0,i]+a[2,1]*b[1,i]+a[2,2]*b[2,i]+a[2,3]*b[3,i];
    c[3,i]:=a[3,0]*b[0,i]+a[3,1]*b[1,i]+a[3,2]*b[2,i]+a[3,3]*b[3,i];
  end;
end;

procedure invmat(a:mat4; var am1:mat4);
var det:real;
    i,j,i1,i2,j1,j2,j3,i3:integer;
    negflag:boolean;
begin
  negflag:=false;
  for i:=0 to 3 do begin
    i1:=(succ(i)) and 3; i2:=(i+2) and 3 ; i3:=(i+3) and 3;
    for j:=0 to 3 do begin
      j1:=(succ(j)) and 3; j2:=(j+2) and 3; j3:=(j+3) and 3;
      am1[j,i]:=a[i1,j1]*(a[i2,j2]*a[i3,j3] - a[i2,j3]*a[i3,j2]) +
                a[i1,j2]*(a[i2,j3]*a[i3,j1] - a[i2,j1]*a[i3,j3]) +
                a[i1,j3]*(a[i2,j1]*a[i3,j2] - a[i2,j2]*a[i3,j1]);
      if negflag then am1[j,i]:=-am1[j,i];
      negflag:=not negflag;
    end;
    negflag:=not negflag;
  end;
  det:=a[0,0]*am1[0,0];
  for i:=1 to 3 do det:=det+a[0,i]*am1[i,0];
  if abs(det)<epsilon then error('Matrix nicht regulr!');
  for i:=0 to 3 do for j:=0 to 3 do am1[i,j]:=am1[i,j]/det;
end;

procedure setviewing(VRP,NRP,VUP:vct3;
                     xmin,ymin,xmax,ymax,vpd,fpd,bpd:real);
var  WC_vrc,vrc_npc,npc_wc:mat4;

  procedure calcwc_vrc(var wc_vrc:mat4);
  var vpn: vct3;
    scal: real;
  begin
    wc_vrc[0][0]:=1.0;
    wc_vrc[0][1]:=vrp.x; wc_vrc[0][2]:=vrp.y;  wc_vrc[0][3]:=vrp.z;
    vpn.x:=nrp.x - vrp.x;
    vpn.y:=nrp.y - vrp.y;
    vpn.z:=nrp.z - vrp.z;
    if donorm(vpn) then error('calcWC_VRC: VRP und NRP sind identisch!');
    WC_VRC[3][0]:=0.0; WC_VRC[3][1]:=vpn.x;
    WC_VRC[3][2]:=vpn.y; WC_VRC[3][3]:=vpn.z;
    scal:=vup.x*vpn.x+vup.y*vpn.y+vup.z*vpn.z;
    vup.x:=vup.x-scal*vpn.x;
    vup.y:=vup.y-scal*vpn.y;
    vup.z:=vup.z-scal*vpn.z;
    if donorm(vup) then error('calcWC_VRC: VUP liegt kollinear zu (VRP,NRP)');
    WC_VRC[2][0]:=0.0;WC_VRC[2][1]:=vup.x;
    WC_VRC[2][2]:=vup.y;WC_VRC[2][3]:=vup.z;
    WC_VRC[1][0]:=0.0;
    wc_vrc[1][1]:=vup.y*vpn.z - vup.z*vpn.y;
    wc_vrc[1][2]:=vup.z*vpn.x - vup.x*vpn.z;
    wc_vrc[1][3]:=vup.x*vpn.y - vup.y*vpn.x;
    eyepoint.x:=vpn.x*vpd+vrp.x;
    eyepoint.y:=vpn.y*vpd+vrp.y;
    eyepoint.z:=vpn.z*vpd+vrp.z;
  end;

  procedure calcVRC_NPC(var VRC_NPC:mat4);
  var k,l:real;
  begin
    k := (VPD - bpd) / VPD;
    l := (fpd - bpd) / (VPD - fpd);

    VRC_NPC[0][0]:=1.0; VRC_NPC[0][1]:=k*xMin;
    VRC_NPC[0][2]:=k*yMin; VRC_NPC[0][3]:=BPD;

    VRC_NPC[1][0]:=0.0; VRC_NPC[1][1]:=k*(xmax-xMin);
    VRC_NPC[1][2]:=0.0; VRC_NPC[1][3]:=0.0;

    VRC_NPC[2][0]:=0.0; VRC_NPC[2][1]:=0.0;
    VRC_NPC[2][2]:=k*(ymax-yMin); VRC_NPC[2][3]:=0.0;

    VRC_NPC[3][0]:=l; VRC_NPC[3][1]:=0.0;
    VRC_NPC[3][2]:=0.0; VRC_NPC[3][3]:=l*VPD;
  end;

begin
  CalcWC_VRC(WC_VRC);
  CalcVRC_NPC(VRC_NPC);
  MulMat(VRC_NPC,WC_VRC,NPC_WC);
  InvMat(NPC_WC,WC_NPC);
  MatsChanged:=true;
end;

procedure SetViewGlobal(VRP,NRP,VUP:vct3;xmin,ymin,xSize,VPD, FPD, BPD: real);
begin
  _VRP:=VRP; _NRP:=NRP; _VUP:=VUP;
  _VPD:=VPD; _FPD:=FPD; _BPD:=BPD;
  _XMIN:=XMIN; _YMIN:=YMIN; _XSIZE:=XSIZE;
end;

procedure SetScreen(lux,luy,rox,roy:real;frame:boolean);
begin
  xwinsize:=rox-lux; xwinofs:=round(lux);
  ywinsize:=roy-luy; ywinofs:=round(luy);
  if frame then begin
    line2d(lux,luy,rox,luy);
    line2d(lux,roy,rox,roy);
    line2d(lux,luy,lux,roy);
    line2d(rox,luy,rox,roy);
  end;
  NPC_DC:=E;
  NPC_DC[1,1]:=xwinsize;NPC_DC[2,2]:=ywinsize;
  NPC_DC[3,3]:=maxint;
  NPC_DC[0,1]:=xwinofs;NPC_DC[0,2]:=ywinofs;
  MatsChanged:=true;
end;

procedure SetScreenGlobal(lux,luy,rox,roy:real);
begin
  _lux:=lux; _luy:=luy; _rox:=rox; _roy:=roy;
  _YSubO:=Round(_roy); _YSubU:=Round(_roy-1);
  _ySize:=_xSize*_PixelHochZuBreit*(luy-roy)/(rox-lux);
  _SpanMemSize:=Round((_rox+1)*2);
end;

function dolocalinit:boolean;
var i:integer;
    pages,availpages,page,zeilen:word;
    emsbenutztgewesen:boolean;
begin
  for i:=_Ysubo to _ysubu do
    freemem(zbuffer[i],_spanmemsize);
  if _useems then begin
    restorepagemap(emshandle);
    deallocatepages(emshandle);
    _useems:=false;
    emsbenutztgewesen:=true;
  end else emsbenutztgewesen:=false;
  if (_ysubu=_luy) or emsbenutztgewesen then
    dolocalinit:=false
  else begin
    dolocalinit:=true;
    inc(_ysubu);
    _ysubo:=_ysubu;
    while (memavail>_spanmemsize+speicherplatz) and (_ysubu<=_luy) do begin
      getmem(zbuffer[_ysubu],_spanmemsize);
      fillchar(zbuffer[_ysubu]^,_spanmemsize,0);
      inc(_ysubu);
    end;
    dec(_ysubu);
    zeilen:=_ysubu;
    if (_ysubu<>_luy) and emmavail then begin
      i:=0;
      emsmemory(totalpages,availpages);
      inc(i,emmresult);
      totalpages:=((round(_luy)-_ysubu)*2*succ(kartemaxx) + $3fff) div $4000;
      if availpages>=totalpages then begin
        emshandle:=allocatepages(totalpages);
        inc(i,emmresult);
        for page:=0 to pred(totalpages) do begin
          mappage(emshandle,page,0);
          inc(i,emmresult);
          fillchar(mem[emsframeaddr:$0000],$4000,0);
        end;
        if totalpages>4 then pages:=4 else pages:=totalpages;
        for page:=0 to pred(pages) do mappage(emshandle,page,page);
        inc(i,emmresult);
        emsbufbegin:=0;
        _useems:=true;
        zeilen:=round(_luy);
        if i<>0 then error('EMS Fehler');
      end;
    end;
    SetViewing(_VRP,_NRP,_VUP,
               _xMin,_yMin+_ySize*(_luy-zeilen)/(_luy-_roy),
               _xMin+_xSize,_yMin+_ySize*(_luy-_YSubO)/(_luy-_roy),
               _VPD,_FPD,_BPD);
    SetScreen(_lux,zeilen,_rox,_YSubO,false);
  end;
end;

procedure Rotate(achse:integer;w:real);
var s,c:real;
    M:mat4;
begin
  M:=E;
  w:=w*pi/180.0;
  s:=sin(w); c:=cos(w);
  case achse of
    1: begin M[2][2]:=c; M[2][3]:=s; M[3][2]:=-s; M[3][3]:=c; end;
    2: begin M[1][1]:=c; M[1][3]:=-s; M[3][1]:=s; M[3][3]:=c; end;
    3: begin M[1][1]:=c; M[1][2]:=s; M[2][1]:=-s; M[2][2]:=c; end;
  end;
  MulMat(M,MC_WC,MC_WC);
  MatsChanged:=true;
end;

procedure translate(xv,yv,zv:real);
var M:mat4;
begin
  M:=E;
  M[0][1]:=xv; M[0][2]:=yv; M[0][3]:=zv;
  MulMat(M,MC_WC,MC_WC);
  MatsChanged:=true;
end;

procedure Scale(scx,scy,scz:real);
var M:mat4;
begin
  m:=E;
  m[1][1]:=scx; m[2][2]:=scy; m[3][3]:=scz;
  MulMat(M,MC_WC,MC_WC);
  MatsChanged:=true;
end;

procedure updateMats;
begin
  if MatsChanged then begin
    MulMat(MC_WC,WC_NPC,MC_NPC);
    MulMat(MC_NPC,NPC_DC,MC_DC);
    MulMat(WC_NPC,NPC_DC,WC_DC);
    InvMat(MC_WC,WC_MC);
    InvMat(MC_NPC,NPC_MC);
    MatsChanged:=false;
  end;
end;

procedure npctodc(a:vct4; var x,y:real);
begin
  x:=npc_dc[0,1]+a.x/a.w*NPC_DC[1,1];
  y:=npc_dc[0,2]+a.y/a.w*NPC_DC[2,2];
end;

procedure mctonpc(a:vct3;var as:vct4);
begin
  as.w:=mc_npc[0,0]+a.x*mc_npc[1,0]+a.y*mc_npc[2,0]+a.z*mc_npc[3,0];
  as.x:=mc_npc[0,1]+a.x*mc_npc[1,1]+a.y*mc_npc[2,1]+a.z*mc_npc[3,1];
  as.y:=mc_npc[0,2]+a.x*mc_npc[1,2]+a.y*mc_npc[2,2]+a.z*mc_npc[3,2];
  as.z:=mc_npc[0,3]+a.x*mc_npc[1,3]+a.y*mc_npc[2,3]+a.z*mc_npc[3,3];
end;

procedure mctowc_vertex(amc:vertex; var awc:vertex);
begin
  with amc.crd do begin
    awc.crd.x:=mc_wc[0][1] + x*MC_WC[1][1] + y*MC_WC[2][1] + z*MC_WC[3][1];
    awc.crd.y:=mc_wc[0][2] + x*MC_WC[1][2] + y*MC_WC[2][2] + z*MC_WC[3][2];
    awc.crd.z:=mc_wc[0][3] + x*MC_WC[1][3] + y*MC_WC[2][3] + z*MC_WC[3][3];
  end;
  with aMC.nrm do begin
    awc.nrm.x:=x*WC_MC[1][1] + y*WC_MC[1][2] + z*WC_MC[1][3];
    awc.nrm.y:=x*WC_MC[2][1] + y*WC_MC[2][2] + z*WC_MC[2][3];
    awc.nrm.z:=x*WC_MC[3][1] + y*WC_MC[3][2] + z*WC_MC[3][3];
  end;
  if donorm(awc.nrm) then error('Normale in Welt nicht definiert !');
  awc.c:=amc.c;
end;

procedure mctodc3(a:vct3; var ps:shd_vtx);
var w:real;
begin
  w:=MC_DC[0,0]+a.x*mc_dc[1,0]+a.y*mc_dc[2,0]+a.z*mc_dc[3,0];
  if abs(w)<epsilon then error('MCtoDC3: Punkt nicht definiert !');
  ps.x:=round((MC_DC[0,1]+a.x*mc_dc[1,1]+a.y*mc_dc[2,1]+a.z*mc_dc[3,1])/w);
  ps.y:=round((MC_DC[0,2]+a.x*mc_dc[1,2]+a.y*mc_dc[2,2]+a.z*mc_dc[3,2])/w);
  ps.z:=round((MC_DC[0,3]+a.x*mc_dc[1,3]+a.y*mc_dc[2,3]+a.z*mc_dc[3,3])/w);
end;

procedure pushtrafs;
begin
  updatemats;
  if trafstack=nil then begin
    new(trafstack);
    trafstack^.vor:=nil;
  end else begin
    new(trafstack^.nach);
    trafstack^.nach^.vor:=trafstack;
    trafstack:=trafstack^.nach;
  end;
  Trafstack^.mc_wc := mc_wc  ;
  Trafstack^.mc_npc := mc_npc;
  Trafstack^.mc_dc := mc_dc  ;
  Trafstack^.wc_npc := wc_npc;
  Trafstack^.wc_dc := wc_dc  ;
  Trafstack^.wc_mc := wc_mc  ;
  Trafstack^.npc_mc := npc_mc;
  Trafstack^.npc_dc := npc_dc;
end;

procedure poptrafs;
begin
  if trafstack=nil then error('Transformationsstack leer !');
  mc_wc :=  Trafstack^.mc_wc ;
  mc_npc:=  Trafstack^.mc_npc;
  mc_dc :=  Trafstack^.mc_dc ;
  wc_npc:=  Trafstack^.wc_npc;
  wc_dc :=  Trafstack^.wc_dc ;
  wc_mc :=  Trafstack^.wc_mc ;
  npc_mc:=  Trafstack^.npc_mc;
  npc_dc:=  Trafstack^.npc_dc;
  if trafstack^.vor=nil then begin
    dispose(trafstack);
    trafstack:=nil;
  end else begin
    trafstack:=trafstack^.vor;
    dispose(trafstack^.nach);
    trafstack^.nach:=nil;
  end;
  matschanged:=false;
end;

procedure copytrafs;
begin
  poptrafs;
  pushtrafs;
end;

function flipnormal(var a:vertex):boolean;
var mustflip:boolean;
    d,z:real;
begin
  if donorm(a.nrm) then begin
    error('Objektnormale nicht definiert');
  end;
  d:=a.crd.x * a.nrm.x + a.crd.y * a.nrm.y + a.crd.z * a.nrm.z;
  z:=  -d     * npc_mc[3,0] + a.nrm.x * npc_mc[3,1] +
      a.nrm.y * npc_mc[3,2] + a.nrm.z * npc_mc[3,3];
  if z<0 then begin
    if flipareaenabled then begin
      a.nrm.x:=-a.nrm.x;
      a.nrm.y:=-a.nrm.y;
      a.nrm.z:=-a.nrm.z;
      flipnormal:=true;
    end else flipnormal:=false;
  end else flipnormal:=true;
end;

procedure WCtoDc(a:vct3; var x,y,z:integer);
var w:real;
begin
  w:=WC_DC[0,0]+a.x*WC_DC[1,0]+a.y*WC_DC[2,0]+a.z*WC_DC[3,0];
  if abs(w)<epsilon then error('WCtoDC: Punkt nicht definiert!');
  x:=round((WC_DC[0,1]+a.x*WC_DC[1,1]+a.y*WC_DC[2,1]+a.z*WC_DC[3,1])/w);
  y:=round((WC_DC[0,2]+a.x*WC_DC[1,2]+a.y*WC_DC[2,2]+a.z*WC_DC[3,2])/w);
  z:=round((WC_DC[0,3]+a.x*WC_DC[1,3]+a.y*WC_DC[2,3]+a.z*WC_DC[3,3])/w);
end;

procedure MCtoDC(a:vct3; var x,y:real);
var w:real;
begin
  w:=MC_DC[0,0]+a.x*MC_DC[1,0]+a.y*MC_DC[2,0]+
            a.z*MC_DC[3,0];
  if abs(w)<epsilon then error('MCtoDC: Punkt nicht deffiniert!');
  x:=(MC_DC[0,1]+a.x*MC_DC[1,1]+a.y*MC_DC[2,1]+
      a.z*MC_DC[3,1])/w;
  y:=(MC_DC[0,2]+a.x*MC_DC[1,2]+a.y*MC_DC[2,2]+
      a.z*MC_DC[3,2])/w;
end;

procedure mctodci(a:vct3; var x,y:integer);
var xr,yr:real;
begin
  MCtoDC(a,xr,yr);
  x:=round(xr); y:=round(yr);
end;

