unit transrot;
{$E+}{$N+}
interface
uses trans3d,dos;
type koord2d=record x,y:real; end;
     umrisstyp=record
                 punkt:array[0..maxpnts] of record
                         crd,nrm:koord2d;
                         color:rgbb;
                       end;
                 xmax,ymin,ymax:real;
                 punktanzahl:shortint;
                 ka,kd,ks,osr,osg,osb,oe,odr,odg,odb,otrans:real;
                 color:rgbb;
               end;
const normen=1;
      ring=2;
      nichtnormen=0;

procedure umrissfarbe(r,g,b:real;var umriss:umrisstyp);
procedure umrisssurface(var umriss:umrisstyp);
procedure rotationskoerper(n:integer;umriss:umrisstyp;winkel:word;zunormen:byte);
procedure zylinderkoerper(n:integer;umriss:umrisstyp;zunormen:byte);
procedure ladeumriss(name:namestr;var umriss:umrisstyp);
procedure sichereumriss(name:namestr;var umriss:umrisstyp);

implementation

procedure umrissfarbe(r,g,b:real;var umriss:umrisstyp);
var z:byte;
begin
  for z:=0 to umriss.punktanzahl do with umriss.punkt[z] do begin
    color.r:=trunc(r*63);
    color.g:=trunc(g*63);
    color.b:=trunc(b*63);
  end;
end;

procedure umrisssurface(var umriss:umrisstyp);
begin
  with umriss do changesurfaceproperty(ka,kd,ks,osr,osg,osb,oe,odr,odg,odb,otrans);
end;

procedure rotationskoerper(n:integer;umriss:umrisstyp;winkel:word;zunormen:byte);
var yvol,betrag,ch,dc,ds,st,ct,sn,cn:real;
    p:vertex;
    a,t:integer;
    hilfe,hilfe2:koord2d;

begin
  with umriss do begin
    if punktanzahl>0 then begin
      if abs(ymin)<abs(ymax) then yvol:=ymax else yvol:=ymin;
      defineclipvolume(xmax,xmax,yvol,color.r/63,color.g/63,color.b/63);
      if clipmode<>outside then begin
        _wrkarr.volume.x:=xmax;
        _wrkarr.volume.y:=xmax;
        _wrkarr.volume.z:=yvol;
        _wrkarr.ymax:=n;
        _wrkarr.xmax:=punktanzahl;

        if zunormen>nichtnormen then begin
          for a:=0 to pred(punktanzahl) do with punkt[a] do begin
            nrm.x:=crd.y-punkt[succ(a)].crd.y;
            nrm.y:=punkt[succ(a)].crd.x-crd.x;
          end;
          with punkt[punktanzahl] do begin
            nrm.x:=crd.y-punkt[0].crd.y;
            nrm.y:=punkt[0].crd.x-crd.x;
          end;
          for a:=0 to punktanzahl do with punkt[a].nrm do begin
            betrag:=sqrt(sqr(x)+sqr(y));
            if betrag<>0 then betrag:=1/betrag;
            x:=x*betrag;
            y:=y*betrag;
          end;
          hilfe:=punkt[0].nrm;
          for a:=1 to pred(punktanzahl) do with punkt[a] do begin
            hilfe2:=nrm;
            nrm.x:=hilfe.x+nrm.x;
            nrm.y:=hilfe.y+nrm.y;
            hilfe:=hilfe2;
          end;
          if zunormen=normen then punkt[punktanzahl].nrm:=hilfe
          else with punkt[punktanzahl] do begin
            nrm.x:=hilfe.x+nrm.x;
            nrm.y:=hilfe.y+nrm.y;
            punkt[0].nrm:=nrm;
          end;
        end;
        dc:=cos(2*PI*winkel/360/n); ds:=sqrt(1-dc*dc);
        for a:=0 to punktanzahl do with punkt[a] do begin
          p.crd.z:=crd.y;
          p.nrm.z:=nrm.y;
          p.c.r:=color.r/63;
          p.c.g:=color.g/63;
          p.c.b:=color.b/63;
          st:=0;
          ct:=crd.x;
          sn:=0;
          cn:=nrm.x;
          for t:=0 to n do with p do begin
            crd.x:=ct; crd.y:=st;
            nrm.x:=cn; nrm.y:=sn;
            _wrkarr.m[a]^[t].a:=p;
            _wrkarr.m[a]^[t].flags:=isvis;
            ch:=ct;
            ct:=ct*dc-st*ds;
            st:=st*dc+ch*ds;
            ch:=cn;
            cn:=cn*dc-sn*ds;
            sn:=sn*dc+ch*ds;
          end;
        end;
        mesh;
      end;
      undefclipvolume;
    end else error('Der Umriss fr den Rotationskrper besteht nur aus einem Punkt !');
  end;
end;

procedure zylinderkoerper(n:integer;umriss:umrisstyp;zunormen:byte);
var yvol,betrag:real;
    p:vertex;
    a,t:integer;
    hilfe,hilfe2:koord2d;

begin
  with umriss do begin
    if punktanzahl>0 then begin
      if abs(ymin)<abs(ymax) then yvol:=ymax else yvol:=ymin;
      defineclipvolume(xmax,1,yvol,color.r/63,color.g/63,color.b/63);
      if clipmode<>outside then begin
        _wrkarr.volume.x:=xmax;
        _wrkarr.volume.y:=1;
        _wrkarr.volume.z:=yvol;
        _wrkarr.ymax:=1;
        _wrkarr.xmax:=punktanzahl;

        if zunormen>nichtnormen then begin
          for a:=0 to pred(punktanzahl) do with punkt[a] do begin
            nrm.x:=crd.y-punkt[succ(a)].crd.y;
            nrm.y:=punkt[succ(a)].crd.x-crd.x;
          end;
          with punkt[punktanzahl] do begin
            nrm.x:=crd.y-punkt[0].crd.y;
            nrm.y:=punkt[0].crd.x-crd.x;
          end;
          for a:=0 to punktanzahl do with punkt[a].nrm do begin
            betrag:=sqrt(sqr(x)+sqr(y));
            if betrag<>0 then betrag:=1/betrag;
            x:=x*betrag;
            y:=y*betrag;
          end;
          hilfe:=punkt[0].nrm;
          for a:=1 to pred(punktanzahl) do with punkt[a] do begin
            hilfe2:=nrm;
            nrm.x:=hilfe.x+nrm.x;
            nrm.y:=hilfe.y+nrm.y;
            hilfe:=hilfe2;
          end;
          if zunormen=normen then punkt[punktanzahl].nrm:=hilfe
          else with punkt[punktanzahl] do begin
            nrm.x:=hilfe.x+nrm.x;
            nrm.y:=hilfe.y+nrm.y;
            punkt[0].nrm:=nrm;
          end;
        end;
        for a:=0 to punktanzahl do with punkt[a] do begin
          p.nrm.x:=nrm.x;
          p.nrm.y:=nrm.y;
          p.nrm.z:=0;
          p.crd.x:=crd.x;
          p.crd.y:=crd.y;
          p.c.r:=color.r/63;
          p.c.g:=color.g/63;
          p.c.b:=color.b/63;
          for t:=0 to n do with p do begin
            crd.z:=t*2/n-1;
            _wrkarr.m[a]^[t].a:=p;
            _wrkarr.m[a]^[t].flags:=isvis;
          end;
        end;
        mesh;
      end;
      undefclipvolume;
    end else error('Der Umriss fr den Zylinderkrper besteht nur aus einem Punkt !');
  end;
end;

procedure ladeumriss(name:namestr;var umriss:umrisstyp);
var umrissfile:file of umrisstyp;
    suche:searchrec;
begin
  findfirst(name+'.RIS',$3f,suche);
  if doserror=0 then begin
    assign(umrissfile,name+'.RIS');
    reset(umrissfile);
    read(umrissfile,umriss);
    close(umrissfile);
  end else error('Ich konnte '+name+'.RIS nicht laden !');
end;

procedure sichereumriss(name:namestr;var umriss:umrisstyp);
var umrissfile:file of umrisstyp;
begin
  if name<>'' then begin
    assign(umrissfile,name+'.RIS');
    rewrite(umrissfile);
    write(umrissfile,umriss);
    close(umrissfile);
  end;
end;

end.