function donorm(var v:vct3):boolean;
var norm:real;
begin
  norm:=sqrt(sqr(v.x)+sqr(v.y)+sqr(v.z));
  if abs(norm)<epsilon then donorm:=true else begin
    v.x:=v.x / norm; v.y:=v.y / norm; v.z:=v.z /norm;
    donorm:=false;
  end;
end;

procedure mulmat(a,b:mat4; var c:mat4);
var i:integer;
begin
  for i:=0 to 3 do begin
    c[0,i]:=a[0,0]*b[0,i]+a[0,1]*b[1,i]+a[0,2]*b[2,i]+a[0,3]*b[3,i];
    c[1,i]:=a[1,0]*b[0,i]+a[1,1]*b[1,i]+a[1,2]*b[2,i]+a[1,3]*b[3,i];
    c[2,i]:=a[2,0]*b[0,i]+a[2,1]*b[1,i]+a[2,2]*b[2,i]+a[2,3]*b[3,i];
    c[3,i]:=a[3,0]*b[0,i]+a[3,1]*b[1,i]+a[3,2]*b[2,i]+a[3,3]*b[3,i];
  end;
end;

procedure invmat(a:mat4; var am1:mat4);
var det:real;
    i,j,i1,i2,j1,j2,j3,i3:integer;
    negflag:boolean;
begin
  negflag:=false;
  for i:=0 to 3 do begin
    i1:=(succ(i)) and 3; i2:=(i+2) and 3 ; i3:=(i+3) and 3;
    for j:=0 to 3 do begin
      j1:=(succ(j)) and 3; j2:=(j+2) and 3; j3:=(j+3) and 3;
      am1[j,i]:=a[i1,j1]*(a[i2,j2]*a[i3,j3] - a[i2,j3]*a[i3,j2]) +
                a[i1,j2]*(a[i2,j3]*a[i3,j1] - a[i2,j1]*a[i3,j3]) +
                a[i1,j3]*(a[i2,j1]*a[i3,j2] - a[i2,j2]*a[i3,j1]);
      if negflag then am1[j,i]:=-am1[j,i];
      negflag:=not negflag;
    end;
    negflag:=not negflag;
  end;
  det:=a[0,0]*am1[0,0];
  for i:=1 to 3 do det:=det+a[0,i]*am1[i,0];
  if abs(det)<epsilon then error('Matrix nicht regulr!');
  for i:=0 to 3 do for j:=0 to 3 do am1[i,j]:=am1[i,j]/det;
end;

procedure Rotate(achse:integer;w:real);
var s,c:real;
    M:mat4;
begin
  M:=E;
  w:=w*pi/180.0;
  s:=sin(w); c:=cos(w);
  case achse of
    1: begin M[2][2]:=c; M[2][3]:=s; M[3][2]:=-s; M[3][3]:=c; end;
    2: begin M[1][1]:=c; M[1][3]:=-s; M[3][1]:=s; M[3][3]:=c; end;
    3: begin M[1][1]:=c; M[1][2]:=s; M[2][1]:=-s; M[2][2]:=c; end;
  end;
  MulMat(M,MC_WC,MC_WC);
  MatsChanged:=true;
end;

procedure translate(xv,yv,zv:real);
var M:mat4;
begin
  M:=E;
  M[0][1]:=xv; M[0][2]:=yv; M[0][3]:=zv;
  MulMat(M,MC_WC,MC_WC);
  MatsChanged:=true;
end;

procedure Scale(scx,scy,scz:real);
var M:mat4;
begin
  m:=E;
  m[1][1]:=scx; m[2][2]:=scy; m[3][3]:=scz;
  MulMat(M,MC_WC,MC_WC);
  MatsChanged:=true;
end;

procedure updateMats;
begin
{  if MatsChanged then begin
    MulMat(MC_WC,WC_NPC,MC_NPC);
    MulMat(MC_NPC,NPC_DC,MC_DC);
    MulMat(WC_NPC,NPC_DC,WC_DC);
    InvMat(MC_WC,WC_MC);
    InvMat(MC_NPC,NPC_MC);
    MatsChanged:=false;
  end;}
end;

{procedure npctodc(a:vct4; var x,y:real);
begin
  x:=npc_dc[0,1]+a.x/a.w*NPC_DC[1,1];
  y:=npc_dc[0,2]+a.y/a.w*NPC_DC[2,2];
end;

procedure mctonpc(a:vct3;var as:vct4);
begin
  as.w:=mc_npc[0,0]+a.x*mc_npc[1,0]+a.y*mc_npc[2,0]+a.z*mc_npc[3,0];
  as.x:=mc_npc[0,1]+a.x*mc_npc[1,1]+a.y*mc_npc[2,1]+a.z*mc_npc[3,1];
  as.y:=mc_npc[0,2]+a.x*mc_npc[1,2]+a.y*mc_npc[2,2]+a.z*mc_npc[3,2];
  as.z:=mc_npc[0,3]+a.x*mc_npc[1,3]+a.y*mc_npc[2,3]+a.z*mc_npc[3,3];
end;

procedure mctowc_vertex(amc:vertex; var awc:vertex);
begin
  with amc.crd do begin
    awc.crd.x:=mc_wc[0][1] + x*MC_WC[1][1] + y*MC_WC[2][1] + z*MC_WC[3][1];
    awc.crd.y:=mc_wc[0][2] + x*MC_WC[1][2] + y*MC_WC[2][2] + z*MC_WC[3][2];
    awc.crd.z:=mc_wc[0][3] + x*MC_WC[1][3] + y*MC_WC[2][3] + z*MC_WC[3][3];
  end;
  with aMC.nrm do begin
    awc.nrm.x:=x*WC_MC[1][1] + y*WC_MC[1][2] + z*WC_MC[1][3];
    awc.nrm.y:=x*WC_MC[2][1] + y*WC_MC[2][2] + z*WC_MC[2][3];
    awc.nrm.z:=x*WC_MC[3][1] + y*WC_MC[3][2] + z*WC_MC[3][3];
  end;
  if donorm(awc.nrm) then error('Normale in Welt nicht definiert !');
  awc.c:=amc.c;
end;

procedure mctodc3(a:vct3; var ps:shd_vtx);
var w:real;
begin
  w:=MC_DC[0,0]+a.x*mc_dc[1,0]+a.y*mc_dc[2,0]+a.z*mc_dc[3,0];
  if abs(w)<epsilon then error('MCtoDC3: Punkt nicht definiert !');
  ps.x:=round((MC_DC[0,1]+a.x*mc_dc[1,1]+a.y*mc_dc[2,1]+a.z*mc_dc[3,1])/w);
  ps.y:=round((MC_DC[0,2]+a.x*mc_dc[1,2]+a.y*mc_dc[2,2]+a.z*mc_dc[3,2])/w);
  ps.z:=round((MC_DC[0,3]+a.x*mc_dc[1,3]+a.y*mc_dc[2,3]+a.z*mc_dc[3,3])/w);
end;
 }
procedure pushtrafs;
begin
  updatemats;
  if trafstack=nil then begin
    new(trafstack);
    trafstack^.vor:=nil;
  end else begin
    new(trafstack^.nach);
    trafstack^.nach^.vor:=trafstack;
    trafstack:=trafstack^.nach;
  end;
  Trafstack^.mc_wc := mc_wc  ;
end;

procedure poptrafs;
begin
  if trafstack=nil then error('Transformationsstack leer !');
  mc_wc :=  Trafstack^.mc_wc ;
  if trafstack^.vor=nil then begin
    dispose(trafstack);
    trafstack:=nil;
  end else begin
    trafstack:=trafstack^.vor;
    dispose(trafstack^.nach);
    trafstack^.nach:=nil;
  end;
  matschanged:=false;
end;

procedure copytrafs;
begin
  poptrafs;
  pushtrafs;
end;
{
function flipnormal(var a:vertex):boolean;
var mustflip:boolean;
    d,z:real;
begin
  if donorm(a.nrm) then begin
    error('Objektnormale nicht definiert');
  end;
  d:=a.crd.x * a.nrm.x + a.crd.y * a.nrm.y + a.crd.z * a.nrm.z;
  z:=  -d     * npc_mc[3,0] + a.nrm.x * npc_mc[3,1] +
      a.nrm.y * npc_mc[3,2] + a.nrm.z * npc_mc[3,3];
  if z<0 then begin
    if flipareaenabled then begin
      a.nrm.x:=-a.nrm.x;
      a.nrm.y:=-a.nrm.y;
      a.nrm.z:=-a.nrm.z;
      flipnormal:=true;
    end else flipnormal:=false;
  end else flipnormal:=true;
end;

procedure WCtoDc(a:vct3; var x,y,z:integer);
var w:real;
begin
  w:=WC_DC[0,0]+a.x*WC_DC[1,0]+a.y*WC_DC[2,0]+a.z*WC_DC[3,0];
  if abs(w)<epsilon then error('WCtoDC: Punkt nicht definiert!');
  x:=round((WC_DC[0,1]+a.x*WC_DC[1,1]+a.y*WC_DC[2,1]+a.z*WC_DC[3,1])/w);
  y:=round((WC_DC[0,2]+a.x*WC_DC[1,2]+a.y*WC_DC[2,2]+a.z*WC_DC[3,2])/w);
  z:=round((WC_DC[0,3]+a.x*WC_DC[1,3]+a.y*WC_DC[2,3]+a.z*WC_DC[3,3])/w);
end;

procedure MCtoDC(a:vct3; var x,y:real);
var w:real;
begin
  w:=MC_DC[0,0]+a.x*MC_DC[1,0]+a.y*MC_DC[2,0]+
            a.z*MC_DC[3,0];
  if abs(w)<epsilon then error('MCtoDC: Punkt nicht deffiniert!');
  x:=(MC_DC[0,1]+a.x*MC_DC[1,1]+a.y*MC_DC[2,1]+
      a.z*MC_DC[3,1])/w;
  y:=(MC_DC[0,2]+a.x*MC_DC[1,2]+a.y*MC_DC[2,2]+
      a.z*MC_DC[3,2])/w;
end;

procedure mctodci(a:vct3; var x,y:integer);
var xr,yr:real;
begin
  MCtoDC(a,xr,yr);
  x:=round(xr); y:=round(yr);
end;

procedure calclight;
begin
  if not lichtberechnet then begin
    _t:=sqrt(sqr(eyepoint.x-mc_wc[0][1])+sqr(eyepoint.y-mc_wc[0][2])+sqr(eyepoint.z-mc_wc[0][3]));
    _c:=eyepoint.x*eyepoint.x+eyepoint.y*eyepoint.y+eyepoint.z*eyepoint.z;
    _a:=p*p-1;
    _b:=v.x*eyepoint.x+v.y*eyepoint.y+v.z*eyepoint.z;
    if donorm(v) then error('Fehler in V');
    lichtberechnet:=true;
  end;
end;

procedure mctowclightspeed(a:vct3; var a2:vct3);
var b,t:real;
    ov:vct3;

begin
  with a do begin
    a2.x:=mc_wc[0][1] + x*MC_WC[1][1] + y*MC_WC[2][1] + z*MC_WC[3][1];
    a2.y:=mc_wc[0][2] + x*MC_WC[1][2] + y*MC_WC[2][2] + z*MC_WC[3][2];
    a2.z:=mc_wc[0][3] + x*MC_WC[1][3] + y*MC_WC[2][3] + z*MC_WC[3][3];
  end;
  ov.X:=A2.X+p*v.x*_t;
  ov.Y:=A2.Y+p*v.y*_t;
  ov.Z:=A2.Z+p*v.z*_t;

  b:=2*p*(_b-v.x*ov.x-v.y*ov.y-v.z*ov.z);
  t:=p*(_t-(-b-sqrt(b*b-4*_a*(_c+ov.x*ov.x+ov.y*ov.y+ov.z*ov.z
     -2*(eyepoint.x*ov.x+eyepoint.y*ov.y+eyepoint.z*ov.z))))/(2*_a));
  a2.x:=a2.x+v.x*t;
  a2.y:=a2.y+v.y*t;
  a2.z:=a2.z+v.z*t;
end;

procedure mctonpclightspeed(a:vct3; var as:vct4);
var a2:vct3;
begin
  mctowclightspeed(a,a2);
  as.w:=wc_npc[0,0]+a2.x*wc_npc[1,0]+a2.y*wc_npc[2,0]+a2.z*wc_npc[3,0];
  as.x:=wc_npc[0,1]+a2.x*wc_npc[1,1]+a2.y*wc_npc[2,1]+a2.z*wc_npc[3,1];
  as.y:=wc_npc[0,2]+a2.x*wc_npc[1,2]+a2.y*wc_npc[2,2]+a2.z*wc_npc[3,2];
  as.z:=wc_npc[0,3]+a2.x*wc_npc[1,3]+a2.y*wc_npc[2,3]+a2.z*wc_npc[3,3];
end;

procedure mctowc_vertexlightspeed(amc:vertex; var awc:vertex);
begin
  mctowclightspeed(amc.crd,awc.crd);
  with aMC.nrm do begin
    awc.nrm.x:=x*WC_MC[1][1] + y*WC_MC[1][2] + z*WC_MC[1][3];
    awc.nrm.y:=x*WC_MC[2][1] + y*WC_MC[2][2] + z*WC_MC[2][3];
    awc.nrm.z:=x*WC_MC[3][1] + y*WC_MC[3][2] + z*WC_MC[3][3];
  end;
  if donorm(awc.nrm) then error('Normale in Welt nicht definiert !');
  awc.c:=amc.c;
end;

procedure changespeed(newp,newvx,newvy,newvz:real);
begin
  if newp=0 then begin
    if lichtgesch then flipareaenabled:=_flip;
    lichtgesch:=false;
  end else begin
    lichtberechnet:=false;
    lichtgesch:=true;
    if abs(newvx)<0.001 then v.x:=0.001 else v.x:=newvx;
    if abs(newvy)<0.001 then v.y:=0.001 else v.y:=newvy;
    if abs(newvz)<0.001 then v.z:=0.001 else v.z:=newvz;
    p:=newp;
    if p>=1 then error('Man kann keinen Krper auf Lichtgeschwindigkeit beschleunigen !');
    _flip:=flipareaenabled;
    flipareaenabled:=true;
  end;
end;}