unit UOBJLIST;
interface

uses Objects, Drivers,  TGDialog, TGStdDlg, USzene;
const cmChangeObj=1804;
type
  ObjStr=string[67];
  { TObjEntry }

  PObjEntry = ^TObjEntry;
  TObjEntry = record
    DisplayText: PString;
    Obj: PObject;
  end;

  { TObjCollection is a collection of TObjEntry's used by       }
  { TObjListBox.                                                }

  PObjCollection = ^TObjCollection;
  TObjCollection = object(TCollection)
    procedure FreeItem(Item: Pointer); virtual;
  end;

  { TObjListBox displays a tree of Objectories for use in the }
  { TChObjDialog.                                               }

  PObjListBox = ^TObjListBox;
  TObjListBox = object(TListBox)
    Obj: PObject;
    Cur: Word;
    constructor Init(var Bounds: TRect; AScrollBar: PScrollBar);
    destructor Done; virtual;
    function GetText(Item: Integer; MaxLen: Integer): String; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    function IsSelected(Item: Integer): Boolean; virtual;
    procedure NewObjectory(var AObj: PObject);
    procedure SetState(AState: Word; Enable: Boolean); virtual;

    procedure GetSzene(var hobj,szene:PObject;var s:ObjStr); virtual;

    function GetPfad(obj:PObject):ObjStr virtual;
    procedure GetOwner(var obj:Pobject); virtual;

    procedure FindSubGroup(var hObj,obj:PObject;var s:objstr); virtual;

  end;



implementation

{ TObjCollection }

procedure TObjCollection.FreeItem(Item: Pointer);
var
  ObjItem: PObjEntry absolute Item;
begin
  DisposeStr(ObjItem^.DisplayText);
  Dispose(ObjItem);
end;

{ TObjListBox }

const
  SzenenS: String[6] = 'Szenen';
  Szenen: PString = @SzenenS;

constructor TObjListBox.Init(var Bounds: TRect; AScrollBar:
  PScrollBar);
begin
  TListBox.Init(Bounds, 1, AScrollBar);
  Obj := nil;
end;

destructor TObjListBox.Done;
begin
  if List <> nil then Dispose(List, Done);
  TListBox.Done;
end;

function TObjListBox.GetText(Item: Integer; MaxLen: Integer): String;
begin
  GetText := PObjEntry(List^.At(Item))^.DisplayText^;
end;

procedure TObjListBox.HandleEvent(var Event: TEvent);
begin
  if (Event.What = evMouseDown) and (Event.Double) then
  begin
    Event.What := evCommand;
    Event.Command := cmChangeObj;
    PutEvent(Event);
    ClearEvent(Event);
  end
  else TListBox.HandleEvent(Event);
end;

function TObjListBox.IsSelected(Item: Integer): Boolean;
begin
  IsSelected := Item = Cur;
end;

procedure TObjListBox.NewObjectory(AObj: PObjectory);
const
  PathObj            = '';
  FirstObj           =   '';
  MiddleObj          =   ' ';
  LastObj            =   ' ';
  IndentSize         = '  ';
var
  AList: PCollection;
  NewObj, Objct: ObjStr;
  C, OldC: Char;
  S, Indent: String[80];
  P: PString;
  isFirst: Boolean;
  SR: SearchRec;
  I: Integer;
  ObjEntry: PObjEntry;

function NewObjEntry(DisplayText:String; AObj: PObject): PObjEntry; near;
var
  ObjEntry: PObjEntry;
begin
  New(ObjEntry);
  ObjEntry^.DisplayText := NewStr(DisplayText);
  ObjEntry^.Obj := AObj;
  NewObjEntry := ObjEntry;
end;

procedure InsertList(entry:PObjEntry);
begin
  if AList^.count<=2 then AList^. Insert(entry)
  else AList^. AtInsert(2,entry);
end;

begin
  Obj := AObj;
  AList := New(PObjCollection, Init(5,5));
  AList^.Insert(NewObjEntry(Szenen^,nil));
  if Obj = nil then {Nil bedeutet hier, dass Szenen angezeigt werden sollen}
  begin
    isFirst := True;
    hobj:=nil;
    getszene(hobj,szene,c);
    OldC := ' ';
    OldSzene:=nil;
    while szene<>nil do begin
      if OldSzene <> nil then begin
        if isFirst then begin
          S := FirstObj + OldC;
          isFirst := False;
        end else S := MiddleObj + OldC;
	AList^.Insert(NewObjEntry(S, OldSzene));
      end;
      if szene = GetCurSzene then Cur := AList^.Count;
      OldC := C;
      OldSzene:=Szene;
      getszene(hobj,szene,s);
    end;
    if OldC <> ' ' then AList^.Insert(NewObjEntry(LastObj + OldC, OldSzene));
  end else begin   {ein normaler Verzeichnisbaum wird angezeigt}
    Indent := IndentSize;
    Objct := Obj;
    path:=GetPfad(obj);{Der Pfad darf kein Backslash am Anfang oder Ende haben. Die Root ist durch einen : gekennzeichnet}
    bs:=countbackslash(path);
    fillchar(ident[1],bs*2,' ');
    ident[0]:=bs*2;
    for n:=1 to bs do begin
      i:=1;
      repeat
        alti:=i;
        i:=pos('\',path);
      until i=0;
      s:=copy(path,succ(alti),255);
      path[0]:=pred(alti);
      InsertList(NewObjEntry(Indent + PathObj + S, Objct));
      dec(ident[0],2);
      GetOwner(Objct);
    end;
    path:=path+'\';
    InsertList(NewObjEntry(PathObj + path, Objct)); {Root (z.B. FIGUR:\)}
    Cur := AList^.Count-1;
    isFirst := True;
    hobj:=nil;
    FindSubGroup(hobj,objct,name);
    while objct<>nil do
    begin
      if isFirst then
      begin
	S := FirstObj;
	isFirst := False;
      end else S := MiddleObj;
      AList^.Insert(NewObjEntry(Indent + S + Name, Objct));
      FindSubGroup(hobj,objct,name);
    end;
    P := PObjEntry(AList^.At(AList^.Count-1))^.DisplayText;
    I := Pos('',P^);
    if I = 0 then
    begin
      I := Pos('',P^);
      if I <> 0 then P^[I] := '';
    end else
    begin                 {es gab kein middleobject}
      P^[I+1] := '';
      P^[I+2] := '';
    end;
  end;
  NewList(AList);
  FocusItem(Cur);
end;

procedure TObjListBox.SetState(AState: Word; Enable: Boolean);
begin
  TListBox.SetState(AState, Enable);
end;

end.
