unit WizView;
interface
uses tgviews,tgdialog;
const TypSingle=   0;
      TypReal=     1;
      TypComp=     2;
      TypDouble=   3;
      TypExtended= 4;
      TypByte=     5;
      TypShortInt= 6;
      TypWord=     7;
      TypInteger=  8;
      TypLongint=  9;

Type ZahlTyp=record case byte of
       TypSingle:   (S:Single);
       TypReal:     (R:Real);
       TypComp:     (C:Comp);
       TypDouble:   (D:Double);
       TypExtended: (E:Extended);
       TypByte:     (B:Byte);
       TypShortInt: (Sh:ShortInt);
       TypWord:     (W:Word);
       TypInteger:  (I:Integer);
       TypLongint:  (L:LongInt);
     end;

     PInputZahl=^TInputZahl;
     TInputZahl=object(TInputLine)
       Zahl:ZahlTyp;
       Typ,b1,b2:byte;
       min,max:extended;    {ausgabeformat:  Zahl:ab1:ab2}
       constructor init(var Bounds:TRect;ATyp,ab1,ab2:byte;amin,amax:extended);
       function DataSize:Word; virtual;
       procedure GetData(var Rec);virtual;
       procedure SetData(var Rec);virtual;
     end;

implementation
const Zahlgrose:array[0..9] of byte=(sizeof(single),sizeof(Real),
                sizeof(Comp),sizeof(Double),sizeof(Extended),sizeof(Byte),
                sizeof(Shortint),sizeof(Word),sizeof(Integer),sizeof(Longint));


constructor TInputZahl.init(var Bounds:TRect;ATyp,ab1,ab2:byte;amin,amax:extended);
var b:byte;
begin
  if ab2=0 then b:=ab1 else b:=succ(ab1+ab2);
  TInputLine.Init(Bounds,b);
  b1:=ab1;b2:=ab2;typ:=atyp;
  min:=amin;max:=amax;
end;

function TInputZahl.DataSize:Word;
begin
  dataSize:=Zahlgrose[typ];
end;

procedure TInputZahl.GetData(var Rec);
var s:string;
    error:integer;
    hilf:ZahlTyp;
begin
  TInputLine.GetData(s);
  case Typ of
    TypSingle:   begin val(s,hilf.s,error);if (hilf.s<min) or (hilf.s>max) then error:=-1; end;
    TypReal:     begin val(s,hilf.r,error);if (hilf.r<min) or (hilf.r>max) then error:=-1; end;
    TypComp:     begin val(s,hilf.c,error);if (hilf.c<min) or (hilf.c>max) then error:=-1; end;
    TypDouble:   begin val(s,hilf.d,error);if (hilf.d<min) or (hilf.d>max) then error:=-1; end;
    TypExtended: begin val(s,hilf.e,error);if (hilf.e<min) or (hilf.e>max) then error:=-1; end;
    TypByte:     begin val(s,hilf.b,error);if (hilf.b<min) or (hilf.b>max) then error:=-1; end;
    TypShortInt: begin val(s,hilf.sh,error);if (hilf.sh<min) or (hilf.sh>max) then error:=-1; end;
    TypWord:     begin val(s,hilf.w,error);if (hilf.w<min) or (hilf.w>max) then error:=-1; end;
    TypInteger:  begin val(s,hilf.i,error);if (hilf.i<min) or (hilf.i>max) then error:=-1; end;
    TypLongint:  begin val(s,hilf.l,error);if (hilf.l<min) or (hilf.l>max) then error:=-1; end;
  end;
  if (error=0) then zahl:=hilf;
  move(zahl,rec,Zahlgrose[typ]);
end;

procedure TInputZahl.SetData(var Rec);
var s:string;
begin
  move(rec,zahl,Zahlgrose[typ]);
  case typ of
    TypSingle:   begin if zahl.s<min then zahl.s:=min else if zahl.s>max then zahl.s:=max;str(zahl.s:b1:b2,s);end;
    TypReal:     begin if zahl.r<min then zahl.r:=min else if zahl.r>max then zahl.r:=max;str(zahl.r:b1:b2,s);end;
    TypComp:     begin if zahl.c<min then zahl.c:=min else if zahl.c>max then zahl.c:=max;str(zahl.c:b1:b2,s);end;
    TypDouble:   begin if zahl.d<min then zahl.d:=min else if zahl.d>max then zahl.d:=max;str(zahl.d:b1:b2,s);end;
    TypExtended: begin if zahl.e<min then zahl.e:=min else if zahl.e>max then zahl.e:=max;str(zahl.e:b1:b2,s);end;
    TypByte:     begin if zahl.b<min then zahl.b:=round(min) else if zahl.b>max then zahl.b:=round(max);str(zahl.b:b1,s);end;
    TypShortInt: begin if zahl.sh<min then zahl.sh:=round(min) else if zahl.sh>max then zahl.sh:=round(max);
                        str(zahl.sh:b1,s);end;
    TypWord:     begin if zahl.w<min then zahl.w:=round(min) else if zahl.w>max then zahl.w:=round(max);str(zahl.w:b1,s);end;
    TypInteger:  begin if zahl.i<min then zahl.i:=round(min) else if zahl.i>max then zahl.i:=round(max);str(zahl.i:b1,s);end;
    TypLongint:  begin if zahl.l<min then zahl.l:=round(min) else if zahl.l>max then zahl.l:=round(max);str(zahl.l:b1,s);end;
  end;
  while s[1]=' ' do delete(s,1,1);
  TInputLine.Setdata(s);
end;

end.