unit TGMineSw;
interface
uses crt,Objects,TGDriver,TGViews,TGDialog,TGMouse;
const maxx=20;
      maxy=20;
      cmNeu=1001;
      scMineSweeperShape=255;
      scLochShape=254;
type PSpiel=^TSpiel;
     TSpiel=array[0..pred(maxx),0..pred(maxy)] of record nummer,marke:byte; end;

     PMine=^TMine;
     TMine=object(TView)
       dx,dy,bomben:byte;
       aktBomben:longint;
       spiel:PSpiel;
       ende:boolean;
       offen:word;
       constructor init(r:TRect;adx,ady,abomben:byte);
       destructor done; virtual;
       procedure handleevent(var event:TEvent); virtual;
       procedure Spielfeldinit;
       procedure store(var s:TStream); virtual;
       constructor load(var s:TStream);
       procedure Draw; virtual;
       function GetPalette: PPalette; virtual;
       {function GetPositionCtx:Word; virtual;}
       procedure UpdateView(x,y:byte);
       procedure getpos(var p:TPoint);
     end;

     PMineSweeper=^TMineSweeper;
     TMineSweeper=object(TDialog)
       Mine:PMine;
       Text:PParamText;
       constructor init(adx,ady,abomben:byte);
       procedure handleevent(var event:TEvent); virtual;
       procedure store(var s:TSTream); virtual;
       constructor load(var s:TStream);
     end;

implementation
const msMine=9;

constructor TMineSweeper.Init(adx,ady,abomben:byte);
var r:TRect;
begin
  r.assign(0,0,30+12*adx+8*6+10,30+12*ady);
  TDialog.init(r,'MineSweeper');
  eventmask:=eventmask or evcommand;
  options:=options or ofCentered;
  r.assign(10,20,10+12*adx,20+12*ady);
  new(Mine,init(r,adx,ady,abomben));
  insert(Mine);
  r.assign(14+12*adx,20,14+12*adx+8*6,40);
  new(Text,init(r,'Minen'#13'%2d',1));
  insert(Text);
  text^.setdata(mine^.aktbomben);
  r.assign(14+12*adx,50,14+12*adx+8*6,65);
  insert(new(PButton,init(r,'~N~eu',cmNeu,bfnormal)));
end;

procedure TMineSweeper.handleevent(var event:TEvent);
begin
  TDialog.handleevent(event);
  if event.what=evCommand then case event.command of
    cmNeu:begin
      Mine^.spielfeldinit;
      drawview;
      clearevent(event);
    end;
  end;
end;

procedure TMineSweeper.store(var s:TSTream);
begin
  TDialog.store(s);
  putsubviewptr(s,mine);
  putsubviewptr(s,text);
end;

constructor TMineSweeper.load(var s:TStream);
begin
  TDialog.load(s);
  getsubviewptr(s,mine);
  getsubviewptr(s,text);
end;

constructor TMine.init(r:TRect;adx,ady,abomben:byte);
begin
  TView.init(r);
  if adx>maxx then dx:=maxx else dx:=adx;
  if ady>maxy then dy:=maxy else dy:=ady;
  bomben:=abomben;
  positionCtx:=scMineSweeperShape;
  new(spiel);
  Spielfeldinit;
end;

destructor TMine.done;
begin
  dispose(spiel);
  TView.done;
end;

procedure TMine.store(var s:TStream);
var n:byte;
begin
  TView.Store(s);
  s.write(dx,sizeof(dx));
  s.write(dy,sizeof(dy));
  s.write(ende,sizeof(ende));
  s.write(bomben,sizeof(bomben));
  s.write(aktbomben,sizeof(aktbomben));
  s.write(offen,sizeof(offen));
  for n:=0 to dy do s.write(spiel^[n],2*maxx);
end;

constructor TMine.load(var s:TStream);
var n:byte;
begin
  TView.Load(s);
  s.read(dx,sizeof(dx));
  s.read(dy,sizeof(dy));
  s.read(ende,sizeof(ende));
  s.read(bomben,sizeof(bomben));
  s.read(aktbomben,sizeof(aktbomben));
  s.read(offen,sizeof(offen));
  new(spiel);
  fillchar(spiel^,sizeof(spiel^),#0);
  for n:=0 to dy do s.read(spiel^[n],2*maxx);
end;

procedure TMine.Spielfeldinit;
var n,x,y,rx,ry:byte;

  function calcmines(x,y:byte):byte;
  var vx,vy:shortint;
      m:byte;
  begin
    m:=0;
    for vx:=-1 to 1 do for vy:=-1 to 1 do
      if ((vx<>0) or (vy<>0)) and
         (x+vx>=0) and (y+vy>=0) and
         (y+vy<dy) and (x+vx<dx) and (spiel^[x+vx,y+vy].nummer=msMine)
      then inc(m);
    calcmines:=m;
  end;

begin
  aktbomben:=bomben;
  offen:=0;
  ende:=false;
  fillchar(spiel^,sizeof(spiel^),#0);
  for n:=1 to bomben do begin
    repeat
      rx:=random(dx);
      ry:=random(dy);
    until spiel^[rx,ry].nummer<>msMine;
    spiel^[rx,ry].nummer:=msMine;
  end;
  for x:=0 to pred(dx) do for y:=0 to pred(dy) do begin
    if spiel^[x,y].nummer<>msMine then spiel^[x,y].nummer:=calcmines(x,y);
  end;
end;

function TMine.GetPalette: PPalette;
const
  CMine = #6#17#18#19#14;
  PMine: String[length(CMine)] = CMine;
begin
  getpalette:= @PMine;
end;

procedure TMine.UpdateView(x,y:byte);
var color:word;
begin
  correctviewport;
  with spiel^[x,y] do begin
    if marke<3 then
    color:=getcolor(5*256+3)
    else color:=getcolor(4*256+3);
    feld(12*x,12*y,12+12*x-1,12+12*y-1,marke<3,color);
    case marke of
      1:schreibenormal(12*x+2,12*y+2,#15,getcolor(1));{bombe vermutet}
      2:schreibenormal(12*x+2,12*y+2,'?',getcolor(1));
      3:if nummer>0 then schreibenormal(12*x+2,12*y+2,char(nummer+byte('0')),getcolor(1));
      4:schreibenormal(12*x+2,12*y+2,#15,getcolor(2));
    end;
  end;
end;

procedure TMine.Draw;
var color:word;
    x,y:byte;
begin
  if getstate(sfvisible) then begin
    hidemouse;
    for x:=0 to pred(dx) do for y:=0 to pred(dy) do updateview(x,y);
    showmouse;
  end;
end;

procedure TMine.getpos(var p:TPoint);
begin
  p.x:=p.x div 12;
  if p.x>dx then p.x:=dx;
  p.y:=p.y div 12;
  if p.y>dy then p.y:=dy;
end;

procedure TMine.handleevent(var event:TEvent);
var p:TPoint;
    x,y:byte;

  procedure incdrawbomben;
  begin
    inc(aktbomben);
    PMineSweeper(owner)^.text^.drawview;
  end;

  procedure open(x,y:byte);
  var vx,vy:shortint;
  begin
    for vy:=-1 to 1 do for vx:=-1 to 1 do if (x+vx>=0) and (y+vy>=0) and
    (y+vy<dy) and (x+vx<dx) then
    with spiel^[x+vx,y+vy] do if marke<>3 then begin
      if marke=1 then incdrawbomben;
      marke:=3;
      inc(offen);
      updateview(x+vx,y+vy);
      if nummer=0 then open(x+vx,y+vy);
    end;
  end;

  procedure testgewonnen;
  var n:word;

    procedure ton(h:word);
    begin
      sound(h);
      delay(1);
    end;

  begin
    if (aktbomben=0) and (offen=dy*dx-bomben) then begin
      for n:=100 to 250 do ton(n*4);
      for n:=250 downto 125 do ton(n*4);
      for n:=62 to 250 do ton(n*8);
      nosound;
    end;
  end;

begin
  TView.Handleevent(event);
  if (event.what and evmousedown>0) and (not ende) then begin
    makelocal(event.where,p);
    getpos(p);
    with spiel^[p.x,p.y] do begin
      if (event.buttons and 1)>0 then begin
        if nummer=msMine then begin
          for x:=0 to pred(dx) do for y:=0 to pred(dy) do with spiel^[x,y] do begin
            if nummer=msmine then begin
              ende:=true;
              marke:=4;
              sound(200);
              updateview(x,y);
              nosound;
            end;
          end;
        end else if marke<3 then begin
          if marke=1 then incdrawbomben;
          marke:=3;
          updateview(p.x,p.y);
          inc(offen);
          if nummer=0 then open(p.x,p.y);
          testgewonnen;
        end;
      end else begin
        if (marke<3) and ((marke<>0) or (aktbomben<>0)) then begin
          inc(marke);
          if marke>2 then marke:=0;
          if marke=1 then dec(aktbomben) else if marke=2 then inc(aktbomben);
          PMineSweeper(owner)^.text^.drawview;
          updateview(p.x,p.y);
          testgewonnen;
        end;
      end;
    end;
    clearevent(event);
  end;
end;

{function TMine.GetPositionCtx:Word;
var p:Tpoint;
begin
  makelocal(mousewhere,p);
  getpos(p);
  if (p.x>=0) and (p.y>=0) and
    (p.y<maxy) and (p.x<maxx) then begin
    if spiel^[p.x,p.y].marke<3 then GetPositionCtx:=scLochShape
    else GetPositionCtx:=scMineSweeperShape;
  end else GetPositionCtx:=hcNoContext;
end;
}
const {MineSweeperShape:TShape = (relx:10;rely:15;
      shape : (screen : ($F8FF,$F07F,$F07F,$F03F,
                         $F8FF,$FBFF,$E1FF,$E9FF,
                         $98FF,$B87F,$F93F,$FDBF,
                         $FDDF,$FBCF,$F8F7,$FFFF);
               mask   : ($0300,$0680,$0680,$0FC0,
                         $0600,$0400,$1A00,$0600,
                         $6700,$4680,$0000,$0240,
                         $0220,$0430,$0708,$0000));
          number:scMineSweeperShape);}
       MineSweeperShape:TShape = (relx:8;rely:8;
       shape : (screen : ($FFFF,$FFFF,$FFFF,$FEFF,
                         $EEEF,$F6DF,$F83F,$F83F,
                         $C007,$F83F,$F83F,$F6DF,
                         $EEEF,$FEFF,$FFFF,$FFFF);
               mask   : ($0000,$0000,$0000,$0100,
                         $1110,$0920,$0440,$0000,
                         $3838,$0000,$0440,$0920,
                         $1110,$0100,$0000,$0000));
          number:scMineSweeperShape);
{      LochShape:TShape = (relx:10;rely:15;
      shape : (screen : ($F0FF,$E063,$E97D,$E071,
                         $E667,$F0EF,$FBEF,$E0FF,
                         $D967,$B9A7,$FBFF,$FBFF,
                         $FBFF,$FBFF,$F8FF,$FFFF);
               mask   : ($0400,$0F00,$1680,$1F80,
                         $1980,$0F00,$0400,$1F00,
                         $2680,$4640,$0400,$0400,
                         $0400,$0400,$0700,$0000));
          number:sclochshape);}
begin
  MouseCursor^.RegisterShape(@MineSweeperShape);
{  MouseCursor^.RegisterShape(@LochShape);}
  randomize;
end.