unit TgStdDlg;
interface

uses Objects, Drivers, TGDriver, TGViews, TGDialog, Dos, TGStdDlg;

  { TObjEntry }

  PObjektory= ^TObjectory;
  TObjectory= record
    View:P3DView;
    Next:TObjectory;
  end;

  PObjEntry = ^TObjEntry;
  TObjEntry = record
    DisplayText: PString;
    Objectory: PObjectory;
  end;

  { TObjCollection is a collection of TObjEntry's used by       }
  { TObjListBox.                                                }

  PObjCollection = ^TObjCollection;
  TObjCollection = object(TCollection)
    function GetItem(var S: TStream): Pointer; virtual;
    procedure FreeItem(Item: Pointer); virtual;
    procedure PutItem(var S: TStream; Item: Pointer); virtual;
  end;

  { TObjListBox displays a tree of Objectories for use in the }
  { TChObjDialog.                                               }

  PObjListBox = ^TObjListBox;
  TObjListBox = object(TListBox)
    Obj: Objectory;
    Cur: Word;
    constructor Init(var Bounds: TRect; AScrollBar: PScrollBar);
    destructor Done; virtual;
    function GetText(Item: Integer; MaxLen: Integer): String; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    function IsSelected(Item: Integer): Boolean; virtual;
    procedure NewObjectory(var AObj: ObjStr);
    procedure SetState(AState: Word; Enable: Boolean); virtual;
  end;

  { TChObjDialog is a standard change Objectory dialog.         }

type

  PChObjDialog = ^TChObjDialog;
  TChObjDialog = object(TDialog)
    ObjList: PObjListBox;
    OkButton: PButton;
    ChObjButton: PButton;
    constructor Init(AOptions: Word; HistoryId: Word);
    constructor Load(var S: TStream);
    function DataSize: Word; virtual;
    procedure GetData(var Rec); virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure SetData(var Rec); virtual;
    procedure Store(var S: TStream);
    function Valid(Command: Word): Boolean; virtual;
{  private}
    procedure SetUpDialog;
  end;

const

  CInfoPane = #44#45#46;

  { TStream registration records }

  RObjCollection: TStreamRec = (
     ObjType: 65;
     VmtLink: Ofs(TypeOf(TObjCollection)^);
     Load:    @TObjCollection.Load;
     Store:   @TObjCollection.Store
  );
  RObjListBox: TStreamRec = (
     ObjType: 66;
     VmtLink: Ofs(TypeOf(TObjListBox)^);
     Load:    @TObjListBox.Load;
     Store:   @TObjListBox.Store
  );
  RChObjDialog: TStreamRec = (
     ObjType: 67;
     VmtLink: Ofs(TypeOf(TChObjDialog)^);
     Load:    @TChObjDialog.Load;
     Store:   @TChObjDialog.Store
  );

procedure RegisterStdDlg;

implementation

uses TGApp, Memory, HistList, TGMsgBox;

{ TObjCollection }

function TObjCollection.GetItem(var S: TStream): Pointer;
var
  ObjItem: PObjEntry;
begin
  New(ObjItem);
  ObjItem^.DisplayText := S.ReadStr;
  ObjItem^.Objectory := S.ReadStr;
  GetItem := ObjItem;
end;

procedure TObjCollection.FreeItem(Item: Pointer);
var
  ObjItem: PObjEntry absolute Item;
begin
  DisposeStr(ObjItem^.DisplayText);
  DisposeStr(ObjItem^.Objectory);
  Dispose(ObjItem);
end;

procedure TObjCollection.PutItem(var S: TStream; Item: Pointer);
var
  ObjItem: PObjEntry absolute Item;
begin
  S.WriteStr(ObjItem^.DisplayText);
  S.WriteStr(ObjItem^.Objectory);
end;

{ TObjListBox }

const
  DrivesS: String[6] = 'Szenen';
  Drives: PString = @DrivesS;

constructor TObjListBox.Init(var Bounds: TRect; AScrollBar:
  PScrollBar);
begin
  TListBox.Init(Bounds, 1, AScrollBar);
  Obj := '';
end;

destructor TObjListBox.Done;
begin
  if List <> nil then Dispose(List, Done);
  TListBox.Done;
end;

function TObjListBox.GetText(Item: Integer; MaxLen: Integer): String;
begin
  GetText := PObjEntry(List^.At(Item))^.DisplayText^;
end;

procedure TObjListBox.HandleEvent(var Event: TEvent);
begin
  if (Event.What = evMouseDown) and (Event.Double) then
  begin
    Event.What := evCommand;
    Event.Command := cmChangeObj;
    PutEvent(Event);
    ClearEvent(Event);
  end
  else TListBox.HandleEvent(Event);
end;

function TObjListBox.IsSelected(Item: Integer): Boolean;
begin
  IsSelected := Item = Cur;
end;

procedure TObjListBox.NewObjectory(AObj: PObjectory);
const
  PathObj            = '';
  FirstObj           =   '';
  MiddleObj          =   ' ';
  LastObj            =   ' ';
  IndentSize         = '  ';
var
  AList: PCollection;
  NewObj, Objct: ObjStr;
  C, OldC: Char;
  S, Indent: String[80];
  P: PString;
  isFirst: Boolean;
  SR: SearchRec;
  I: Integer;
  ObjEntry: PObjEntry;

function NewObjEntry(DisplayText, Objectory: String): PObjEntry; near;
var
  ObjEntry: PObjEntry;
begin
  New(ObjEntry);
  ObjEntry^.DisplayText := NewStr(DisplayText);
  ObjEntry^.Objectory := NewStr(Objectory);
  NewObjEntry := ObjEntry;
end;

function CopyObjectory(n:byte;obj:PObjectory):PObjectory;
var Root,Hobj,aktobj,neuobj:PObjectory;
begin
  m:=1;
  Aktobj:=obj;
  Neuobj:=nil;
  while (m<=n) and (aktobj<>nil) do begin
    New(HObj);
    HObj^.View:=aktobj^.view;
    if neuobj<>nil then neuobj^.next:=hobj else root:=hobj;
    neuobj:=hobj;
    neuobj^.next:=nil;
    aktobj:=aktobj^.next;
    inc(m);
  end;
  CopyObjectory:=Root;
end;

fuction DriveValid(c:char):boolean;
begin
  drivevalid:=true;
end;

begin
  Obj := AObj;
  AList := New(PObjCollection, Init(5,5));
{  AList^.Insert(NewObjEntry(Drives^,Drives^));
  if Obj = Drives^ then
  begin
    isFirst := True;
    OldC := ' ';
    for C := 'A' to 'Z' do
    begin
      if (C < 'C') or DriveValid(C) then
      begin
        if OldC <> ' ' then
	begin
          if isFirst then
	  begin
	    S := FirstObj + OldC;
            isFirst := False;
          end
          else S := MiddleObj + OldC;
	  AList^.Insert(NewObjEntry(S, OldC + ':\'));
        end;
        if C = GetCurDrive then Cur := AList^.Count;
        OldC := C;
      end;
    end;
    if OldC <> ' ' then AList^.Insert(NewObjEntry(LastObj + OldC, OldC + ':\'));
  end
  else  }
  begin
    Indent := IndentSize;
    NewObj := Obj^.Objectory^.View^.Name;
    Objct := NewObj;
    HObject:=copyObjectory(1,Obj);
    AList^.Insert(NewObjEntry(PathObj + Objct, HObject));{Root (z.B. C:\)}
    NewObj := Copy(NewObj,4,255);
    while NewObj <> '' do
    begin
      I := Pos('\',NewObj);
      if I <> 0 then
      begin
        S := Copy(NewObj,1,I-1);
        Objct := Objct + S;
        AList^.Insert(NewObjEntry(Indent + PathObj + S, Objct));
        NewObj := Copy(NewObj,I+1,255);
      end
      else
      begin
        Objct := Objct + NewObj;
        AList^.Insert(NewObjEntry(Indent + PathObj + NewObj, Objct));
        NewObj := '';
      end;
      Indent := Indent + IndentSize;
      Objct := Objct + '\';
    end;
    Cur := AList^.Count-1;
    isFirst := True;
    NewObj := Objct + '*.*';
    FindFirst(NewObj, Objectory, SR);
    while DosError = 0 do
    begin
      if (SR.Attr and Objectory <> 0) and (SR.Name[1] <> '.') then
      begin
        if isFirst then
	begin
	  S := FirstObj;
	  isFirst := False;
	end else S := MiddleObj;
        AList^.Insert(NewObjEntry(Indent + S + SR.Name, Objct + SR.Name));
      end;
      FindNext(SR);
    end;
    P := PObjEntry(AList^.At(AList^.Count-1))^.DisplayText;
    I := Pos('',P^);
    if I = 0 then
    begin
      I := Pos('',P^);
      if I <> 0 then P^[I] := '';
    end else
    begin
      P^[I+1] := '';
      P^[I+2] := '';
    end;
  end;
  NewList(AList);
  FocusItem(Cur);
end;

procedure TObjListBox.SetState(AState: Word; Enable: Boolean);
begin
  TListBox.SetState(AState, Enable);
  if AState and sfFocused <> 0 then
    PChObjDialog(Owner)^.ChObjButton^.MakeDefault(Enable);
end;

{ TChObjDialog }

constructor TChObjDialog.Init(AOptions: Word; HistoryId: Word);
var
  R: TRect;
  Control: PView;
  CurObj: ObjStr;
begin
  R.assignText(16, 2, 64, 20);
  TDialog.Init(R, 'Objektliste');

  R.assign(32*8+1, 6*10, 33*8+3, 16*10);
  Control := New(PScrollBar, Init(R));
  Insert(Control);
  R.assignText(3, 6, 32, 16);
  ObjList := New(PObjListBox, Init(R, PScrollBar(Control)));
  Insert(ObjList);
  R.assignText(2, 5, 18, 6);
  Control := New(PLabel, Init(R, 'Objekt ~B~aum', ObjList));
  Insert(Control);

  R.assignText(35, 6, 45, 8);
  OkButton := New(PButton, Init(R, 'O~K~', cmOK, bfDefault));
  Insert(OkButton);
  Inc(R.A.Y,3*10); Inc(R.B.Y,3*10);
  ChObjButton := New(PButton, Init(R, '~O~bjekt', cmChangeObj, bfNormal));
  Insert(ChObjButton);
  Inc(R.A.Y,3*10); Inc(R.B.Y,3*10);
  Insert(New(PButton, Init(R, '~U~rsprung', cmRevert, bfNormal)));
  if AOptions and cdHelpButton <> 0 then
  begin
    Inc(R.A.Y,3*10); Inc(R.B.Y,3*10);
    Insert(New(PButton, Init(R, 'Help', cmHelp, bfNormal)));
  end;

  if AOptions and cdNoLoadObj = 0 then SetUpDialog;

  SelectNext(False);
end;

constructor TChObjDialog.Load(var S: TStream);
var
  CurObj: ObjStr;
begin
  TDialog.Load(S);
  GetSubViewPtr(S, ObjList);
  GetSubViewPtr(S, ObjInput);
  GetSubViewPtr(S, OkButton);
  GetSubViewPtr(S, ChObjbutton);
  SetUpDialog;
end;

function TChObjDialog.DataSize: Word;
begin
  DataSize := 0;
end;

procedure TChObjDialog.GetData(var Rec);
begin
end;

procedure TChObjDialog.HandleEvent(var Event: TEvent);
var
  CurObj: ObjStr;
  P: PObjEntry;
begin
  TDialog.HandleEvent(Event);
  case Event.What of
    evCommand:
      begin
        case Event.Command of
          cmRevert: GetObj(0,CurObj);
          cmChangeObj:
            begin
              P := ObjList^.List^.At(ObjList^.Focused);
              if (P^.Objectory^ = Drives^) or DriveValid(P^.Objectory^[1]) then
                CurObj := P^.Objectory^
              else Exit;
            end;
        else
          Exit;
        end;
        if (Length(CurObj) > 3) and (CurObj[Length(CurObj)] = '\') then
          CurObj := Copy(CurObj,1,Length(CurObj)-1);
        ObjList^.NewObjectory(CurObj);
        ObjInput^.Data^ := CurObj;
        ObjInput^.DrawView;
        ObjList^.Select;
        ClearEvent(Event);
      end;
  end;
end;

procedure TChObjDialog.SetData(var Rec);
begin
end;

procedure TChObjDialog.SetUpDialog;
var
  CurObj: ObjStr;
begin
  if ObjList <> nil then
  begin
    CurObj := GetCurObj;
    ObjList^.NewObjectory(CurObj);
    if (Length(CurObj) > 3) and (CurObj[Length(CurObj)] = '\') then
      CurObj := Copy(CurObj,1,Length(CurObj)-1);
    if ObjInput <> nil then
    begin
      ObjInput^.Data^ := CurObj;
      ObjInput^.DrawView;
    end;
  end;
end;

procedure TChObjDialog.Store(var S: TStream);
begin
  TDialog.Store(S);
  PutSubViewPtr(S, ObjList);
  PutSubViewPtr(S, ObjInput);
  PutSubViewPtr(S, OkButton);
  PutSubViewPtr(S, ChObjButton);
end;

function TChObjDialog.Valid(Command: Word): Boolean;
var
  P: PathStr;
begin
  Valid := True;
  if Command = cmOk then
  begin
    P := FExpand(ObjInput^.Data^);
    if (Length(P) > 3) and (P[Length(P)] = '\') then Dec(P[0]);
    {$I-}
    ChObj(P);
    if IOResult <> 0 then
    begin
      MessageBox('Invalid Objectory.', nil, mfError + mfOkButton);
      Valid := False;
    end;
    {$I+}
  end;
end;

procedure RegisterStdDlg;
begin
  RegisterType(RObjCollection);
  RegisterType(RObjListBox);
  RegisterType(RChObjDialog);
end;

end.
