unit UBlockDlg;
interface
uses Objects,TGDriver,TGViews,TGDialog,TGStdDlg,TGApp,UObjList,U3DViews,
     Uszene,UUtils;

type PGroupListBox = ^TGroupListBox;
  TGroupListBox = object(TObjListBox)
    procedure GetSzene(var hobj,szene:PObject;var s:ObjStr); virtual;
    function getcurszene:pobject; virtual;
    function GetPfad(Aobj:PObject):ObjStr; virtual;
    procedure GetOwner(var Aobj:Pobject); virtual;
    procedure FindSubGroup(var hObj,Aobj:PObject;var s:objstr); virtual;
    procedure FocusItem(Item: Integer); virtual;
    function GetAktName:GroupStr;
    function GetSelectedGroup:P3DGroup;
    procedure SetName(aname:PString);
    procedure HandleEvent(var Event: TEvent); virtual;
    function GetAktSzene:Pszene;
  end;

  P3DViewRec = ^T3DViewRec;
  T3DViewRec = record
    View: P3DView;
    Name: PString;
  end;

  P3DInputLine = ^T3DInputLine;
  T3DInputLine = object(TInputLine)
    Lister:PListViewer;
    constructor Init(var Bounds: TRect; AMaxLen: Integer;AText:String;MyLister:PListViewer);
    procedure setState(Astate:word;Enable:Boolean); virtual;
  end;

  P3DViewInputLine = ^T3DViewInputLine;
  T3DViewInputLine = object(T3DInputLine)
    procedure HandleEvent(var Event: TEvent); virtual;
  end;

  P3DGroupInputLine = ^T3DGroupInputLine;
  T3DGroupInputLine = object(T3DInputLine)
    procedure HandleEvent(var Event: TEvent); virtual;
  end;

  P3DViewCollection = ^T3DViewCollection;
  T3DViewCollection = object(TSortedCollection)
    function Compare(Key1, Key2: Pointer): Integer; virtual;
    procedure FreeItem(Item: Pointer); virtual;
  end;

  P3DViewList = ^T3DViewList;
  T3DViewList = object(TSortedListBox)
    cur:integer;
    AktGroup:P3DGroup;
    constructor Init(var Bounds: TRect; Group:P3DGroup;
      AScrollBar: PScrollBar);
    destructor Done; virtual;
    function DataSize: Word; virtual;
    procedure FocusItem(Item: Integer); virtual;
    procedure GetData(var Rec); virtual;
    function GetText(Item: Integer; MaxLen: Integer): String; virtual;
    function GetKey(var S: String): Pointer; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure ReadViews(Group:P3DGroup);
    procedure SetData(var Rec); virtual;
    procedure FindSubView(var hObj,Aobj:PObject;var s:objstr);
    procedure SetName(aname:PString);
    function GetCurView:P3DView;
  end;

  PSelectView = ^TSelectView;
  TSelectView = object(TGroup)
    GroupList:PGroupListBox;
    ViewList:P3DViewList;
    constructor init(bounds:TRect;Szene:PSzene);
    procedure HandleEvent(var Event:TEvent); virtual;
    function DataSize: Word; virtual;
    procedure GetData(var Rec); virtual;
    procedure SetData(var Rec); virtual;
    {procedure SetUpDialog;}
    procedure NeueGruppe;
    procedure LoescheGruppe;
    procedure LoescheObjekt;
    function GetAktGroup:P3DGroup;
    function GetAktView:P3DView;
    function GetAktSzene:PSzene;
  end;

  PBlockDialog = ^TBlockDialog;
  TBlockDialog = object(TDialog)
    momszene:PSzene;
    SelectViewA,SelectViewB: PSelectView;
    RenObjButton: PButton;
    constructor Init(aktszene:PSzene);
    function Valid(Command: Word): Boolean; virtual;
    function DataSize: Word; virtual;
    procedure GetData(var Rec); virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure SetData(var Rec); virtual;
  end;

implementation

{ T3DInputLine }

constructor T3DInputLine.Init(var Bounds: TRect; AMaxLen: Integer;AText:String;MyLister:PListViewer);
begin
  TInputLine.Init(Bounds, AMaxLen);
  Data^:=AText;
  EventMask := EventMask or evBroadcast or evcommand;
  Options:=Options or OfPostProcess;
  Lister:=MyLister;
end;

procedure T3DInputLine.SetState(AState:Word;Enable:Boolean);
begin
  TInputLine.setstate(astate,enable);
  If ((AState and sfFocused)<>0) and enable then begin
    Message(Owner^.owner, evBroadcast, cm3DLineActive, @Self);
  end;
end;

{ T3DViewInputLine }

procedure T3DViewInputLine.HandleEvent(var Event: TEvent);
begin
  TInputLine.HandleEvent(Event);
  if (Event.What = evBroadcast)  {and (State and sfSelected = 0)} and
     (Event.Command=cm3DViewFocused) then begin
    if (Event.InfoPtr<>nil)
    then Data^:=P3DViewRec(Event.InfoPtr)^.Name^
    else Data^:='';
    DrawView;
  end else if (event.what=evcommand) and (event.command=cmRenObj)
  then begin
    clearevent(event);
    P3DViewList(Lister)^.SetName(Data);
  end;
end;

{ T3DGroupInputLine }

procedure T3DGroupInputLine.HandleEvent(var Event: TEvent);
begin
  TInputLine.HandleEvent(Event);
  if (Event.What = evBroadcast)  {and (State and sfSelected = 0)} and
     (Event.Command=cmChangeObj) then begin
    Data^:=PGroupListBox(Event.InfoPtr)^.GetAktName;
    DrawView;
  end  else if (event.what=evcommand) and (event.command=cmRenObj)
  then begin
    clearevent(event);
    PGroupListBox(Lister)^.SetName(Data);
  end;
end;

{ T3DViewCollection }

function T3DViewCollection. Compare(Key1, Key2: Pointer): Integer;
begin
  if UpWordf(P3DViewRec(Key1)^.Name^) > UpWordf(P3DViewRec(Key2)^.Name^) then
    Compare := 1
  else Compare := -1;
end;

procedure T3DViewCollection.FreeItem(Item: Pointer);
begin
  disposestr(P3DViewRec(Item)^.name);
  Dispose(P3DViewRec(Item));
end;

{ T3DViewList }

constructor T3DViewList.Init(var Bounds: TRect; Group: P3DGroup;
  AScrollBar: PScrollBar);
begin
  TSortedListBox.Init(Bounds, 1, AScrollBar);
  ReadViews(Group);
end;

destructor T3DViewList.Done;
begin
  if List <> nil then Dispose(List, Done);
  TListBox.Done;
end;

function T3DViewList.DataSize: Word;
begin
  DataSize := 0;
end;

procedure T3DViewList.FocusItem(Item: Integer);
begin
  TSortedListBox.FocusItem(Item);
  if (item<list^.count) and (Item>=0)
  then Message(Owner, evBroadcast, cm3DViewFocused, list^.at(item))
  else Message(Owner, evBroadcast, cm3DViewFocused, nil);
  cur:=item;
end;

procedure T3DViewList.GetData(var Rec);
begin
end;

function T3DViewList.GetKey(var S: String): Pointer;
const
  SR: T3DViewRec = ();

procedure UpStr(var S: String);
var
  I: Integer;
begin
  for I := 1 to Length(S) do S[I] := UpCase(S[I]);
end;

begin
  SR.Name := NewStr(S);
  UpStr(SR.Name^);
  sr.view:=nil;
  GetKey := @SR;
end;

function T3DViewList.GetText(Item: Integer; MaxLen: Integer): String;
begin
  if (list=nil) or (item>=List^.count) or (item<0) then Gettext:='' else GetText := P3DViewRec(List^.At(Item))^.Name^;
end;

procedure T3DViewList.HandleEvent(var Event: TEvent);
begin
  {if (Event.What = evMouseDown) and (Event.Double) then
  begin
    Event.What := evCommand;
    Event.Command := cmOK;
    PutEvent(Event);
    ClearEvent(Event);
  end
  else} TSortedListBox.HandleEvent(Event);
  if (Event.What = evBroadcast) then begin
    case event.Command of
      cmChangeObj:if (State and sfSelected = 0) then ReadViews(PGroupListBox(Event.InfoPtr)^.GetSelectedGroup);
      cmVerzeichnisneuanzeigen: if aktgroup=event.infoptr then begin
        ReadViews(aktgroup);
        DrawView;
      end;
    end;
  end;
end;

procedure T3DViewList.ReadViews(Group:P3DGroup);
var
  ViewList: P3DViewCollection;
  Event: TEvent;
  hobj,obj:PObject;
  s:objstr;
  ObjEntry: P3DViewRec;
begin
  if group<>nil then begin
    ViewList := New(P3DViewCollection, Init(5, 5));
    cur:=0;
    hobj:=nil;
    obj:=Group;
    FindSubView(hObj,obj,s);
    while obj<>nil do begin
      New(ObjEntry);
      ObjEntry^.name := newstr(s);
      ObjEntry^.View := P3DView(Obj);
      if P3DView(Obj)^.Szene^.aktObjekt=PView(Obj)
      then cur:=ViewList^.count;
      ViewList^.Insert(ObjEntry);
      FindSubView(hObj,obj,s);
    end;
    NewList(ViewList);
    if owner<>nil then begin
      Event.What := evBroadcast;
      Event.Command := cm3DViewFocused;
      if List^.Count > 0 then Event.InfoPtr := List^.At(cur)
      else Event.InfoPtr:=nil;
      Owner^.HandleEvent(Event);
    end;
    aktGroup:=Group;
  end;
end;

procedure T3DViewList.SetData(var Rec);
begin
{  with P3DViewDialog(Owner)^ do
    Self.ReadDirectory(Directory^ + WildCard);}
end;

procedure T3DViewList.SetName(aname:PString);
begin
  if (list<>nil) and (cur<List^.count) then begin
    with P3DViewRec(list^.at(cur))^ do if (name^<>aname^) then begin
      if View<>nil then View^.setname(aname^);
      Message(Owner^.owner, evBroadcast, cmVerzeichnisneuanzeigen, aktgroup);
    end;
  end;
end;

function T3DViewList.GetCurView:P3DView;
begin
  if cur<List^.count then GetCurView:=P3DViewRec(List^.at(cur))^.View
  else GetCurView:=nil;
end;

{ TSuch3DView }

type PSuch3DView=^TSuch3DView;
       TSuch3DView=object(TObject)
         zuletztgefunden:P3DView;
         stammgruppe:P3DGroup;
         constructor init(stamm:P3DGroup);
         function find:P3DView;
       end;

  constructor TSuch3DView.init(stamm:P3DGroup);
  begin
    TObject.init;
    zuletztgefunden:=nil;
    stammgruppe:=stamm;
  end;

  function TSuch3DView.find:P3DView;
  var letztegefunden:boolean;

    function suche3DView(item: PView):boolean;far;
    begin
      suche3DView:=false;
      if (TypeOf(Item^)<>TypeOf(T3DGroup)) and (TypeOf(Item^)<>TypeOf(TRoot)) then begin
        if LetzteGefunden then suche3DView:=true else begin
          if P3DView(item)=ZuletztGefunden then LetzteGefunden:=true;
        end;
      end;
    end;

  begin
    if ZuletztGefunden=nil then letztegefunden:=true else letztegefunden:=false;
    zuletztgefunden:=P3DView(stammgruppe^.subviews^.firstthat(@suche3DView));
    find:=zuletztgefunden;
  end;

procedure T3DViewList.FindSubView(var hObj,Aobj:PObject;var s:objstr);
begin
  if hobj=nil then hobj:=new(PSuch3DView,init(P3DGroup(aobj)));
  aobj:=PSuch3DView(hobj)^.find;
  if aobj=nil then begin
    if hobj<>nil then dispose(hobj,done);
    hobj:=nil;
    s:='';
  end else s:=P3DView(aobj)^.Getname;
end;

{ TSelectView }

constructor TSelectView.init(bounds:TRect;Szene:PSzene);
var b,r:Trect;
    c:integer;
    hview:PView;
    GroupLine:P3DGroupInputLine;
    ViewLine:P3DViewInputLine;
{    ViewInfo:PViewInfo;}
const unten=0;
      inputlinebreite=14;
begin
  TGroup.init(bounds);
  options:=options or ofPostProcess;

  b.a.x:=0;
  b.a.y:=0;
  b.b.x:=bounds.b.x-bounds.a.x;
  b.b.y:=bounds.b.y-bounds.a.y;
  with b do begin
    c:=b.x div 2;

    r.assign(c-9,10+inputlinebreite,pred(c),pred(b.y-unten));
    hview:=new(PScrollbar,init(r));
    Insert(hView);
    r.assign(0,a.y+10+inputlinebreite,c-10,pred(b.y-unten));
    GroupList:=new(PGroupListBox,init(r,PScrollbar(hview)));
    Insert(GroupList);
    GroupList^.NewObjectory(Szene^.GetAktGruppe);

    r.assign(0,9,pred(c),9+inputlinebreite);
    if Szene^.getaktgruppe<>nil
    then GroupLine:=new(P3DGroupInputLine,init(r,15,Szene^.getaktgruppe^.getname,grouplist))
    else GroupLine:=new(P3DGroupInputLine,init(r,15,'',grouplist));
    insert(GroupLine);
    r.assign(0,0,c,8);
    Insert(new(PLabel,init(r,'~G~ruppen:',GroupLine)));

    r.assign(b.x-8,10+inputlinebreite,b.x,pred(b.y-unten));
    hview:=new(PScrollbar,init(r));
    Insert(hView);
    r.assign(succ(c),a.y+10+inputlinebreite,b.x-9,pred(b.y-unten));
    ViewList:=new(P3DViewList,init(r,P3DGroup(Szene^.GetAktGruppe),PScrollBar(hview)));
    Insert(ViewList);

    r.assign(succ(c),9,b.x,9+inputlinebreite);
    if Szene^.GetCurrentObjekt<>nil
    then ViewLine:=new(P3DViewInputLine,init(r,15,Szene^.GetcurrentObjekt^.getname,viewlist))
    else ViewLine:=new(P3DViewInputLine,init(r,15,'',viewlist));
    Insert(ViewLine);
    r.assign(succ(c),0,b.x,8);
    Insert(new(PLabel,init(r,'~O~bjekte:',ViewLine)));

    {r.assign(0,r.y-unten,b.x,b.y);
     Info:=new(PViewInfo,init(r,nil));
     Insert(Info);}

     {SetUpDialog;}

  end;
end;

function TSelectView.DataSize: Word;
begin
  DataSize := 0;
end;

procedure TSelectView.GetData(var Rec);
begin
end;

procedure TSelectView.HandleEvent(var Event: TEvent);
var
  CurObj: PObject;
  P: PObjEntry;
  s:ObjStr;
  h:PSzene;
begin
  TGroup.HandleEvent(Event);
  case Event.What of
    evCommand:
      begin
        case Event.Command of
          cmChangeObj:
            begin
              P := GroupList^.List^.At(GroupList^.Focused);
              {if (P^.Obj = Nil) or DriveValid(P^.Objectory^[1]) then}
                CurObj := P^.Obj
              {else Exit;}
            end;
        else
          Exit;
        end;
        {if (Length(CurObj) > 3) and (CurObj[Length(CurObj)] = '\') then
          CurObj := Copy(CurObj,1,Length(CurObj)-1);}
        GroupList^.NewObjectory(CurObj);
        {if curobj<>nil then begin
          P3DGroup(CurObj)^.getpfad(s);
          ObjInput^.Data^ := s;
          ObjInput^.DrawView;
        end;
        GroupList^.Select;}
        ClearEvent(Event);
      end;
  end;
end;

procedure TSelectView.SetData(var Rec);
begin
end;

{procedure TSelectView.SetUpDialog;
var
  CurObj: PObject;
  h:PSzene;
begin
  if GroupList <> nil then
  begin
    h:=PSzene(GroupList^.GetCurSzene);
    if h<>nil then curObj:=h^.Getaktgruppe;
    GroupList^.NewObjectory(CurObj);

  end;
end;}

procedure TSelectView.NeueGruppe;
begin
  if GroupList^.Obj<>nil then begin
    P3DGroup(GroupList^.Obj)^.NeueGruppe;
    Message(owner,evBroadCast,cmGruppenBaumneuanzeigen,nil);
  end;
end;

procedure TSelectView.LoescheGruppe;
var own:PView;
begin
  if (GroupList^.Obj<>nil) and (TypeOf(GroupList^.Obj^)<>Typeof(TRoot)) then begin
    own:=P3DGroup(GroupList^.Obj)^.next;
    while (own<>PView(GroupList^.Obj)) and (typeof(own^)<>Typeof(T3DGroup))
          and (typeof(own^)<>Typeof(TRoot)) and (own<>nil) do own:=own^.next;
    if (own=PView(GroupList^.Obj)) or (own=nil)
       or ((typeof(own^)<>Typeof(T3DGroup)) and (typeof(own^)<>Typeof(TRoot)))
    then own:=P3DGroup(GroupList^.Obj)^.owner;
{    if P3DGroup(GroupList^.Obj)^.owner^.subviews^.count=1
    then} P3DGroup(GroupList^.Obj)^.owner^.current:=nil;
    P3DGroup(GroupList^.Obj)^.state:=P3DGroup(GroupList^.Obj)^.state and not sfvisible;
    {P3DGroup(GroupList^.Obj)^.owner^.delete(P3DGroup(GroupList^.Obj));}
    Dispose(P3DGroup(GroupList^.Obj),done);
    Message(owner,evBroadCast,cmGruppenBaumneuanzeigen,own);
  end;
end;

procedure TSelectView.LoescheObjekt;
var hView:PView;
begin
  hview:=ViewList^.GetCurView;
  if (hView<>nil) and (TypeOf(HView^)<>TypeOf(TRoot)) then begin
    HView^.state:=HView^.state and not sfvisible;
    HView^.owner^.current:=nil;
    dispose(HView,done);
    Message(owner,evBroadCast,cmVerzeichnisneuanzeigen,ViewList^.aktGroup);
  end;
end;

function TSelectView.GetAktGroup:P3DGroup;
begin
  GetAktGroup:=GroupList^.GetSelectedGroup;
end;

function TSelectView.GetAktView:P3DView;
begin
  GetAktView:=ViewList^.GetCurView;
end;

function TSelectView.GetAktSzene:PSzene;
begin
  GetAktSzene:=GroupList^.GetAktSzene;
end;

{ TGroupListBox }

{ TSuchSzene }

  type PSuchSzene=^TSuchSzene;
       TSuchSzene=object(TObject)
         zuletztgefunden:PSzene;
         constructor init;
         function find:PSzene;
       end;

  constructor TSuchSzene.init;
  begin
    TObject.init;
    zuletztgefunden:=nil;
  end;

  function TSuchSzene.find:PSzene;
  var letztegefunden:boolean;

    function sucheszene(item: PView):boolean;far;
    begin
      sucheszene:=false;
      if TypeOf(Item^)=TypeOfTSzene then begin
        if LetzteGefunden then sucheszene:=true else begin
          if PSzene(item)=ZuletztGefunden then LetzteGefunden:=true;
        end;
      end;
    end;

  begin
    if ZuletztGefunden=nil then letztegefunden:=true else letztegefunden:=false;
    zuletztgefunden:=PSzene(desktop^.subviews^.firstthat(@sucheszene));
    find:=zuletztgefunden;
  end;

procedure TGroupListBox.GetSzene(var hobj,szene:PObject;var s:ObjStr);
begin
  if hobj=nil then hobj:=new(PSuchSzene,init);
  szene:=PSuchSzene(hobj)^.find;
  if szene=nil then begin
    if hobj<>nil then dispose(hobj,done);
    hobj:=nil;
    s:='';
  end else begin
    szene:=PSzene(szene)^.root;
    s:=PRoot(szene)^.name;
  end;
end;


function TGroupListBox.GetCurSzene:PObject;
begin
  GetCurSzene:=GetAktSzene;
end;

function TGroupListBox.GetPfad(Aobj:PObject):ObjStr;
var s:objstr;
begin
  P3DGroup(AObj)^.GetPfad(s);
  s[0]:=pred(s[0]);
  getpfad:=s;
end;

procedure TGroupListBox.GetOwner(var Aobj:Pobject);
begin
  aobj:=P3DGroup(AObj)^.owner;
end;

{ TSuch3DGroup }

type PSuch3DGroup=^TSuch3DGroup;
       TSuch3DGroup=object(TObject)
         zuletztgefunden,stammgruppe:P3DGroup;
         constructor init(stamm:P3DGroup);
         function find:P3DGroup;
       end;

  constructor TSuch3DGroup.init(stamm:P3DGroup);
  begin
    TObject.init;
    zuletztgefunden:=nil;
    stammgruppe:=stamm;
  end;

  function TSuch3DGroup.find:P3DGroup;
  var letztegefunden:boolean;

    function suche3DGroup(item: PView):boolean;far;
    begin
      suche3DGroup:=false;
      if (TypeOf(Item^)=TypeOf(T3DGroup)) or (TypeOf(Item^)=TypeOf(TRoot)) then begin
        if LetzteGefunden then suche3DGroup:=true else begin
          if P3DGroup(item)=ZuletztGefunden then LetzteGefunden:=true;
        end;
      end;
    end;

  begin
    if ZuletztGefunden=nil then letztegefunden:=true else letztegefunden:=false;
    zuletztgefunden:=P3DGroup(stammgruppe^.subviews^.firstthat(@suche3DGroup));
    find:=zuletztgefunden;
  end;

procedure TGroupListBox.FindSubGroup(var hObj,Aobj:PObject;var s:objstr);
begin
  if hobj=nil then hobj:=new(PSuch3DGroup,init(P3DGroup(aobj)));
  aobj:=PSuch3DGroup(hobj)^.find;
  if aobj=nil then begin
    if hobj<>nil then dispose(hobj,done);
    hobj:=nil;
    s:='';
  end else s:=P3DGroup(aobj)^.name;
end;

procedure TGroupListBox.FocusItem(Item: Integer);
begin
  TObjListBox.FocusItem(Item);
  Message(Owner, evBroadcast, cmChangeObj, @Self);
end;

function TGroupListBox.GetAktName:GroupStr;
begin
  if cur<List^.count
  then GetAktName:=P3DGroup(PObjEntry(List^.At(Cur))^.Obj)^.GetName
  else GetAktName:='';
end;

function TGroupListBox.GetSelectedGroup:P3DGroup;
begin
  if Cur<List^.count
  then GetSelectedGroup:=P3DGroup(PObjEntry(List^.At(Cur))^.Obj)
  else GetSelectedGroup:=nil;
end;

procedure TGroupListBox.SetName(aname:PString);
var s:groupstr;
    n:byte;
begin
  if (list<>nil) and (cur<List^.count) and (cur>0) then begin {Cur=0 wre 'Szenen', deshalb berlesen}
    with PObjEntry(list^.at(cur))^ do begin
      s:=displaytext^;
      n:=1;
      while (n<length(s)) and ((s[n]=' ') or (s[n]>='')) do inc(n);
      if copy(s,n,255)<>aname^ then begin
        if obj<>nil then P3DGroup(Obj)^.setname(aname^);
        Message(Owner^.owner, evBroadcast, cmGruppenBaumneuanzeigen, nil);
      end;
    end;
  end;
end;

procedure TGroupListBox.HandleEvent(var Event: TEvent);
begin
  TObjListBox.HandleEvent(Event);
  if (event.what=evBroadcast) and (event.command=cmGruppenBaumneuanzeigen)
  then begin
    if event.infoptr=nil then NewObjectory(obj) else NewObjectory(event.infoptr);
    DrawView;
  end;
end;

function TGroupListBox.GetAktSzene:Pszene;
begin
  GetAktSzene:=nil;
  if obj=nil then begin
    if List^.count>cur
    then GetAktSzene:=PSzene(PObjEntry(List^.At(cur))^.Obj);
  end else begin
    if List^.count>1
    then GetAktSzene:=PSzene(PRoot(PObjEntry(List^.At(1))^.Obj)^.owner);
  end;
end;

{ TBlockDialog }

constructor TBlockDialog.Init(aktszene:PSzene);
var
  R: TRect;
  Control: PView;
  CurObj: ObjStr;
begin
  R.AssignText(2, 2, 78, 33);
  TDialog.Init(R, 'Gruppenbefehle');
  momszene:=nil;

  Options := Options or ofCentered;
  R.AssignText(2, 3, 37, 21);
  SelectViewA := New(PSelectView, Init(R,aktszene) );
  Insert(SelectViewA);

  R.AssignText(2, 2, 18, 3);
  Control := New(PLabel, Init(R, 'Objekt Baum ~A~', SelectViewA));
  Insert(Control);

  R.AssignText(39, 3, 74, 21);
  SelectViewB := New(PSelectView, Init(R,aktszene) );
  Insert(SelectViewB);

  R.AssignText(39, 2, 61, 3);
  Control := New(PLabel, Init(R, 'Objekt Baum ~B~', SelectViewB));
  Insert(Control);

  R.AssignText(2,22,13,24);
  Insert(New(PButton, Init(R, 'O~K~', cmOK, bfDefault)));

  Inc(R.A.X,12*8); Inc(R.B.X,12*8);
  Insert(New(PButton, Init(R, 'Kopie Ob', cmKopieObjekt, bfNormal)));

  Inc(R.A.X,12*8); Inc(R.B.X,12*8);
  Insert(New(PButton, Init(R, 'Ver Ob', cmMoveObjekt, bfNormal)));

  Inc(R.A.X,12*8); Inc(R.B.X,12*8);
  Insert(New(PButton, Init(R, 'Lsche Ob', cmLoescheObjekt, bfNormal)));

  R.AssignText(2,25,13,27);
  RenObjButton := New(PButton, Init(R, '~N~ame', cmRenObj, bfNormal));
  Insert(RenObjButton);

  Inc(R.A.X,12*8); Inc(R.B.X,12*8);
  Insert(New(PButton, Init(R, 'Kopie Gr', cmKopieGruppe, bfNormal)));

  
  Inc(R.A.X,12*8); Inc(R.B.X,12*8);
  Insert(New(PButton, Init(R, 'Ver Gr', cmMoveGruppe, bfNormal)));

  Inc(R.A.X,12*8); Inc(R.B.X,12*8);
  Insert(New(PButton, Init(R, 'Lsche Gr', cmLoescheGruppe, bfNormal)));

  Inc(R.A.X,12*8); Inc(R.B.X,12*8);
  Insert(New(PButton, Init(R, 'Neue Gr', cmNeueGruppe, bfNormal)));
end;


procedure TBlockDialog.HandleEvent(var Event: TEvent);
var myevent:boolean;

  procedure KopiereGruppen;
  var a,b:P3DGroup;
  begin
    a:=SelectViewA^.GetAktGroup;
    if a<>nil then begin
      b:=SelectViewB^.GetAktGroup;
      if b<>nil then begin
        b^.szene^.gesichert:=false;
        a:=a^.KopierDich(b^.Szene);
        a^.state:=a^.state and not sfvisible;
        a^.options:=a^.options and not ofselectable;
        b^.insert(a);
        {a^.state:=a^.state or sfvisible;}
        a^.options:=a^.options or ofselectable;
        Message(@self,evBroadCast,cmGruppenBaumneuanzeigen,nil);
      end;
    end;
  end;

  procedure KopiereObject;
  var a:P3DView;
      b:P3DGroup;
  begin
    a:=SelectViewA^.GetAktView;
    if a<>nil then begin
      b:=SelectViewB^.GetAktGroup;
      if b<>nil then begin
        b^.szene^.gesichert:=false;
        a:=a^.KopierDich(b^.Szene);
        a^.state:=a^.state and not sfvisible;
        a^.options:=a^.options and not ofselectable;
        b^.insert(a);
        a^.state:=a^.state or sfvisible;
        a^.options:=a^.options or ofselectable;
        Message(@Self, evBroadcast, cmVerzeichnisneuanzeigen, b);
      end;
    end;
  end;

  procedure VerschiebeGruppen;
  var a,b:P3DGroup;
  begin
    a:=SelectViewA^.GetAktGroup;
    if (a<>nil) and (TypeOf(a^)<>TypeOf(TRoot)) then begin
      b:=SelectViewB^.GetAktGroup;
      if (b<>nil) and (message(a,evcommand,cmTestIsMySubGroup,b)=nil) then begin
        a^.szene^.gesichert:=false;
        b^.szene^.gesichert:=false;
        a^.state:=a^.state and not sfvisible;
        a^.options:=a^.options and not ofselectable;
        a^.owner^.current:=a^.owner^.current^.next;
        if a^.owner^.current=PView(a) then a^.owner^.current:=nil;
        a^.owner^.delete(a);
        b^.insert(a);
        {a^.state:=a^.state or sfvisible;}
        a^.options:=a^.options or ofselectable;
        Message(@Self,evBroadCast,cmGruppenBaumneuanzeigen,nil);
      end;
    end;
  end;

  procedure VerschiebeObject;
  var a:P3DView;
      b:P3DGroup;
  begin
    a:=SelectViewA^.GetAktView;
    if a<>nil then begin
      b:=SelectViewB^.GetAktGroup;
      if b<>nil then begin
        a^.szene^.gesichert:=false;
        b^.szene^.gesichert:=false;
        a^.state:=a^.state and not sfvisible;
        a^.options:=a^.options and not ofselectable;
        a^.owner^.current:=a^.owner^.current^.next;
        if a^.owner^.current=PView(a) then a^.owner^.current:=nil;
        a^.owner^.delete(a);
        b^.insert(a);
        a^.state:=a^.state or sfvisible;
        a^.options:=a^.options or ofselectable;
        Message(SelectViewB,evBroadCast,cmVerzeichnisneuanzeigen,b);
        Message(SelectViewA,evBroadCast,cmVerzeichnisneuanzeigen,SelectViewA^.GetAktGroup);
      end;
    end;
  end;

begin
  TDialog.HandleEvent(Event);
  case event.what of
  evBroadCast:if (event.command=cm3DLineActive) then begin
      RenObjButton^.makedefault(true);
    end;
  evcommand:begin
      myevent:=true;
      case event.command of
        cmNeueGruppe:SelectViewA^.NeueGruppe;
        cmLoescheGruppe:SelectViewA^.LoescheGruppe;
        cmLoescheObjekt:SelectViewA^.LoescheObjekt;
        cmKopieGruppe:KopiereGruppen;
        cmKopieObjekt:KopiereObject;
        cmMoveGruppe:VerschiebeGruppen;
        cmMoveObjekt:VerschiebeObject;
      else myevent:=false;
      end;
      if myevent then clearevent(event);
    end;
  end;
end;

function TBlockDialog.DataSize: Word;
begin
  DataSize := sizeof(pointer);
end;

procedure TBlockDialog.GetData(var Rec);
begin
  move(momszene,rec,sizeof(pointer));
end;

procedure TBlockDialog.SetData(var Rec);
begin
end;

function TBlockDialog.Valid(Command: Word):Boolean;
var v:P3DView;
    g:P3DGroup;
    s:Pszene;
begin
  valid:=true;
  if command<>cmvalid then begin
    v:=SelectViewA^.GetAktView;
    if (v=nil) or (v^.szene=nil) then begin
      g:=SelectViewA^.GetAktGroup;
      if (g=nil) or (G^.Szene=nil) then begin
        s:=SelectViewA^.GetAktSzene;
        if s<>nil
        then begin
          s^.setobjekt(nil);
          momszene:=s;
        end else valid:=false;
      end else begin
        momszene:=PSzene(g^.szene);
        g^.szene^.setobjekt(g);
      end;
    end else begin
      momszene:=PSzene(v^.szene);
      v^.szene^.setobjekt(v);
    end;
  end;
end;

end.