unit UOBJLIST;
interface

uses Objects, TGDriver, TGViews, TGDialog;
const cmChangeObj=1804;
type
  ObjStr=string[67];
  { TObjEntry }

  PObjEntry = ^TObjEntry;
  TObjEntry = record
    DisplayText: PString;
    Obj: PObject;
  end;

  { TObjCollection is a collection of TObjEntry's used by       }
  { TObjListBox.                                                }

  PObjCollection = ^TObjCollection;
  TObjCollection = object(TCollection)
    procedure FreeItem(Item: Pointer); virtual;
  end;

  { TObjListBox displays a tree of Objectories for use in the }
  { TChObjDialog.                                               }

  PObjListBox = ^TObjListBox;
  TObjListBox = object(TListBox)
    Obj: PObject;
    Cur: Word;
    constructor Init(var Bounds: TRect; AScrollBar: PScrollBar);
    destructor Done; virtual;
    function GetText(Item: Integer; MaxLen: Integer): String; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    function IsSelected(Item: Integer): Boolean; virtual;
    procedure NewObjectory(AObj: PObject);

    procedure GetSzene(var hobj,szene:PObject;var s:ObjStr); virtual;
    function getcurszene:pobject; virtual;

    function GetPfad(Aobj:PObject):ObjStr; virtual;
    procedure GetOwner(var Aobj:Pobject); virtual;

    procedure FindSubGroup(var hObj,Aobj:PObject;var s:objstr); virtual;
  end;


implementation

{ TObjCollection }

procedure TObjCollection.FreeItem(Item: Pointer);
var
  ObjItem: PObjEntry absolute Item;
begin
  DisposeStr(ObjItem^.DisplayText);
  Dispose(ObjItem);
end;

{ TObjListBox }

const
  SzenenS: String[6] = 'Szenen';
  Szenen: PString = @SzenenS;

constructor TObjListBox.Init(var Bounds: TRect; AScrollBar:
  PScrollBar);
begin
  TListBox.Init(Bounds, 1, AScrollBar);
  Obj := nil;
end;

destructor TObjListBox.Done;
begin
  if List <> nil then Dispose(List, Done);
  TListBox.Done;
end;

function TObjListBox.GetText(Item: Integer; MaxLen: Integer): String;
begin
  if (list=nil) or (item>=list^.count) or (item<0) then Gettext:='' else GetText := PObjEntry(List^.At(Item))^.DisplayText^;
end;

procedure TObjListBox.HandleEvent(var Event: TEvent);
begin
  if (Event.What and evMouseDown>0) then begin
    Event.double:=false;
    TListBox.Handleevent(Event);
    Event.What := evCommand;
    Event.Command := cmChangeObj;
    Event.InfoPtr:=@self;
    PutEvent(Event);
    ClearEvent(Event);
  end
  else TListBox.HandleEvent(Event);
end;

function TObjListBox.IsSelected(Item: Integer): Boolean;
begin
  IsSelected := Item = Cur;
end;

procedure TObjListBox.NewObjectory(AObj: PObject);
const
  PathObj            = '';
  FirstObj           =   '';
  MiddleObj          =   ' ';
  LastObj            =   ' ';
  IndentSize         = '  ';
var
  AList: PCollection;
  path: ObjStr;
  Objct:PObject;
  c, OldC: ObjStr;
  S, Indent: String[80];
  P: PString;
  isFirst: Boolean;
  hobj,szene,oldszene,curszene:PObject;
  h,i,n,bs:byte;

function NewObjEntry(DisplayText:String; AObj: PObject): PObjEntry; near;
var
  ObjEntry: PObjEntry;
begin
  New(ObjEntry);
  ObjEntry^.DisplayText := NewStr(DisplayText);
  ObjEntry^.Obj := AObj;
  NewObjEntry := ObjEntry;
end;

procedure InsertList(entry:PObjEntry);
begin
  if AList^.count<=1 then AList^. Insert(entry)
  else AList^. AtInsert(1,entry);
end;

function countbackslash(path:objstr):byte;
var n:byte;
begin
  n:=0;
  while pos('\',path)<>0 do begin
    inc(n);
    delete(path,1,pos('\',path));
  end;
  countBackSlash:=n;
end;

begin
  Obj := AObj;
  AList := New(PObjCollection, Init(5,5));
  AList^.Insert(NewObjEntry(Szenen^,nil));
  if Obj = nil then {Nil bedeutet hier, dass Szenen angezeigt werden sollen}
  begin
    isFirst := True;
    hobj:=nil;
    getszene(hobj,szene,c);
    OldC := ' ';
    OldSzene:=nil;
    curSzene:=GetCurSzene;
    cur:=1;
    while szene<>nil do begin
      if OldSzene <> nil then begin
        if isFirst then begin
          S := FirstObj + OldC;
          isFirst := False;
        end else S := MiddleObj + OldC;
	AList^.Insert(NewObjEntry(S, OldSzene));
      end;
      if szene = CurSzene then Cur := AList^.Count;
      OldC := C;
      OldSzene:=Szene;
      getszene(hobj,szene,c);
    end;
    if OldC <> ' ' then AList^.Insert(NewObjEntry(LastObj + OldC, OldSzene));
  end else begin   {ein normaler Verzeichnisbaum wird angezeigt}
    Objct := Obj;
    path:=GetPfad(obj);{Der Pfad darf kein Backslash am Anfang oder Ende haben. Die Root ist durch einen : gekennzeichnet}
    bs:=countbackslash(path);
    fillchar(indent[1],succ(bs)*2,' ');
    indent[0]:=char(bs*2);
    for n:=1 to bs do begin
      i:=0;
      repeat
        h:=pos('\',copy(path,succ(i),255));
        inc(i,h);
      until h=0;   {endlosschleife}
      s:=copy(path,succ(i),255);
      path[0]:=char(pred(i));
      InsertList(NewObjEntry(Indent + PathObj + S, Objct));
      dec(indent[0],2);
      GetOwner(Objct);
    end;
    path:=path+'\';
    InsertList(NewObjEntry(PathObj + path, Objct)); {Root (z.B. FIGUR:\)}
    Cur := AList^.Count-1;
    indent[0]:=char(succ(bs)*2);
    isFirst := True;
    hobj:=nil;
    Objct := Obj;
    FindSubGroup(hobj,objct,c);
    while objct<>nil do
    begin
      if isFirst then
      begin
	S := FirstObj;
	isFirst := False;
      end else S := MiddleObj;
      AList^.Insert(NewObjEntry(Indent + S + c, Objct));
      FindSubGroup(hobj,objct,c);
    end;
    P := PObjEntry(AList^.At(AList^.Count-1))^.DisplayText;
    I := Pos('',P^);
    if I = 0 then
    begin
      I := Pos('',P^);
      if I <> 0 then P^[I] := '';
    end else
    begin                 {es gab kein middleobject}
      P^[I+1] := '';
      P^[I+2] := '';
    end;
  end;
  NewList(AList);
  FocusItem(Cur);
end;

procedure TObjListBox.GetSzene(var hobj,szene:PObject;var s:ObjStr);
begin
end;

function TObjListBox.getcurszene:pobject;
begin
  abstract;
end;

function TObjListBox.GetPfad(Aobj:PObject):ObjStr;
begin
  abstract;
end;

procedure TObjListBox.GetOwner(var Aobj:Pobject);
begin
end;

procedure TObjListBox.FindSubGroup(var hObj,Aobj:PObject;var s:objstr);
begin
end;

end.
