unit UUtils;
interface
Uses Objects,Drivers,TGDriver,matrizen,TGDialog,TGViews,TGApp,WizView;
const cm3DLineActive=913;
const gleichezeileweiter:boolean=false;
var befehl,argumente:string;
    f:text;
    zeile:word;
    varsingle:array[65..90] of single;
    varint:array[65..90] of integer;

type PMesh=^TMesh;
     TMesh=object(TObject)
       x,y:byte;
       Points:Pointer;
       Erzeuger:word;
       Nutzer:word;
       constructor init(ax,ay:byte);
       destructor done; virtual;
       function PointAt(ax,ay:byte):P3DPoint;
       procedure putin(ax,ay:byte;var p:T3dPoint);
       procedure changeSize(ax,ay:byte);
       procedure IncNutzer;
       procedure kopiere(original:pmesh);
       procedure ebene;
     end;

     PPoint=^TPoint;

     P2DLine=^T2DLine;
     T2DLine=object(TObject)
       x:byte;
       Points:Pointer;
       constructor init(ax:byte);
       destructor done; virtual;
       function PointAt(ax:byte):PPoint;
       procedure putin(ax:byte;var p:T3dPoint);
     end;

function notzahl(r:single;a:byte):boolean;
function notzahlvct(v:T3dPoint;a:byte):boolean;
procedure upword(var tex:string);
Function berechne(f:string;x,y:single;var error:Integer):single;
function id(bef,s:string):boolean;
function gleich(bef,s:string):boolean;
procedure deltext;
procedure delarg(n:byte);
function getstring(n:byte):string;
function notleer(var s:string):boolean;
procedure lesezeile;
procedure delspace(var s:string);
function zahl(h:PDialog;s:string;x,ho:word;a,b:byte;min,max:single;Typ:Byte):Pinputzahl;
function upwordf(s:string):string;
function PunkteGleich(genau:single;a,b:T3DPoint):boolean;

implementation

{ TMesh }

constructor TMesh.init(ax,ay:byte);
{initialisiert mesh mit Punkten von x=0..ax und y=0..ay}
begin
  x:=ax;
  y:=ay;
  erzeuger:=0;
  nutzer:=0;
  if maxavail>succ(x)*succ(y)*sizeof(T3dPoint) then begin
    getmem(points,succ(x)*succ(y)*sizeof(T3dPoint));
    ebene;
  end else points:=nil;
end;

procedure TMesh.Ebene;
var p:T3DPoint;
    dx,dy:byte;
    xdist,ydist:real;
begin
  xdist:=2 / x;
  ydist:=2 / y;
  p.z:=0;
  p.x:=-1;
  for dx:=0 to x do begin
    p.y:=-1;
    for dy:=0 to y do begin
      putin(dx,dy,p);
      p.y:=p.y+ydist;
    end;
    p.x:=p.x+xdist;
  end;
end;

destructor TMesh.done;
begin
  if points<>nil then freemem(points,succ(x)*succ(y)*sizeof(T3dPoint));
end;

procedure TMesh.changeSize(ax,ay:byte);
begin
  if points<>nil then freemem(points,succ(x)*succ(y)*sizeof(T3dPoint));
  x:=ax;
  y:=ay;
  if maxavail>succ(x)*succ(y)*sizeof(T3dPoint) then begin
    getmem(points,succ(x)*succ(y)*sizeof(T3dPoint));
    ebene;
  end else begin
    points:=nil;
    Application^.OutOfMemory;
  end;
end;

function TMesh.PointAt(ax,ay:byte):P3DPoint;
begin
  PointAt:=P3DPoint(@meml[seg(points^):
                          ofs(points^)+(ay*succ(x)+ax)*sizeof(T3dPoint)]);
end;

procedure TMesh.putin(ax,ay:byte;var p:T3dPoint);
begin
  if (ax<=x) and (ay<=y) then begin
    pointat(ax,ay)^:=p;
  end;
end;

procedure TMesh.IncNutzer;
begin
  inc(Nutzer);
end;

procedure TMesh.kopiere(original:pmesh);
begin
  if (x=original^.x) and (y=original^.y) and (Points<>nil)
  then move(original^.points^,points^,succ(x)*succ(y)*sizeof(T3dPoint));
end;

{ T2DLine }

constructor T2DLine.init(ax:byte);
{initialisiert 2DLine mit Punkten von x=0..ax
 Dieses 2DLine wird gebraucht um eine Zeile eines Transformierten Meshs
 zwischenzuspeichern dies beschleunigt die Bildschirmausgabe}
begin
  x:=ax;
  if maxavail>succ(x)*sizeof(TPoint) then begin
   getmem(points,succ(x)*sizeof(TPoint));
   fillchar(points^,succ(x)*sizeof(TPoint),#0);
  end else begin
    Application^.OutOfMemory;
    points:=nil;
  end;
end;

destructor T2DLine.done;
begin
  if points<>nil then freemem(points,succ(x)*sizeof(TPoint));
end;

function T2DLine.PointAt(ax:byte):PPoint;
begin
  PointAt:=PPoint(@meml[seg(points^):
                          ofs(points^)+ax*sizeof(TPoint)]);
end;

procedure T2DLine.putin(ax:byte;var p:T3DPoint);
var HPoint:PPoint;
begin
  if (ax<=x) then begin
    HPoint:=Pointat(ax);
    hpoint^.x:=round(p.x);
    hpoint^.y:=round(p.y);
  end;
end;

function notzahl(r:single;a:byte):boolean;
begin
  notzahl:=round(r*100)<>a;
end;

function notzahlvct(v:T3dPoint;a:byte):boolean;
begin
  notzahlvct:=notzahl(v.x,a) or notzahl(v.y,a) or notzahl(v.z,a);
end;

procedure upword(var tex:string);
var n:byte;
begin
  for n:=1 to length(tex) do begin
    tex[n]:=upcase(tex[n]);
    case tex[n] of
      '':tex[n]:='';
      '':tex[n]:='';
      '':tex[n]:='';
    end;
  end;
end;


Function berechne(f:string;x,y:single;var error:Integer):single;
const klammer=true;
      glied=false;
      maxsingle=3.4e38;
      plus=0;
      minus=1;
      geteilt=2;
      mal=3;
      nichts=4;
var hilfb,aktpos:byte;
    err2,err:integer;
    hilf:single;
    funkt:string[6];
    modus:boolean;

  Function rechne(sinn:boolean;var error:Integer):single;
  var z,stapel:single;
      vorprodukt,vorganger:byte;
  begin
    error:=0;
    while (pos(' ',f)=aktpos) and (aktpos<=length(f)) do inc(aktpos);
    if aktpos>length(f) then begin
      error:=aktpos;
      rechne:=0;
      exit;
    end;
    if ((f[aktpos]='[') or (f[aktpos]='{') or (f[aktpos]='(')) then begin
      inc(aktpos);
      z:=rechne(klammer,error);
      if error<>0 then exit;
    end else begin
      funkt:='';
      while (f[aktpos]>='A') and (f[aktpos]<='Z') do begin
        funkt:=funkt+f[aktpos];
        inc(aktpos);
      end;
      if length(funkt)<>0 then begin
        if funkt='Y' then z:=y else
        if funkt='X' then z:=x else
        if funkt='E' then z:=2.718281829 else
        if funkt='PI' then z:=pi else
        if funkt='RND' then z:=random else
        if funkt='LN' then begin
          inc(aktpos);
          hilf:=rechne(klammer,error);
          if hilf<=0 then begin
            error:=aktpos;
            rechne:=0;
            exit;
          end;
          z:=ln(hilf);
        end else if funkt='EXP' then begin
          inc(aktpos);
          z:=exp(rechne(klammer,error));
        end else if funkt='SIN' then begin
          inc(aktpos);
          z:=sin(rechne(klammer,error));
        end else if funkt='COS' then begin
          inc(aktpos);
          z:=cos(rechne(klammer,error));
        end else if funkt='TAN' then begin
          inc(aktpos);
          hilf:=rechne(klammer,error);
          z:=sin(hilf);
          hilf:=cos(hilf);
          if hilf<>0 then z:=z/hilf else z:=maxsingle;
        end else if funkt='COT' then begin
          inc(aktpos);
          hilf:=rechne(klammer,error);
          z:=cos(hilf);
          hilf:=sin(hilf);
          if hilf<>0 then z:=z/hilf else z:=maxsingle;
        end else if funkt='ABS' then begin
          inc(aktpos);
          z:=abs(rechne(klammer,error));
        end else if funkt='SGN' then begin
          inc(aktpos);
          hilf:=rechne(klammer,error);
          if hilf<0 then z:=-1 else if z>0 then z:=1 else z:=0;
        end else if funkt='SQR' then begin
          inc(aktpos);
          z:=sqr(rechne(klammer,error));
        end else if funkt='SQRT' then begin
          inc(aktpos);
          hilf:=rechne(klammer,error);
          if hilf<0 then begin
            error:=aktpos;
            rechne:=0;
            exit;
          end;
          z:=sqrt(hilf);
        end else if funkt='FRAC' then begin
          inc(aktpos);
          z:=frac(rechne(klammer,error));
        end else if funkt='TRUNC' then begin
          inc(aktpos);
          z:=trunc(rechne(klammer,error));
        end else if funkt='ROUND' then begin
          inc(aktpos);
          z:=round(rechne(klammer,error));
        end else if funkt='ARCTAN' then begin
          inc(aktpos);
          z:=arctan(rechne(klammer,error));
        end else begin
          error:=aktpos;
          rechne:=0;
          exit;
        end;
        if error<>0 then exit;
      end else begin
        system.val(copy(f,aktpos,length(f)-pred(aktpos)),z,err);
        if err=1 then begin
          error:=aktpos;
          rechne:=0;
          exit;
        end;
        if err=0 then aktpos:=length(f) else begin
          system.val(copy(f,aktpos,pred(err)),z,err2);
          aktpos:=aktpos+pred(err);
        end;
      end;
    end;
    if sinn=klammer then begin
      vorganger:=nichts; stapel:=0;
      while ((f[aktpos]<>']') and (f[aktpos]<>'}') and
             (f[aktpos]<>')') and (aktpos<length(f))) do begin
        hilfb:=aktpos;
        inc(aktpos);
        if ((f[aktpos]='[') or (f[aktpos]='{') or (f[aktpos]='(')) then begin
          inc(aktpos);
          modus:=klammer;
        end else modus:=glied;
        case f[hilfb] of
          '+':begin
                case vorganger of
                  plus,nichts: begin
                    z:=z+stapel;
                    stapel:=rechne(modus,error);
                  end;
                  minus: begin
                    z:=z-stapel;
                    stapel:=rechne(modus,error);
                  end;
                  mal,geteilt:
                  case vorprodukt of
                    plus: begin z:=z+stapel; stapel:=rechne(modus,error); end;
                    minus: begin z:=z-stapel; stapel:=rechne(modus,error); end;
                    nichts: begin z:=stapel; stapel:=rechne(modus,error); end;
                  end;
                end;
                
                vorganger:=plus;
              end;
          '-':begin
                case vorganger of
                  plus,nichts: begin z:=z+stapel; stapel:=rechne(modus,error); end;
                  minus: begin z:=z-stapel; stapel:=rechne(modus,error); end;
                  mal,geteilt: case vorprodukt of
                    plus: begin z:=z+stapel; stapel:=rechne(modus,error); end;
                    minus: begin z:=z-stapel; stapel:=rechne(modus,error); end;
                    nichts: begin z:=stapel; stapel:=rechne(modus,error); end;
                  end;
                end;
                vorganger:=minus;
              end;
          '/':begin
                hilf:=rechne(modus,error);
                if vorganger=nichts then stapel:=z;
                if (vorganger=minus) or (vorganger=plus) or
                   (vorganger=nichts) then vorprodukt:=vorganger;
                if hilf<>0 then stapel:=stapel/hilf else stapel:=maxsingle;
                vorganger:=geteilt;
              end;
          '*':begin
                if vorganger=nichts then stapel:=z;
                if (vorganger=minus) or (vorganger=plus) or
                   (vorganger=nichts) then vorprodukt:=vorganger;
                stapel:=stapel*rechne(modus,error);
                vorganger:=mal;
              end;
          else begin
            error:=aktpos;
            rechne:=0;
            exit;
          end;
          if error<>0 then exit;
        end;
      end;
      case vorganger of
        plus:   z:=z+stapel;
        minus:  z:=z-stapel;
        geteilt,mal:case vorprodukt of
              plus:  z:=z+stapel;
              minus: z:=z-stapel;
              nichts:z:=stapel;
            end;
      end;
      inc(aktpos);
    end;
    rechne:=z;
  end;

begin
  error:=0;
  upword(f);
  aktpos:=1;
  berechne:=rechne(klammer,error);
end;

function id(bef,s:string):boolean;
var gleich:boolean;
    n,k:byte;
begin
  gleich:=true;
  while (' '=bef[length(bef)]) do system.delete(bef,length(bef),1);
  K:=length(bef);
  if k=0 then k:=1;
  n:=length(s);
  if n<k then k:=n;
  n:=1;
  repeat
    bef[n]:=upcase(bef[n]);
    case bef[n] of
      '':bef[n]:='';
      '':bef[n]:='';
      '':bef[n]:='';
    end;
    gleich:=gleich and (s[n]=bef[n]);
    inc(n);
  until (not gleich) or (n>k);
  id:=gleich;
end;

function gleich(bef,s:string):boolean;
var glei:boolean;
    n,k:byte;
begin
  glei:=true;
  delspace(bef);
  delspace(s);
  K:=length(bef);
  n:=length(s);
  if n<>k then begin
    gleich:=false;
    exit;
  end;
  n:=1;
  repeat
    bef[n]:=upcase(bef[n]);
    case bef[n] of
      '':bef[n]:='';
      '':bef[n]:='';
      '':bef[n]:='';
    end;
    s[n]:=upcase(s[n]);
    case s[n] of
      '':s[n]:='';
      '':s[n]:='';
      '':s[n]:='';
    end;
    glei:=glei and (s[n]=bef[n]);
    inc(n);
  until (not glei) or (n>k);
  gleich:=glei;
end;

procedure deltext;
var s:byte;
begin
  s:=pos('"',argumente);
  if s<>0 then begin
    delete(argumente,1,s);
    s:=pos('"',argumente);
    if s<>0 then delete(argumente,1,s) {else zeilenerror('Kein 2. "');}
  end {else zeilenerror('Kein "');}
end;

procedure delarg(n:byte);
var z:byte;
begin
  z:=0;
  argumente:=argumente+' ';
  repeat
    while ' '=argumente[1] do system.delete(argumente,1,1);
    if (length(argumente)>0) then system.delete(argumente,1,pos(' ',argumente));
    inc(z);
  until (z=n) or (length(argumente)=0);
end;

function getstring(n:byte):string;
var buf:string;
begin
  argumente:=argumente+' ';
  while ' '=argumente[1] do system.delete(argumente,1,1);
  if (length(argumente)>0) then begin
    buf:=copy(argumente,1,pred(pos(' ',argumente)));
    system.delete(argumente,1,pos(' ',argumente));
  end else buf:='';
  getstring:=copy(buf,1,n);
end;

function notleer(var s:string):boolean;
begin
  while pos(' ',s)=1 do system.delete(s,1,1);
  notleer:=length(s)<>0;
end;

procedure lesezeile;
begin
  if notleer(argumente) then befehl:=argumente else begin
    readln(f,befehl);
    inc(zeile);
  end;
  while pos(' ',befehl)=1 do system.delete(befehl,1,1);
  argumente:=befehl;
  argumente:=argumente+' ';
  system.delete(argumente,1,pos(' ',argumente));
  befehl:=befehl+' ';
  system.delete(befehl,pos(' ',befehl),length(befehl)-pos(' ',befehl));
end;


procedure delspace(var s:string);
begin
  while pos(' ',s)<>0 do system.delete(s,pos(' ',s),1);
end;

function zahl(h:PDialog;s:string;x,ho:word;a,b:byte;min,max:single;Typ:Byte):Pinputzahl;
var hzahl:PInputZahl;
    r:Trect;
begin
  with h^ do begin
    r.assign(x+succ(CStrlen(s))*8,ho,x+60+succ(cstrlen(s))*8,ho+14);
    hzahl:=new(PInputZahl,init(r,typ,a,b,min,max));
    insert(hzahl);
    r.assign(x,ho+3,x+succ(cstrlen(s))*8,ho+17);
    insert(new(PLabel,init(r,s,hzahl)));
  end;
  zahl:=hzahl;
end;

function upwordf(s:string):string;
var h:string;
    n:byte;
begin
  h:='';
  for n:=1 to length(s) do h:=h+upcase(s[n]);
  upwordf:=h;
end;

function PunkteGleich(genau:single;a,b:T3DPoint):boolean;
begin
  punktegleich:=(abs(a.x-b.x)<genau) and
                (abs(a.y-b.y)<genau) and
                (abs(a.z-b.z)<genau);
end;

end.